using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

/// <summary>
/// Class with blog comment data
/// </summary>
public class BlogCommentDetail : System.Web.UI.UserControl
{
    protected int mCommentID = 0;
    protected DataRow mCommentsDataRow = null;
    protected bool mShowEditButton = false;
    protected bool mShowDeleteButton = false;
    protected bool mShowApproveButton = false;
    protected bool mShowRejectButton = false;

    public BlogProperties BlogpPoperties = new BlogProperties();
    public event OnCommentActionEventHandler OnCommentAction;

    #region " Public properties"


    /// <summary>
    ///Comment ID.
    /// </summary>
    public int CommentID
    {
        get
        {
            return mCommentID;
        }
        set
        {
            mCommentID = value;
        }
    }


    /// <summary>
    /// DataRow with comments data.
    /// </summary>
    public DataRow CommentsDataRow
    {
        get
        {
            return mCommentsDataRow;
        }
        set
        {
            mCommentsDataRow = value;
        }
    }

    /// <summary>
    /// Indicates whether 'edit' button should be displayed.
    /// </summary>
    public bool ShowEditButton
    {
        get
        {
            return mShowEditButton;
        }
        set
        {
            mShowEditButton = value;
        }
    }


    /// <summary>
    /// Indicates whether 'delete' button should be displayed.
    /// </summary>
    public bool ShowDeleteButton
    {
        get
        {
            return mShowDeleteButton;
        }
        set
        {
            mShowDeleteButton = value;
        }
    }


    /// <summary>
    /// Indicates whether 'approve' button should be displayed.
    /// </summary>
    public bool ShowApproveButton
    {
        get
        {
            return mShowApproveButton;
        }
        set
        {
            mShowApproveButton = value;
        }
    }


    /// <summary>
    /// Indicates whether 'reject' button should be displayed.
    /// </summary>
    public bool ShowRejectButton
    {
        get
        {
            return mShowRejectButton;
        }
        set
        {
            mShowRejectButton = value;
        }
    }


    #endregion


    protected void FireOnCommentAction(string actionName, object actionArgument)
    {
        OnCommentAction(actionName, actionArgument);
    }

}
