<%@ Control Language="C#" AutoEventWireup="true" CodeFile="EditForm.ascx.cs" Inherits="CMSAdminControls_UserContributions_EditForm" %>
<%@ Register Src="~/CMSDesk/Content/editmenu.ascx" TagName="editmenu" TagPrefix="uc1" %>
<%@ Register Src="~/CMSAdminControls/pagetitle.ascx" TagName="pagetitle" TagPrefix="uc1" %>
<%@ Register Assembly="CMS.Controls" Namespace="CMS.Controls" TagPrefix="cc1" %>
<%@ Register Assembly="CMS.FormEngine" Namespace="CMS.FormEngine" TagPrefix="cc1" %>
<asp:Panel runat="server" ID="pnlForm" SkinID="EditForm">
    <asp:Panel runat="server" ID="pnlTitle" SkinID="PageHeader">
        <uc1:pagetitle ID="titleElem" runat="server" />
    </asp:Panel>
    <asp:Panel runat="server" ID="pnlSelectClass" SkinID="PageContent">
        <b>
            <asp:Label ID="lblInfo" runat="server" SkinID="ContentLabel" EnableViewState="false" /></b><br />
        <asp:Label ID="lblError" runat="server" SkinID="ContentError" ForeColor="Red" EnableViewState="false" />
        <br />
        <asp:GridView runat="server" ID="gridClasses" AutoGenerateColumns="false" ShowHeader="false"
            SkinID="ContentNewClasses" GridLines="None">
            <Columns>
                <asp:TemplateField>
                    <ItemTemplate>
                        <asp:LinkButton runat="server" ID="lnkItem" CommandArgument='<%# DataBinder.Eval(Container.DataItem, "ClassID") %>'
                            SkinID="ContentNewClass" OnCommand="btnClass_Command">
                            <asp:Image ID="imgIcon" runat="server" ImageUrl='<%# "~/App_Themes/Default/Images/CMSDesk/Icons/" + Convert.ToString(DataBinder.Eval(Container.DataItem, "ClassName")).Replace(".", "_") + ".gif" %>' />
                            <%# DataBinder.Eval(Container.DataItem, "ClassDisplayName") %>
                        </asp:LinkButton>
                    </ItemTemplate>
                </asp:TemplateField>
            </Columns>
        </asp:GridView>
    </asp:Panel>
    <asp:Panel runat="server" ID="pnlNewCulture" SkinID="PageContent">
        <b>
            <asp:Label ID="lblNewCultureInfo" runat="server" SkinID="ContentLabel"></asp:Label></b><br />
        <br />
        <table>
            <tr>
                <td>
                    <asp:RadioButton ID="radEmpty" runat="server" GroupName="NewVersion" Checked="true" />
                </td>
            </tr>
            <tr>
                <td>
                    <asp:RadioButton ID="radCopy" runat="server" GroupName="NewVersion" />
                </td>
            </tr>
            <tr id="divCultures" style="<%= (this.radCopy.Checked ?  "display: block;": "display: none;") %>"">
                <td>
                    <asp:Panel runat="server" ID="pnlCultures" SkinID="softselectionborder">
                        <asp:ListBox runat="server" ID="lstCultures" DataTextField="DocumentCulture" DataValueField="DocumentID"
                            SkinID="ContentListBoxLow" />
                    </asp:Panel>
                </td>
            </tr>
            <tr>
                <td>
                    &nbsp;
                </td>
            </tr>
            <tr>
                <td>
                    <asp:Button ID="btnOK" runat="server" OnClick="btnOK_Click" />
                </td>
            </tr>
        </table>
    </asp:Panel>
    <asp:Panel runat="server" ID="pnlEdit">
        <asp:Panel runat="server" ID="pnlMenu" SkinID="ContentEditMenu">
            <uc1:editmenu ID="menuElem" runat="server" ShowProperties="false" RenderScript="false"
                ShowDelete="true" ShowSpellCheck="true" />
        </asp:Panel>
        <asp:PlaceHolder runat="server" ID="plcSaveChanges" EnableViewState="false" Visible="false">
            <input type="hidden" name="saveChanges" id="saveChanges" value="0" />

            <script type="text/javascript" language="javascript" src="<%= ResolveUrl("~/CMSAdminControls/SaveChanges/savechanges.js") %>"></script>

        </asp:PlaceHolder>

        <script language="javascript" src="<%= ResolveUrl("~/CMSAdminControls/SpellChecker/spell.js") %>"
            type="text/javascript"></script>

        <script type="text/javascript" language="javascript"> 
        <!--
            // Spell check
            function SpellCheck()
            {
                checkSpelling();
            }
        -->
        </script>

        <div id="FCKToolbarUC">
        </div>
        <asp:Panel runat="server" ID="pnlWorkflowInfo" SkinID="PageManagerWorkflowInfo">
            <asp:Label ID="lblWorkflowInfo" runat="server" SkinID="WorkflowInfo" EnableViewState="false" />
        </asp:Panel>
        <asp:Panel runat="server" ID="pnlContent" SkinID="PageContent">
            <cc1:CMSForm runat="server" ID="formElem" Visible="false" CssClass="UserContributionForm"  HtmlAreaToolbarLocation="Out:FCKToolbarUC"
                ShowOkButton="false" />
        </asp:Panel>
        <asp:Button ID="btnSave" runat="server" OnClick="btnSave_Click" />
        <asp:Button ID="btnApprove" runat="server" EnableViewState="false" OnClick="btnApprove_Click" />
        <asp:Button ID="btnReject" runat="server" EnableViewState="false" OnClick="btnReject_Click" />
        <asp:Button ID="btnCheckIn" runat="server" EnableViewState="true" OnClick="btnCheckIn_Click" />
        <asp:Button ID="btnCheckOut" runat="server" EnableViewState="true" OnClick="btnCheckOut_Click" />
        <asp:Button ID="btnUndoCheckOut" runat="server" EnableViewState="true" OnClick="btnUndoCheckOut_Click" />
        <asp:Button ID="btnDelete" runat="server" EnableViewState="true" OnClick="btnDelete_Click" />
    </asp:Panel>
    <asp:Panel runat="server" ID="pnlDelete" SkinID="PageContent">
        <b>
            <asp:Label ID="lblQuestion" runat="server" SkinID="ContentLabel" EnableViewState="false" /></b><br />
        <asp:Label ID="lblDocuments" runat="server" SkinID="ContentLabel" EnableViewState="false" />
        <br />
        <asp:PlaceHolder ID="plcCheck" runat="server">
            <asp:CheckBox ID="chkDestroy" runat="server" SkinID="ContentCheckbox" /><br />
            <asp:CheckBox ID="chkAllCultures" runat="server" SkinID="ContentCheckbox" /><br />
            <br />
        </asp:PlaceHolder>
        <asp:Button ID="btnYes" runat="server" SkinID="ContentButton" OnClick="btnYes_Click" />
        <asp:Button ID="btnNo" runat="server" SkinID="ContentButton" OnClick="btnNo_Click" />
    </asp:Panel>
    <asp:Panel ID="pnlInfo" runat="server" SkinID="PageContent">
        <asp:Label ID="lblFormInfo" runat="server" EnableViewState="false" SkinID="ContentLabel" />
    </asp:Panel>
    <asp:Literal runat="server" ID="ltlScript" EnableViewState="false" /></asp:Panel>
