using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.Blogs;
using CMS.GlobalHelper;


public partial class CMSBlog_BlogCommentDetail : BlogCommentDetail
{ 

    protected void Page_Load(object sender, EventArgs e)
    {
        // Contorls initialization
        lnkApprove.Text = ResHelper.GetString("BlogCommentDetail.lnkApprove");
        lnkReject.Text = ResHelper.GetString("BlogCommentDetail.lnkReject");
        lnkEdit.Text = ResHelper.GetString("BlogCommentDetail.lnkEdit");
        lnkDelete.Text = ResHelper.GetString("BlogCommentDetail.lnkDelete");

        lnkEdit.Visible = this.ShowEditButton;
        lnkDelete.Visible = this.ShowDeleteButton;
        lnkApprove.Visible = this.ShowApproveButton;        
        lnkReject.Visible = this.ShowRejectButton;

        LoadData();

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "DeleteCommentConfirmation",  ScriptHelper.GetScript("function ConfirmDelete(){ return confirm('" + ResHelper.GetString("BlogCommentDetail.DeleteConfirmation") + "');}"));

    }

    /// <summary>
    /// Reload data
    /// </summary>
    public void LoadData()
    {

        if (this.mCommentsDataRow != null)
        {
            // Load comment data
            BlogCommentInfo bci = new BlogCommentInfo(this.mCommentsDataRow);
            if (bci != null)
            {
                this.CommentID = bci.CommentID;
                
                // Set user picture
                if (this.BlogpPoperties.EnableUserPictures)
                {
                    userPict.UserID = bci.CommentUserID;
                    userPict.Width = this.BlogpPoperties.UserPictureMaxWidth;
                    userPict.Height = this.BlogpPoperties.UserPictureMaxHeight;
                    userPict.Visible = true;
                }
                else
                {
                    userPict.Visible = false;                    
                }

                lnkName.Text = bci.CommentUserName;
                lnkName.NavigateUrl = bci.CommentUrl; 

                lblText.Text = bci.CommentText;
                lblDate.Text = bci.CommentDate.ToString();
                lnkEdit.OnClientClick = "EditComment('" + ResolveUrl("~/CMSBlog/Comment_Edit.aspx") + "?commentID=" + this.CommentID + "');return false;";
            }
        }
    }

    protected void lnkDelete_Click(object sender, EventArgs e)
    {
        FireOnCommentAction("delete", CommentID);
    }

    protected void lnkApprove_Click(object sender, EventArgs e)
    {
        FireOnCommentAction("approve", CommentID);
    }

    protected void lnkReject_Click(object sender, EventArgs e)
    {
        FireOnCommentAction("reject", CommentID);
    }
}
