using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class CMSDesk_MyDesk_MyBlogs_Comment_Edit : CMSDeskPage
{    

    protected void Page_Load(object sender, EventArgs e)
    {        
        ctrlCommentEdit.CommentId = ValidationHelper.GetInteger(Request.QueryString["commentID"], 0);
        ctrlCommentEdit.OnAfterCommentSaved += new OnAfterCommentSavedEventHandler(ctrlCommentEdit_OnAfterCommentSaved);
        ctrlCommentEdit.OnBeforeCommentSaved += new OnBeforeCommentSavedEventHandler(ctrlCommentEdit_OnBeforeCommentSaved);
        ctrlCommentEdit.OkButtonText = ResHelper.GetString("General.OK");

        titleElem.TitleText = ResHelper.GetString("Blog.CommentEdit.Title");
        titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/MyDesk/MyBlogs/comment.gif";
        
    }

    void ctrlCommentEdit_OnBeforeCommentSaved()
    {
        // check 'Manage' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.blog", "Manage"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.blog", "Manage");
        }
    }

    void ctrlCommentEdit_OnAfterCommentSaved(CMS.Blogs.BlogCommentInfo commentObj)
    {
        ltlScript.Text = ScriptHelper.GetScript("wopener.RefreshPage();window.close();");
    }
}
