using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.TreeEngine;
using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.SiteProvider;

public partial class CMSDesk_BreadCrumbs : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {

        // Current Node ID
        int nodeId = 0;
        if (Request.QueryString["nodeid"] != null)
        {
            nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);
        }
        // Get the node
        TreeProvider tree = new TreeProvider();
        CMS.TreeEngine.TreeNode node = tree.SelectSingleNode(nodeId);
        if (node != null)
        {
            string path = ValidationHelper.GetString(node.GetValue("DocumentNamePath"), node.NodeAliasPath).Trim('/');
            if (path == "")
            {
                SiteInfo si = SiteInfoProvider.GetSiteInfo(node.NodeSiteID);
                if (si != null)
                {
                    path = si.DisplayName;
                }
            }
            this.titleElem.CreateStaticBreadCrumbs( HttpUtility.HtmlEncode(path));
        }
    }

}
