using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.GlobalHelper;
using CMS.SiteProvider;

public partial class CMSDesk_Content_NewCultureVersion : CMSDeskPage
{

    protected void Page_Load(object sender, EventArgs e)
    {
        this.ltlScript.Text += ScriptHelper.GetScript(
            "var radCopyElem = document.getElementById('" + this.radCopy.ClientID + "');\n" +
                "var lstCulturesElem = document.getElementById('" + this.lstCultures.ClientID + "');\n"
            );

        this.titleElem.TitleText = ResHelper.GetString("Content.NewCultureVersionTitle") + " (" + CMSContext.CurrentUser.PreferredCultureCode + ")";
        this.titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/new.gif";

        this.lblInfo.Text = ResHelper.GetString("ContentNewCultureVersion.Info");
        this.radCopy.Text = ResHelper.GetString("ContentNewCultureVersion.Copy");
        this.radEmpty.Text = ResHelper.GetString("ContentNewCultureVersion.Empty");

        radCopy.Attributes.Add("onclick", "ShowSelection();");
        radEmpty.Attributes.Add("onclick", "ShowSelection()");

        this.btnOK.Text = ResHelper.GetString("ContentNewCultureVersion.Create");
        this.btnOK.Attributes.Add("onclick", "NewDocument(" + Request.QueryString["nodeid"] + "); return false;");

        // Current Node ID
        int nodeId = 0;
        if (Request.QueryString["nodeid"] != null)
        {
            nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);
        }

        if (nodeId > 0)
        {
            // Fill in the existing culture versions
            TreeProvider tree = new TreeProvider();
            CMS.TreeEngine.TreeNode node = tree.SelectSingleNode(nodeId, TreeProvider.ALL_CULTURES);
            if (node != null)
            {
                SiteInfo si = SiteInfoProvider.GetSiteInfo(node.NodeSiteID);
                if (si != null)
                {
                    DataSet nodes = tree.SelectNodes(si.SiteName, node.NodeAliasPath, TreeProvider.ALL_CULTURES, false, null, null, null, 1, false);
                    foreach (DataRow nodeCulture in nodes.Tables[0].Rows)
                    {
                        ListItem li = new ListItem();
                        li.Text = CultureInfoProvider.GetCultureInfo(nodeCulture["DocumentCulture"].ToString()).CultureName;
                        li.Value = nodeCulture["DocumentID"].ToString();
                        lstCultures.Items.Add(li);
                    }
                    if (lstCultures.Items.Count > 0)
                    {
                        lstCultures.SelectedIndex = 0;
                    }
                    //this.lstCultures.DataSource = nodes;
                    //this.lstCultures.DataBind();
                }
            }
            else
            {
                this.pnlNewVersion.Visible = false;
                this.lblInfo.Text = ResHelper.GetString("Content.DocumentNotExistsInfo");

                this.titleElem.TitleText = ResHelper.GetString("Content.DocumentNotExists");
                this.titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/notexists.gif";
            }
        }
    }

}
