using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.SiteProvider;
using CMS.TreeEngine;
using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.WorkflowEngine;
using CMS.Staging;

public partial class CMSDesk_Content_Relateddocs_Add : CMSDeskPage
{
    protected int currentNodeId = 0;
    //protected int selectedNodeId = 0;
    //protected bool currentNodeIsOnLeftSide = true;


    protected void Page_Load(object sender, EventArgs e)
    {
        // Register the dialog script
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);
        
        if ((Request.QueryString["nodeid"] != null) && (Request.QueryString["nodeid"].ToString() != ""))
        {
            currentNodeId = Convert.ToInt32(Request.QueryString["nodeid"]);
        }

        leftCell.Text = ResHelper.GetString("Relationship.leftSideDoc");
        middleCell.Text = ResHelper.GetString("Relationship.RelationshipName");
        rightCell.Text = ResHelper.GetString("Relationship.rightSideDoc");

        btnLeftNode.Text = ResHelper.GetString("Relationship.SelectDocument");
        btnRightNode.Text = ResHelper.GetString("Relationship.SelectDocument");
        btnSwitchSides.Text = ResHelper.GetString("Relationship.SwitchSides");
        btnOk.Text = ResHelper.GetString("General.OK");

        string relatedDocs = ResHelper.GetString("Relationship.RelatedDocs");
        string relatedDocsUrl = "~/CMSDesk/Content/Properties/Relateddocs_List.aspx?nodeid=" + currentNodeId.ToString();
        string addRelatedDocs = ResHelper.GetString("Relationship.AddRelatedDocs");
        string title = ResHelper.GetString("Relationship.AddRelatedDocsTitle");
        // initializes page title
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = relatedDocs;
        pageTitleTabs[0, 1] = relatedDocsUrl;
        pageTitleTabs[0, 2] = "propedit";
        pageTitleTabs[1, 0] = addRelatedDocs;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle1.Breadcrumbs = pageTitleTabs;
        

        if (currentNodeId > 0)
        {
            TreeProvider treeProvider = new TreeProvider();
            if (!IsPostBack)
            {
                InitializeDrpRelationship();
            }
            else
            {
                //set currentNodeIsOnLeftSide
            }

            lblLeftNode.Text = treeProvider.SelectSingleNode(currentNodeId).DocumentName;
            lblRightNode.Text = treeProvider.SelectSingleNode(currentNodeId).DocumentName;

            btnRightNode.OnClientClick = "modalDialog('../SelectNodeDialog/default.aspx?action=select', 'contentselectnode', 400, 600); return false;";
            btnLeftNode.OnClientClick = "modalDialog('../SelectNodeDialog/default.aspx?action=select', 'contentselectnode', 400, 600); return false;";

            txtLeftNode.Text = "";
            txtRightNode.Text = "";
            
        }
    }


    protected void InitializeDrpRelationship()
    {

        int siteId = CMSContext.CurrentSite.SiteID;
        DataSet dataSetRelationships = RelationshipNameInfoProvider.GetAllRelationshipNames(siteId);
        if ((dataSetRelationships != null) && (dataSetRelationships.Tables.Count > 0))
        {
            DataTable dataTableRelationships = dataSetRelationships.Tables[0];
            foreach (DataRow dataRowRelationship in dataTableRelationships.Rows)
            {
                ListItem listItemRelationships = new ListItem(dataRowRelationship["RelationshipDisplayName"].ToString(), dataRowRelationship["RelationshipNameID"].ToString());
                drpRelationship.Items.Add(listItemRelationships);
            }
        }
        if (drpRelationship.Items.Count > 0) drpRelationship.SelectedIndex = 0;
    }


    protected void btnOk_Click(object sender, EventArgs e)
    {
        if ((currentNodeId > 0) && (drpRelationship.SelectedIndex > -1))
        {
            int relationshipNameId = Convert.ToInt32(drpRelationship.SelectedValue);
            int selectedNodeId = 0;
            bool currentNodeIsOnLeftSide = true;

            if ((Request.Params["currentOnLeft"] != null) && (Request.Params["currentOnLeft"].ToString() != ""))
            {
                currentNodeIsOnLeftSide = Convert.ToBoolean(Request.Params["currentOnLeft"]);
            }
            if ((Request.Params["selectedNodeId"] != null) && (Request.Params["selectedNodeId"].ToString() != ""))
            {
                selectedNodeId = Convert.ToInt32(Request.Params["selectedNodeId"]);
            }

            if (selectedNodeId > 0)
            {
                try
                {
                    if (currentNodeIsOnLeftSide)
                    {
                        RelationshipProvider.AddRelationship(currentNodeId, selectedNodeId, relationshipNameId);
                    }
                    else
                    {
                        RelationshipProvider.AddRelationship(selectedNodeId, currentNodeId, relationshipNameId);
                    }

                    // Log synchronization
                    string aliasPath = TreePathUtils.GetAliasPathByNodeId(currentNodeId);
                    DocumentHelper.LogSynchronization(CMSContext.CurrentSite.SiteName, aliasPath, TaskTypeEnum.UpdateDocument, null, SynchronizationInfoProvider.ENABLED_SERVERS);

                    Response.Redirect("Relateddocs_List.aspx?nodeid=" + currentNodeId);
                }
                catch (Exception ex)
                {
                    lblError.Visible = true;
                    lblError.Text = ex.Message;
                }
            }
        }
    }
}
