using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.SiteProvider;
using CMS.TreeEngine;
using CMS.ExtendedControls;
using CMS.WorkflowEngine;
using CMS.CMSHelper;
using CMS.PortalEngine;

public partial class CMSDesk_Content_Properties_general : CMSDeskPage
{
    int nodeId = 0;
    protected string mSave = null;
    string imagesUrl = null;
    bool canEditOwner = false;
    CMS.TreeEngine.TreeNode node = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        Page.ClientScript.RegisterClientScriptBlock(typeof(string), "function CacheTypeChange()", ScriptHelper.GetScript("" +
            "function CacheTypeChange(enable) { \n" +
            "if (enable) { document.getElementById('" + this.txtCacheMinutes + "').enabled = true; } \n" +
            "else { document.getElementById('" + this.txtCacheMinutes + "').enabled = false; } } \n"
            ));

        imagesUrl = ResolveUrl("~/App_Themes/" + this.Page.Theme + "/Images/CMSDesk/Content/");

        nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);

        this.valAlias.ErrorMessage = ResHelper.GetString("GeneralProperties.RequiresAlias");

        this.lblAlias.Text = ResHelper.GetString("GeneralProperties.Alias");
        this.lblUrlPath.Text = ResHelper.GetString("GeneralProperties.UrlPath");

        this.pnlPath.GroupingText = ResHelper.GetString("GeneralProperties.PathGroup");
        this.pnlCache.GroupingText = ResHelper.GetString("GeneralProperties.CacheGroup");
        this.pnlOther.GroupingText = ResHelper.GetString("GeneralProperties.OtherGroup");

        this.radInherit.Text = ResHelper.GetString("GeneralProperties.radInherit");
        this.radYes.Text = ResHelper.GetString("GeneralProperties.radYes");
        this.radNo.Text = ResHelper.GetString("GeneralProperties.radNo");

        this.lblCacheMinutes.Text = ResHelper.GetString("GeneralProperties.cacheMinutes");

        //this.btnRadOk.Text = ResHelper.GetString("GeneralProperties.btnOk");

        // this.lblOther.Text = ResHelper.GetString("GeneralProperties.Other");
        this.lblNameTitle.Text = ResHelper.GetString("GeneralProperties.Name");
        this.lblNamePathTitle.Text = ResHelper.GetString("GeneralProperties.NamePath");
        this.lblAliasPathTitle.Text = ResHelper.GetString("GeneralProperties.AliasPath");
        this.lblTypeTitle.Text = ResHelper.GetString("GeneralProperties.Type");
        this.lblNodeIDTitle.Text = ResHelper.GetString("GeneralProperties.NodeID");
        this.lblLastModifiedByTitle.Text = ResHelper.GetString("GeneralProperties.LastModifiedBy");
        this.lblLastModifiedTitle.Text = ResHelper.GetString("GeneralProperties.LastModified");
        this.lblLiveURLTitle.Text = ResHelper.GetString("GeneralProperties.LiveURL");
        this.lblGUIDTitle.Text = ResHelper.GetString("GeneralProperties.GUID");
        this.lblCultureTitle.Text = ResHelper.GetString("GeneralProperties.Culture");
        this.lblCreatedByTitle.Text = ResHelper.GetString("GeneralProperties.CreatedBy");
        this.lblCreatedTitle.Text = ResHelper.GetString("GeneralProperties.Created");
        this.chkCustomUrl.Text = ResHelper.GetString("GeneralProperties.UseCustomUrlPath");
        this.lblOwnerTitle.Text = ResHelper.GetString("GeneralProperties.Owner");
        this.lblCssStyle.Text = ResHelper.GetString("PageProperties.CssStyle");

        this.chkCssStyle.Text = ResHelper.GetString("Metadata.Inherit");
        
        this.imgSave.ImageUrl = imagesUrl + "save.gif";
        mSave = ResHelper.GetString("EditMenu.IconSave");

        canEditOwner = (CMSContext.CurrentUser.IsAuthorizedPerResource("cms.content", "ModifyPermissions") && (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(nodeId, NodePermissionsEnum.ModifyPermissions) != AuthorizationResultEnum.Denied)) || (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(nodeId, NodePermissionsEnum.ModifyPermissions) == AuthorizationResultEnum.Allowed);

        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        node = DocumentHelper.GetDocument(nodeId, CMSContext.CurrentUser.PreferredCultureCode, tree);
        
        if (!this.IsPostBack)
        {
            ReloadData();
        }
    }


    private void ReloadData()
    {
        //node = tree.SelectSingleNode(nodeId);
        if (node != null)
        {
            // Check read permissions
            if (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(nodeId, NodePermissionsEnum.Read) == AuthorizationResultEnum.Denied)
            {
                CMSDeskPage.RedirectToAccessDenied(String.Format(ResHelper.GetString("cmsdesk.notauthorizedtoreaddocument"), node.NodeAliasPath));
            }
            else
            {
                // Check modify permissions
                if (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(nodeId, NodePermissionsEnum.Modify) == AuthorizationResultEnum.Denied)
                {
                    // disable form editing                                                            
                    DisableFormEditing();

                    // show access denied message
                    lblInfo.Text = String.Format(ResHelper.GetString("cmsdesk.notauthorizedtoeditdocument"), node.NodeAliasPath);
                }

                // Show owner editing only when authorized to change the permissions
                if (canEditOwner)
                {
                    lblOwner.Visible = false;
                    usrOwner.Visible = true;
                }

                this.txtAlias.Text = node.NodeAlias;
                this.txtUrlPath.Text = node.DocumentUrlPath;
                this.chkCustomUrl.Checked = !node.DocumentUseNamePathForUrlPath;

                if (!IsPostBack)
                {
                    if (canEditOwner)
                    {
                        this.usrOwner.Value = node.GetValue("NodeOwner");
                    }
                }

                if (node.NodeClassName.ToLower() == "cms.root")
                {
                    //DisableFormEditing();
                    this.txtAlias.Enabled = false;
                    this.txtUrlPath.Enabled = false;
                    this.chkCustomUrl.Enabled = false;
                    this.lblAlias.Enabled = false;
                    this.lblUrlPath.Enabled = false;
                    valAlias.Enabled = false;
                }
                else
                {
                    this.txtUrlPath.Enabled = this.chkCustomUrl.Checked;
                }

                if (node.IsLink)
                {
                    this.txtUrlPath.Enabled = false;
                    this.chkCustomUrl.Enabled = false;
                }

                this.lblName.Text = node.DocumentName;
                this.lblNamePath.Text = Convert.ToString(node.GetValue("DocumentNamePath"));
                this.lblAliasPath.Text = Convert.ToString(node.NodeAliasPath);
                this.lblType.Text = DataClassInfoProvider.GetDataClass(node.NodeClassName).ClassDisplayName;
                this.lblNodeID.Text = Convert.ToString(node.NodeID);
                int uid = ValidationHelper.GetInteger(node.GetValue("DocumentModifiedByUserId"), 0);
                if (uid > 0)
                {
                    this.lblLastModifiedBy.Text = UserInfoProvider.GetUserInfo(uid).FullName;
                }
                this.lblLastModified.Text = Convert.ToString(node.GetValue("DocumentModifiedWhen"));

                uid = ValidationHelper.GetInteger(node.GetValue("NodeOwner"), 0);
                if (uid > 0)
                {
                    this.lblOwner.Text = UserInfoProvider.GetUserInfo(uid).FullName;
                }

                string liveUrl = null;
                if (node.IsLink)
                {
                    liveUrl = CMSContext.GetUrl(node.NodeAliasPath, null);
                }
                else
                {
                    liveUrl = CMSContext.GetUrl(node.NodeAliasPath, node.DocumentUrlPath);
                }

                this.lnkLiveURL.Text = AbsoluteUrl(liveUrl);
                this.lnkLiveURL.NavigateUrl = liveUrl;

                this.lblGUID.Text = Convert.ToString(node.NodeGUID);

                CultureInfo ci = CultureInfoProvider.GetCultureInfo(node.DocumentCulture);
                if (ci != null)
                {
                    this.lblCulture.Text = ci.CultureName;
                }
                else
                {
                    this.lblCulture.Text = node.DocumentCulture;
                }

                uid = ValidationHelper.GetInteger(node.GetValue("DocumentCreatedByUserId"), 0);
                if (uid > 0)
                {
                    this.lblCreatedBy.Text = UserInfoProvider.GetUserInfo(uid).FullName;
                }
                this.lblCreated.Text = Convert.ToString(node.GetValue("DocumentCreatedWhen"));

                if (!this.chkCustomUrl.Checked)
                {
                    txtUrlPath.Enabled = false;
                }

                bool isRoot = (node.NodeClassName.ToLower() == "cms.root");
                if (!IsPostBack)
                {

                    if (isRoot)
                    {
                        radInherit.Visible = false;
                        this.chkCssStyle.Visible = false;
                        switch (node.NodeCacheMinutes)
                        {
                            case -1: radNo.Checked = true; radYes.Checked = false; radInherit.Checked = false; txtCacheMinutes.Text = ""; break;
                            case 0: radNo.Checked = true; radYes.Checked = false; radInherit.Checked = false; txtCacheMinutes.Text = ""; break;
                            default: radNo.Checked = false; radYes.Checked = true; radInherit.Checked = false; txtCacheMinutes.Text = node.NodeCacheMinutes.ToString(); break;
                        }
                    }
                    else
                    {
                        switch (node.NodeCacheMinutes)
                        {
                            case -1: radNo.Checked = false; radYes.Checked = false; radInherit.Checked = true; txtCacheMinutes.Text = ""; break;
                            case 0: radNo.Checked = true; radYes.Checked = false; radInherit.Checked = false; txtCacheMinutes.Text = ""; break;
                            default: radNo.Checked = false; radYes.Checked = true; radInherit.Checked = false; txtCacheMinutes.Text = node.NodeCacheMinutes.ToString(); break;
                        }
                    }

                    if (!radYes.Checked)
                    {
                        txtCacheMinutes.Enabled = false;
                    }
                }

                if (!this.IsPostBack)
                {
                    // fill drop down list
                    DataSet ds = CssStylesheetInfoProvider.GetAllCssStylesheets();
                    if ((ds != null) && (ds.Tables.Count > 0) && (ds.Tables[0].Rows.Count > 0))
                    {
                        foreach (DataRow dr in ds.Tables[0].Rows)
                        {
                            CssStylesheetInfo cs = new CssStylesheetInfo(dr);
                            if (cs.IsInSite(node.NodeSiteID))
                            {
                                ListItem li = new ListItem();
                                li.Text = dr["StylesheetDisplayName"].ToString();
                                li.Value = dr["StylesheetID"].ToString();
                                drpCssStyle.Items.Add(li);
                            }
                        }
                    }

                    if (node.GetValue("DocumentStylesheetID") == null)
                    {
                        drpCssStyle.SelectedIndex = drpCssStyle.Items.IndexOf(drpCssStyle.Items.FindByValue("(default)"));
                    }
                    else
                    {
                        if (ValidationHelper.GetInteger(node.GetValue("DocumentStylesheetID"), 0) == -1)
                        {
                            if (!isRoot)
                            {
                                drpCssStyle.Enabled = false;
                                chkCssStyle.Checked = true;
                                string value = PageInfoProvider.GetParentProperty(CMSContext.CurrentSite.SiteID, node.NodeAliasPath, "DocumentStylesheetID <> -1", "DocumentStylesheetID", null);

                                if (value == "")
                                {
                                    drpCssStyle.SelectedIndex = drpCssStyle.Items.IndexOf(drpCssStyle.Items.FindByValue("(default)"));
                                }
                                else
                                {
                                    try
                                    {
                                        drpCssStyle.SelectedIndex = drpCssStyle.Items.IndexOf(drpCssStyle.Items.FindByValue(value));
                                    }
                                    catch
                                    {
                                    }
                                }
                            }
                        }
                        else
                        {
                            drpCssStyle.SelectedIndex = drpCssStyle.Items.IndexOf(drpCssStyle.Items.FindByValue(node.GetValue("DocumentStylesheetID").ToString()));
                        }
                    }
                }
            }
        }
    }


    protected void chkCustomUrl_CheckedChanged(object sender, EventArgs e)
    {
        this.txtUrlPath.Enabled = this.chkCustomUrl.Checked;
        if (!this.chkCustomUrl.Checked)
        {
            txtUrlPath.Text = "";
        }
    }


    protected void lnkSave_Click(object sender, EventArgs e)
    {
        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        node = tree.SelectSingleNode(nodeId, CMSContext.CurrentUser.PreferredCultureCode);
        if (node != null)
        {
            bool correct = true;

            node.NodeAlias = this.txtAlias.Text.Trim();
            node.DocumentUrlPath = this.txtUrlPath.Text.Trim();

            node.DocumentUseNamePathForUrlPath = !this.chkCustomUrl.Checked;
            if (node.DocumentUseNamePathForUrlPath)
            {
                string urlPath = TreePathUtils.GetUrlPathFromNamePath(node.DocumentNamePath);
                node.DocumentUrlPath = urlPath;
                this.txtUrlPath.Text = urlPath;
            }

            // Set owner
            int ownerId = ValidationHelper.GetInteger(usrOwner.Value, 0);
            if (ownerId > 0)
            {
                node.SetValue("NodeOwner", usrOwner.Value);
            }
            else
            {
                node.SetValue("NodeOwner", null);
            }


            node.SetValue("DocumentStylesheetID", -1);
            if (!chkCssStyle.Checked)
            {
                if (drpCssStyle.SelectedItem.Text == "(default)" && drpCssStyle.SelectedItem.Value == Convert.ToString(-1))
                {
                    node.SetValue("DocumentStylesheetID", null);
                }
                else
                {
                    node.SetValue("DocumentStylesheetID", drpCssStyle.SelectedValue);
                }
            }

            if (radNo.Checked)
            {
                node.NodeCacheMinutes = 0;
            }

            if (radYes.Checked)
            {
                string siteName = "";

                if (CMSContext.CurrentSite != null)
                {
                    siteName = CMSContext.CurrentSite.SiteName;
                }



                if (txtCacheMinutes.Text == "")
                {
                    if (radYes.Checked)
                    {
                        correct = false;
                    }
                    else
                    {
                        txtCacheMinutes.Text = SettingsKeyProvider.GetStringValue(siteName + ".CMSCacheMinutes");
                    }
                }
                else
                {
                    int isInteger = ValidationHelper.GetInteger(txtCacheMinutes.Text, -5);
                    if (isInteger <= 0) correct = false;
                }

                node.NodeCacheMinutes = ValidationHelper.GetInteger(txtCacheMinutes.Text, 0);
            }

            if (radInherit.Checked)
            {
                node.NodeCacheMinutes = -1;
            }

            if (correct)
            {
                node.Update();

                this.lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
                ReloadData();
            }
            else
            {
                lblError.Text = ResHelper.GetString("GeneralProperties.BadCacheMinutes");
            }
        }
    }


    /// <summary>
    /// Disables form editing.
    /// </summary>
    protected void DisableFormEditing()
    {
        // disable form editing
        this.txtAlias.Enabled = false;
        this.txtUrlPath.Enabled = false;
        this.chkCustomUrl.Enabled = false;
        this.usrOwner.Enabled = false;

        // disable 'save button'
        this.lnkSave.Enabled = false;
        this.lnkSave.CssClass = "MenuItemEditDisabled";
        this.imgSave.ImageUrl = imagesUrl + "savedisabled.gif";

    }


    protected void radInherit_CheckedChanged(object sender, EventArgs e)
    {
        txtCacheMinutes.Enabled = false;

        if (radYes.Checked)
        {
            txtCacheMinutes.Enabled = true;
        }
    }


    protected void chkCssStyle_CheckedChanged(object sender, EventArgs e)
    {
        if (chkCssStyle.Checked)
        {

            drpCssStyle.Enabled = false;
            string value = PageInfoProvider.GetParentProperty(CMSContext.CurrentSite.SiteID, node.NodeAliasPath, "DocumentStylesheetID <> -1", "DocumentStylesheetID", null);

            if (value == "")
            {
                drpCssStyle.SelectedIndex = drpCssStyle.Items.IndexOf(drpCssStyle.Items.FindByValue("(default)"));
            }
            else
            {
                try
                {
                    drpCssStyle.SelectedIndex = drpCssStyle.Items.IndexOf(drpCssStyle.Items.FindByValue(value));
                }
                catch
                {
                }
            }
        }
        else
        {
            drpCssStyle.Enabled = true;
        }
    }

}
