using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.TreeEngine;
using CMS.GlobalHelper;
using CMS.SiteProvider;
using CMS.SettingsProvider;
using CMS.CMSHelper;

public partial class CMSDesk_Content_Properties_header : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string[,] tabs = new string[10, 4];
        int selectedTab = -1;

        bool personalize = (CMSContext.CurrentSite != null) && (SettingsKeyProvider.GetBoolValue(CMSContext.CurrentSite.SiteName + ".CMSPersonalizeUserInterface"));
        CurrentUserInfo curUser = CMSContext.CurrentUser;

        // Order of the tabs adding is mandatory because of selectedTab variable
        if ((personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesSecurity"))) || !personalize)
        {
            tabs[9, 0] = "&nbsp;" + ResHelper.GetString("Properties.Security") + "&nbsp;";
            tabs[9, 2] = "security.aspx?nodeid=" + Request.QueryString["nodeid"];
            selectedTab = 8;
        }

        if ((personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesLinkedDocs"))) || !personalize)
        {
            tabs[8, 0] = "&nbsp;" + ResHelper.GetString("Properties.Linked") + "&nbsp;";
            tabs[8, 2] = "LinkedDocs.aspx?nodeid=" + Request.QueryString["nodeid"];
            selectedTab = 7;
        }

        if ((personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesRelatedDocs"))) || !personalize)
        {
            tabs[7, 0] = "&nbsp;" + ResHelper.GetString("Properties.Related") + "&nbsp;";
            tabs[7, 2] = "Relateddocs_List.aspx?nodeid=" + Request.QueryString["nodeid"];
            selectedTab = 7;
        }

        if ((personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesVersions"))) || !personalize)
        {
            tabs[5, 0] = "&nbsp;" + ResHelper.GetString("Properties.Versions") + "&nbsp;";
            tabs[5, 2] = "versions.aspx?nodeid=" + Request.QueryString["nodeid"];
            selectedTab = 5;
        }

        if ((personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesWorkflow"))) || !personalize)
        {
            tabs[4, 0] = "&nbsp;" + ResHelper.GetString("Properties.Workflow") + "&nbsp;";
            tabs[4, 2] = "workflow.aspx?nodeid=" + Request.QueryString["nodeid"];
            selectedTab = 4;
        }

        if ((personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesMenu"))) || !personalize)
        {
            tabs[3, 0] = "&nbsp;" + ResHelper.GetString("Properties.Menu") + "&nbsp;";
            tabs[3, 2] = "menu.aspx?nodeid=" + Request.QueryString["nodeid"];
            selectedTab = 3;
        }

        if ((personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesMetaData"))) || !personalize)
        {
            tabs[2, 0] = "&nbsp;" + ResHelper.GetString("Properties.Metadata") + "&nbsp;";
            tabs[2, 2] = "metadata.aspx?nodeid=" + Request.QueryString["nodeid"];
            selectedTab = 2;
        }

        if ((personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesTemplate"))) || !personalize)
        {
            tabs[1, 0] = "&nbsp;" + ResHelper.GetString("Properties.Template") + "&nbsp;";
            tabs[1, 2] = "template.aspx?nodeid=" + Request.QueryString["nodeid"];
            selectedTab = 1;
        }

        if ((personalize && (curUser.IsAuthorizedPerResource("CMS.UserInterface", "PropertiesGeneral"))) || !personalize)
        {
            tabs[0, 0] = "&nbsp;" + ResHelper.GetString("Properties.General") + "&nbsp;";
            tabs[0, 2] = "general.aspx?nodeid=" + Request.QueryString["nodeid"];
            selectedTab = 0;
        }

        tabsProperties.Tabs = tabs;
        tabsProperties.SelectedTab = selectedTab;
        tabsProperties.UrlTarget = "propedit";
    }
}
