using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.SiteProvider;
using CMS.TreeEngine;
using CMS.WorkflowEngine;
using CMS.CMSHelper;
using CMS.Staging;

public partial class CMSDesk_Content_Properties_relationshipdelete : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        int leftNodeId = 0;
        int relationshipNameId = 0;
        int rightNodeId = 0;
        int originalNodeId = 0;

        if ((Request.QueryString["lnode"] != null) && (Request.QueryString["lnode"].ToString() != ""))
        {
            leftNodeId = Convert.ToInt32(Request.QueryString["lnode"]);
        }

        if ((Request.QueryString["relname"] != null) && (Request.QueryString["relname"].ToString() != ""))
        {
            relationshipNameId = Convert.ToInt32(Request.QueryString["relname"]);
        }

        if ((Request.QueryString["rnode"] != null) && (Request.QueryString["rnode"].ToString() != ""))
        {
            rightNodeId = Convert.ToInt32(Request.QueryString["rnode"]);
        }

        if ((leftNodeId > 0) && (relationshipNameId > 0) && (rightNodeId > 0))
        {
            RelationshipProvider.RemoveRelationship(leftNodeId, rightNodeId, relationshipNameId);
        }

        // Log synchronization
        string aliasPath = TreePathUtils.GetAliasPathByNodeId(leftNodeId);
        DocumentHelper.LogSynchronization(CMSContext.CurrentSite.SiteName, aliasPath, TaskTypeEnum.UpdateDocument, null, SynchronizationInfoProvider.ENABLED_SERVERS);

        if ((Request.QueryString["node"] != null) && (Request.QueryString["node"].ToString() != ""))
        {
            originalNodeId = Convert.ToInt32(Request.QueryString["node"]);
        }

        string targetUrl = "Relateddocs_List.aspx";
        if (originalNodeId > 0) targetUrl += "?nodeid=" + originalNodeId.ToString();
        Response.Redirect(targetUrl);
    }
}
