using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.SiteProvider;
using CMS.CMSHelper;
using CMS.GlobalHelper;
using CMS.TreeEngine;

public partial class CMSDesk_Content_SelectImageDialog_Tree : CMSModalPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        int siteId = ValidationHelper.GetInteger(Request.QueryString["siteid"], CMSContext.CurrentSite.SiteID);        

        this.treeContent.NodeTextTemplate = "<span class=\"ContentTreeItem\" onclick=\"SelectNode(##NODEID##, this, '##NODENAMEJAVA##'); return false;\">##ICON##<span class=\"Name\">##NODENAME##</span></span>";
        this.treeContent.SelectedNodeTextTemplate = "<span id=\"treeSelectedNode\" class=\"ContentTreeSelectedItem\" onclick=\"SelectNode(##NODEID##, this, '##NODENAMEJAVA##'); return false;\">##ICON##<span class=\"Name\">##NODENAME##</span></span>";

        this.treeContent.SiteName = SiteInfoProvider.GetSiteInfo(siteId).SiteName;

        string contentUrl = ResolveUrl("content.aspx") + Request.Url.Query;

        // Set starting path
        string path = ValidationHelper.GetString(Request.QueryString["path"], "");
        if (path != "")
        {
            treeContent.Path = path;
        }                       

        // If nodeId set, init the list of the nodes to expand
        int expandNodeId = 0;
        if (Request.QueryString["expandnodeid"] != null)
        {
            expandNodeId = ValidationHelper.GetInteger(Request.QueryString["expandnodeid"], 0);
        }
        this.treeContent.ExpandNodeID = expandNodeId;

        // Current Node ID
        int nodeId = 0;
        if (Request.QueryString["nodeid"] != null)
        {
            nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);
        }
        this.treeContent.NodeID = nodeId;

        // Setup the current node script
        if (nodeId > 0)
        {
            this.ltlScript.Text += ScriptHelper.GetScript("    currentNodeId = " + nodeId + ";");
        }

        contentUrl = UrlHelper.AddParameterToUrl(UrlHelper.RemoveParameterFromUrl(contentUrl, "nodeid"), "nodeid", "");

        this.ltlScript.Text += ScriptHelper.GetScript("var contentUrl='" + ResolveUrl(contentUrl) + "'; treeUrl = '" + ResolveUrl("~/CMSDesk/Content/SelectImageDialog/Tree.aspx?siteid=" + Request.QueryString["siteid"]) + "';");

        // Setup the current node script
        if (nodeId > 0)
        {
            this.ltlScript.Text += ScriptHelper.GetScript("    currentNodeId = " + nodeId + ";");
        }
    }


}

