using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.TreeEngine;

public partial class CMSDesk_Content_SelectNodeDialog_footer : CMSModalPage, ICallbackEventHandler
{
    private TreeProvider tree;    
    
    protected void Page_Load(object sender, EventArgs e)
    {
        tree = new TreeProvider();
        // Register the script to perform target path retrieval callback
        this.Page.ClientScript.RegisterClientScriptBlock(GetType(), "FileImportAliasPath", ScriptHelper.GetScript("function GetTargetAliasPath(nodeId){ return " + this.Page.ClientScript.GetCallbackEventReference(this, "nodeId", "ReceiveTargetAliasPath", null) + "; } \n"));

        this.errorNotSelected.Value = ResHelper.GetString("SelectNodeDialog.ErrorNotSelected");
        this.errorMoveIdentity.Value = ResHelper.GetString("SelectNodeDialog.ErrorMoveIdentity");
        this.errorCopyIdentity.Value = ResHelper.GetString("SelectNodeDialog.ErrorCopyIdentity");

        // Process the action
        if (Request.QueryString["action"] != null)
        {
            // Get the nodeId
            int nodeId = 0;
            if (Request.QueryString["nodeid"] != null)
            {
                nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);
            }
            // Setup the text template

            switch (Request.QueryString["action"].ToLower())
            {
                case "move":
                    if (nodeId != 0)
                    {
                        this.btnProceed.Text = ResHelper.GetString("MoveDialog.btnProceed");
                        this.btnProceed.Attributes.Add("onclick", "MoveNodeToCurrent(" + nodeId + "); return false;");
                    }
                    break;
                case "copy":
                    if (nodeId != 0)
                    {
                        this.btnProceed.Text = ResHelper.GetString("CopyDialog.btnProceed");
                        this.btnProceed.Attributes.Add("onclick", "CopyNodeToCurrent(" + nodeId + "); return false;");
                    }
                    break;
                case "select":
                    this.btnProceed.Text = ResHelper.GetString("SelectDialog.btnProceed");
                    this.btnProceed.Attributes.Add("onclick", "SelectCurrentNode(); return false;");
                    break;
            }
        }

        this.btnCancel.Text = ResHelper.GetString("SelectNodeDialog.btnCancel");
        this.btnCancel.Attributes.Add("onclick", "CloseWindow(); return false;");
    }


    #region "Callback handling"

    /// <summary>
    /// Current template description
    /// </summary>
    private string cbTargetAliasPath = "";


    /// <summary>
    /// Callback event handler
    /// </summary>
    /// <param name="argument">Callback argument</param>
    public void RaiseCallbackEvent(string argument)
    {
        int nodeId = 0;
        nodeId = Convert.ToInt32(argument);
        if (nodeId > 0)
        {
            cbTargetAliasPath = tree.SelectSingleNode(nodeId).NodeAliasPath;
        }
    }


    /// <summary>
    /// Callback result retrieving handler
    /// </summary>
    public string GetCallbackResult()
    {
        return cbTargetAliasPath;
    }

    #endregion
}
