using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SiteProvider;
using CMS.CMSHelper;

public partial class CMSDesk_Content_SelectNodeDialog_header : CMSModalPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        int siteId = ValidationHelper.GetInteger(Request.QueryString["siteid"], 0);
        string path = ValidationHelper.GetString(Request.QueryString["path"], "");

        this.lblSite.Text = ResHelper.GetString("SelectNodeDialog.Site");
        // Fill in the site list
        if (dropSites.Items.Count == 0)
        {

            // If actual user is global administrator, get all sites
            if (CMSContext.CurrentUser.IsGlobalAdministrator)
            {
                DataSet ds = SiteInfoProvider.GetAllSites();
                if (!DataHelper.DataSourceIsEmpty(ds))
                {
                    dropSites.DataSource = ds.Tables[0];
                    dropSites.DataBind();
                }
            }
            // Else get only user's sites.
            else
            {
                DataTable ds = UserInfoProvider.GetUserSites(CMSContext.CurrentUser.UserID);

                if (!DataHelper.DataSourceIsEmpty(ds))
                {
                    dropSites.DataSource = ds;
                    dropSites.DataBind();
                }
            }

            try
            {
                dropSites.SelectedValue = CMSContext.CurrentSite.SiteID.ToString();
            }
            catch
            {
            }

            // Disable selecting other sites from dropdownlist when starting path is defined
            dropSites.Enabled = (path == ""); 
        }

        switch (ValidationHelper.GetString(Request.QueryString["action"], ""))
        {
            case "move":
                this.titleElem.TitleText = ResHelper.GetString("Content.MoveDialog");
                this.titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/move.gif";
                break;
            case "copy":
                this.titleElem.TitleText = ResHelper.GetString("Content.CopyDialog");
                this.titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/copy.gif";
                break;
            default:
                this.titleElem.TitleText = ResHelper.GetString("Content.SelectDialog");
                this.titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/select.gif";
                break;
        }        

        this.dropSites.Attributes.Add("onchange", "RefreshSite(this,'" + path +"');");
        ltlScript.Text = "RefreshSite(document.getElementById('dropSites'),'" + path + "' );";
    }

}
