using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.TreeEngine;
using CMS.WorkflowEngine;
using CMS.FileManager;
using CMS.DataEngine;

public partial class CMSDesk_Content_ViewFile : CMSDeskPage
{
    int nodeId = 0;
    
    protected void Page_Load(object sender, EventArgs e)
    {
        lblFileName.Text = ResHelper.GetString("ViewFile.FileName");
        lblFileSize.Text = ResHelper.GetString("ViewFile.FileSize");

        // gets query string information:
        //   current nodeID
        if (Request.QueryString["nodeid"] != null)
        {
            nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);
        }

        // Get the node
        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);

        // Get current node
        CMS.TreeEngine.TreeNode node = DocumentHelper.GetDocument(nodeId, CMSContext.CurrentUser.PreferredCultureCode, tree);

        if (node != null)
        {
            //Get latest version
            if (node.GetValue("FileAttachment") != null)
            {
                // Get guid
                Guid mGuid = new Guid(node.GetValue("FileAttachment").ToString());
                AttachmentInfo atInfo = DocumentHelper.GetAttachment(node, mGuid, tree, false);

                // if file exist, check filetype and create texts and links
                if (atInfo != null)
                {
                    lblFileSizeText.Text = atInfo.AttachmentSize.ToString();
                    lblFileNameText.Text = atInfo.AttachmentName;

                    // Get attachment URL
                    string attUrl = null;
                    if (node.NodeClassName.ToLower() == "cms.file")
                    {
                        attUrl = "~/CMSPages/GetFile.aspx?nodeguid=" + node.NodeGUID.ToString();  //DocumentHelper.GetAttachmentUrl(atInfo, versionHistoryId);
                    }
                    else
                    {
                        int versionHistoryId = ValidationHelper.GetInteger(node.GetValue("DocumentCheckedOutVersionHistoryID"), 0);
                        attUrl = DocumentHelper.GetAttachmentUrl(atInfo, versionHistoryId);
                    }

                    // Setup the display information
                    if (ImageHelper.IsImage(atInfo.AttachmentExtension))
                    {
                        // Image, show preview
                        this.plcSize.Visible = true;
                        this.lblSize.Text = ResHelper.GetString("ViewFile.Size");
                        this.lblSizeText.Text = atInfo.AttachmentImageWidth.ToString() + "x" + atInfo.AttachmentImageHeight.ToString();

                        this.plcImage.Visible = true;
                        this.imgPreview.ImageUrl = attUrl + "&maxsidesize=600";

                        this.lnkView.NavigateUrl = attUrl;
                        this.lnkView.Text = ResHelper.GetString("ViewFile.OpenInFull");
                    }
                    else
                    {
                        // Document, open link
                        this.lnkView.Text = ResHelper.GetString("ViewFile.Open");
                        this.lnkView.NavigateUrl = attUrl;
                    }
                }
            }
        }
    }
}
