using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.DataEngine;
using CMS.TreeEngine;
using CMS.SettingsProvider;
using CMS.CMSHelper;

public partial class CMSDesk_Content_new : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // Current Node ID
        int nodeId = 0;
        if (Request.QueryString["nodeid"] != null)
        {
            nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);
        }

        // Get the node
        TreeProvider tree = new TreeProvider();
        CMS.TreeEngine.TreeNode node = tree.SelectSingleNode(nodeId, TreeProvider.ALL_CULTURES);

        this.titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/new.gif";
        this.titleElem.TitleText = ResHelper.GetString("Content.NewTitle");

        this.lblNewLink.Text = ResHelper.GetString("ContentNew.NewLink");
        this.lnkNewLink.NavigateUrl = "EditFrameset.aspx?action=newlink&nodeid=" + Request.QueryString["nodeid"];
        this.imgNewLink.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Content/link.gif";

        if (node != null)
        {
            if ((CMSContext.CurrentUser.IsAuthorizedPerTreeNode(node, NodePermissionsEnum.Create)== AuthorizationResultEnum.Allowed) ||
                (CMSContext.CurrentUser.IsAuthorizedPerTreeNode(node, NodePermissionsEnum.Create) == AuthorizationResultEnum.Insignificant))
            {
                // Get the allowed child classes
                DataSet ds = DataClassInfoProvider.GetAllowedChildClasses(ValidationHelper.GetInteger(node.GetValue("NodeClassID"), 0), CMSContext.CurrentSite.SiteID);

                ArrayList rows = new ArrayList();

                if (!DataHelper.DataSourceIsEmpty(ds))
                {
                    for (int i = 0; i < ds.Tables[0].Rows.Count; ++i)
                    {
                        DataRow dr = ds.Tables[0].Rows[i];
                        string doc = ValidationHelper.GetString(DataHelper.GetDataRowValue(dr, "ClassName"), "");

                        // Document type is not allowed, remove it from the data set
                        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Content", "Create") && !CMSContext.CurrentUser.IsAuthorizedPerClassName(doc, "Create"))
                        {
                            rows.Add(dr);
                        }
                    }

                    // Remove the document types
                    foreach (DataRow dr in rows)
                    {
                        ds.Tables[0].Rows.Remove(dr);
                    }

                    if (!DataHelper.DataSourceIsEmpty(ds))
                    {
                        ds.Tables[0].DefaultView.Sort = "ClassDisplayName";
                    }
                    else
                    {
                        lblError.Visible = true;
                        lblError.Text = ResHelper.GetString("Content.NoPermissions");
                        lblInfo.Visible = false;
                        pnlFooter.Visible = false;
                    }
                }
                else
                {
                    lblError.Visible = true;
                    lblError.Text = ResHelper.GetString("Content.NoAllowedChildDocuments");
                    lblInfo.Visible = false;
                    pnlFooter.Visible = false;
                }

                this.gridClasses.DataSource = ds.Tables[0].DefaultView.Table;
                this.gridClasses.DataBind();
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("Content.NoPermissions");
                lblInfo.Visible = false;
                pnlFooter.Visible = false;
            }

            this.lblInfo.Text = ResHelper.GetString("Content.NewInfo");
        }
    }
}
