using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class CMSDesk_MyDesk_MyDocuments : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/MyDesk/MyDocuments/mydocuments.gif";
        titleElem.TitleText = ResHelper.GetString("MyDesk.MyDocumentsTitle");
        ugDocs.GridView.GridLines = GridLines.Horizontal;

        object[,] parameters = new object[2, 3];
        parameters[0, 0] = "@UserID";
        parameters[0, 1] = CMSContext.CurrentUser.UserID;
        parameters[1, 0] = "@SiteID";
        parameters[1, 1] = CMSContext.CurrentSite.SiteID;

        ugDocs.QueryParameters = parameters;
        ugDocs.OnExternalDataBound += new OnExternalDataBoundEventHandler(ugDocs_OnExternalDataBound);

        ugDocs.HideControlForZeroRows = true;
    }
    

    /// <summary>
    /// External data binding handler
    /// </summary>
    object ugDocs_OnExternalDataBound(object sender, string sourceName, object parameter)
    {
        if (sourceName.ToLower() == "classname")
        {
            string imageUrl = "../../../App_Themes/" + this.Page.Theme + "/Images/CMSDesk/Icons/" + Convert.ToString(parameter).Replace(".", "_") + ".gif";
            return "<img src=\"" + imageUrl + "\" border=\"0\"/>";
        }

        return parameter;
    }
}
