using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class CMSDesk_MyDesk_OutdatedDocuments : CMSDeskPage
{

    protected void Page_Load(object sender, EventArgs e)
    {

        string strDays = ResHelper.GetString("MyDesk.OutdatedDocuments.Days");
        string strWeeks = ResHelper.GetString("MyDesk.OutdatedDocuments.Weeks");
        string strMonths = ResHelper.GetString("MyDesk.OutdatedDocuments.Months");
        string strYears = ResHelper.GetString("MyDesk.OutdatedDocuments.Years");

        // Initialize controls
        titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/MyDesk/OutdatedDocuments/outdateddocuments.gif";
        titleElem.TitleText = ResHelper.GetString("MyDesk.OutdatedDocumentsTitle");
        lblFilter.Text = ResHelper.GetString("MyDesk.OutdatedDocuments.Filter");
        btnShow.Text = ResHelper.GetString("MyDesk.OutdatedDocuments.Show");

        if (!IsPostBack)
        {
            // Fill the dropdown list
            drpFilter.Items.Add(strDays);
            drpFilter.Items.Add(strWeeks);
            drpFilter.Items.Add(strMonths);
            drpFilter.Items.Add(strYears);

            // Load default value
            txtFilter.Text = "1";
            drpFilter.SelectedValue = strYears;

        }

        ugOutdatedDocs.GridView.GridLines = GridLines.Horizontal;

        object[,] parameters = new object[3, 3];
        parameters[0, 0] = "@UserID";
        parameters[0, 1] = CMSContext.CurrentUser.UserID;
        parameters[1, 0] = "@SiteID";
        parameters[1, 1] = CMSContext.CurrentSite.SiteID;

        DateTime olderThan = DateTime.Now;

        if (drpFilter.SelectedValue == strDays)
        {
            olderThan = olderThan.AddDays(-ValidationHelper.GetInteger(txtFilter.Text, 0));
        }
        else if (drpFilter.SelectedValue == strWeeks)
        {
            olderThan = olderThan.AddDays(-ValidationHelper.GetInteger(txtFilter.Text, 0) * 7);
        }
        else if (drpFilter.SelectedValue == strMonths)
        {
            olderThan = olderThan.AddMonths(-ValidationHelper.GetInteger(txtFilter.Text, 0));
        }
        else if (drpFilter.SelectedValue == strYears)
        {
            olderThan = olderThan.AddYears(-ValidationHelper.GetInteger(txtFilter.Text, 0));
        }

        parameters[2, 0] = "@OlderThan";
        parameters[2, 1] = olderThan;

        ugOutdatedDocs.QueryParameters = parameters;
        ugOutdatedDocs.HideControlForZeroRows = true;
        ugOutdatedDocs.OnExternalDataBound += new OnExternalDataBoundEventHandler(ugOutdatedDocs_OnExternalDataBound);

    }


    /// <summary>
    /// External data binding handler
    /// </summary>
    object ugOutdatedDocs_OnExternalDataBound(object sender, string sourceName, object parameter)
    {
        if (sourceName.ToLower() == "classname")
        {
            string imageUrl = "../../../App_Themes/" + this.Page.Theme + "/Images/CMSDesk/Icons/" + Convert.ToString(parameter).Replace(".", "_") + ".gif";
            return "<img src=\"" + imageUrl + "\" border=\"0\"/>";
        }

        return parameter;
    }



}
