using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.WebAnalytics;
using CMS.GlobalHelper;

public partial class CMSDesk_Tools_Analytics_StatisticsList : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.PageTitle.TitleText = ResHelper.GetString("Analytics.StatisticsList.TitleText");
        this.PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Analytics/statistics.gif";

        UniGridStatistics.OnExternalDataBound += new OnExternalDataBoundEventHandler(UniGridStatistics_OnExternalDataBound);
        UniGridStatistics.OnAction += new OnActionEventHandler(UniGridStatistics_OnAction);
    }


    /// <summary>
    /// Handles the UniGrid's OnExternalDataBound event.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="sourceName"></param>
    /// <param name="parameter"></param>
    object UniGridStatistics_OnExternalDataBound(object sender, string sourceName, object parameter)
    {
        if (sourceName.ToLower() == "statisticscodename")
        {
            return ResHelper.GetString("analytics_codename." + ValidationHelper.GetString(parameter, ""));
        }

        return parameter.ToString();
    }


    /// <summary>
    /// Handles the UniGrid's OnAction event.
    /// </summary>
    /// <param name="actionName">Name of item (button) that throws event.</param>
    /// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
    void UniGridStatistics_OnAction(string actionName, object actionArgument)
    {
        if (DataHelper.GetNotEmpty(actionName, "") == "delete")
        {
            // Delete StatisticsInfo object from DB.
            StatisticsInfoProvider.DeleteStatisticsInfo(ValidationHelper.GetString(actionArgument, ""));
        }
    }
}
