using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.FormEngine;
using CMS.DataEngine;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_BizForms_BizForm_Edit_Data : CMSDeskPage
{
    protected int formId = 0;
    protected string formName = "";
    protected string editToolTip = "";
    protected string deleteToolTip = "";
    protected DataClassInfo dci = null;
    protected DataSet ds = null;
    protected BizFormInfo bfi = null;               

    string imagesUrl = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        // check 'ReadData' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.form", "ReadData"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.form", "ReadData");
        }

        imagesUrl = ResolveUrl("~/App_Themes/" + this.Page.Theme + "/Images/CMSDesk/Tools/BizForms/");
        
        //BizFormInfo bfi = null;               
        GeneralConnection genConn = null;
        //DataSet ds = null;
        string className = "";        

        // get form id from url
        formId = ValidationHelper.GetInteger(Request.QueryString["formid"], 0);

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "SelectFields", ScriptHelper.GetScript("function SelectFields() { modalDialog('" + ResolveUrl("~/CMSDesk/Tools/BizForms/BizForm_Edit_Data_SelectFields.aspx") + "?formID=" + formId + "'  ,'BizFormFields', 500, 500); }"));        

        // link inits
        lnkNewRecord.Text = ResHelper.GetString("bizform_edit_data.newrecord");
        lnkNewRecord.NavigateUrl = "BizForm_Edit_EditRecord.aspx?formID=" + formId;
        this.imgNewRecord.ImageUrl = imagesUrl + "newrecord.gif";

        lnkExportXLS.Text = ResHelper.GetString("bizform_edit_data.exporttoexcel");
        lnkExportXLS.NavigateUrl = "BizForm_Edit_Export.aspx?formID="+formId;
        this.imgExportXLS.ImageUrl = imagesUrl + "excelexport.gif";

        lnkExport2007.Text = ResHelper.GetString("bizform_edit_data.exporttoexcel2007");
        lnkExport2007.NavigateUrl = "BizForm_Edit_Export.aspx?formID=" + formId + "&office=2007";
        this.imgExport2007.ImageUrl = imagesUrl + "excelexport.gif";

        lnkSelectFields.Text = ResHelper.GetString("bizform_edit_data.selectdisplayedfields");        
        lnkSelectFields.NavigateUrl = "javascript:SelectFields();";
        this.imgSelectFields.ImageUrl = imagesUrl + "selectfields16.gif";
        

        // buttons' tooltips
        editToolTip = ResHelper.GetString("bizform_edit_data.edit");
        deleteToolTip = ResHelper.GetString("bizform_edit_data.delete");

        // delete confirmation
        ltlScript.Text = ScriptHelper.GetScript("deleteConfirmation = '" + ResHelper.GetString("BizForm_Edit_Data.DeleteConfirmation") + "';");

        // get form info
        bfi = BizFormInfoProvider.GetBizFormInfo(formId);

        //gridData.PageIndexChanging += new GridViewPageEventHandler(gridData_PageIndexChanging);

        if (bfi != null)
        {
            

            dci = DataClassInfoProvider.GetDataClass(bfi.FormClassID);
            if (dci != null)
            {
                className = dci.ClassName;
                formName = dci.ClassName;
            }

            if (className != "")
            {
                gridData.RowDataBound += new GridViewRowEventHandler(gridData_RowDataBound);
                gridData.GridLines = GridLines.Horizontal;

                // get all table data
                genConn = ConnectionHelper.GetConnection();
                ds = genConn.ExecuteQuery(className + ".selectall", null, null, null);
                gridData.DataSource = ds;

                // Set displayed columns to the gridview
                if (!IsPostBack)
                {
                    SetDisplayedColumns(ds, bfi.FormReportFields);
                }
                gridData.DataBind();
            }

        }
    }


    protected void gridData_PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        gridData.PageIndex = e.NewPageIndex;        
        gridData.DataBind();  
    }


    /// <summary>
    /// Binds command argument to the image buttons.
    /// </summary>
    protected void gridData_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        ImageButton buttonDelete = ((ImageButton)(e.Row.FindControl("btnDelete")));
        if (buttonDelete != null)
        {
            buttonDelete.CommandArgument = Convert.ToString(((DataRowView)(e.Row.DataItem))[0]);
        }

        ImageButton buttonEdit= ((ImageButton)(e.Row.FindControl("btnEdit")));
        if (buttonEdit != null)
        {
            buttonEdit.OnClientClick = "EditRecord(" + formId + ", " + Convert.ToString(((DataRowView)(e.Row.DataItem))[0]) + "); return false;";
            buttonEdit.CommandArgument = Convert.ToString(((DataRowView)(e.Row.DataItem))[0]);
        }        
    }


    /// <summary>
    /// Set displayed columns to the gridview.
    /// </summary>
    /// <param name="ds">Dataset with gridview data.</param>
    /// <param name="reportFields">String with report fields separated by ';'</param>
    protected void SetDisplayedColumns(DataSet ds, string reportFields)
    {        
        FormInfo fi = new FormInfo();        
        string fieldCaption = "";        
        string [] columnNames = null;

        if (dci != null)
        {
            // get class form definition
            fi.LoadXmlDefinition(dci.ClassFormDefinition);

            // get columns names            
            columnNames = fi.GetColumnNames();
        }

        // no field is set to be displayed -> set all fields to be dispalyed
        if ((reportFields == null) || (reportFields == ""))
        {
            if (columnNames != null)
            {
                foreach (string column in columnNames)
                {
                    reportFields += column + ";";
                }

                if (reportFields != "")
                {
                    // remove ending ';'
                    reportFields = reportFields.TrimEnd(';');
                }

                BizFormInfo bfi = BizFormInfoProvider.GetBizFormInfo(formId);
                if (bfi != null)
                {
                    // save report fields
                    bfi.FormReportFields = reportFields;
                    BizFormInfoProvider.SetBizFormInfo(bfi);
                }
            }
        }        
        FormFieldInfo ffi = null;                

        if ((ds.Tables.Count > 0) && (ds.Tables[0].Columns.Count > 0))
        {
            reportFields = ";" + reportFields.ToLower().Trim(';') + ";";

            // Go through the form fields
            foreach (string columnName in columnNames)
            {
                if ((reportFields.Contains(";" + columnName.ToLower() + ";") && (ds.Tables[0].Columns.Contains(columnName))))
                {
                    // get field caption
                    ffi = fi.GetFormField(columnName);
                    if (ffi == null)
                    {
                        fieldCaption = columnName;
                    }
                    else
                    {
                        if (ffi.Caption == "")
                        {
                            fieldCaption = columnName;
                        }
                        else
                        {
                            fieldCaption = ResHelper.LocalizeString(ffi.Caption);
                        }
                    }

                    // set column datafield and caption                    
                    BoundField column = new BoundField();
                    column.DataField = columnName;
                    column.HeaderText = fieldCaption;
                    column.ItemStyle.Wrap = false;
                    column.SortExpression = columnName;                    

                    // add column to gridview
                    gridData.Columns.Add(column);
                }
            }

            // set last column width to 100%
            if (gridData.Columns.Count > 1)
            {
                gridData.Columns[gridData.Columns.Count - 1].ItemStyle.Width = new Unit("100%");
            }
        }
        else
        {
            // hide action icons when no record is displayed
            gridData.Columns.Clear();
        }


    }


    /// <summary>
    /// Delete selected form data.
    /// </summary>
    protected void btnDelete_OnCommand(object sender, CommandEventArgs e)
    {
        // check 'DeleteData' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.form", "DeleteData"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.form", "DeleteData");
        }

        int formRecordID = Convert.ToInt32(e.CommandArgument);
        GeneralConnection genConn = ConnectionHelper.GetConnection();
        DataClass formRecord = new DataClass(this.formName, formRecordID, genConn);

        if (!(formRecord.IsEmpty()))
        {
            // Delete selected form record.
            formRecord.Delete();
            // Update number of entries in BizFormInfo
            BizFormInfo bfi = BizFormInfoProvider.GetBizFormInfo(this.formId);
            if (bfi != null)
            {
                bfi.FormItems--;
                BizFormInfoProvider.SetBizFormInfo(bfi);
            }
        }

        Response.Redirect(Page.Request.Url.ToString());
    }

    protected void gridData_sort(object sender, GridViewSortEventArgs e)
    {
        string[] direction = ViewState["sorting"] as string[];
        if (direction == null)
        {
            direction = new string[] { e.SortExpression, "ASC" };
            ViewState["sorting"] = direction;
        }
        else
        {
            if (e.SortExpression == direction[0]) //same column - reverse order
            {
                direction = new string[] { e.SortExpression, (direction[1]=="ASC")?"DESC":"ASC" };
                ViewState["sorting"] = direction;
            }
            else
            {
                direction = new string[] { e.SortExpression, "ASC" };
                ViewState["sorting"] = direction;
            }
        }
        DataSet ds = (DataSet)gridData.DataSource;
        ds.Tables[0].DefaultView.Sort = e.SortExpression + " " + direction[1];
        gridData.DataSource = ds.Tables[0].DefaultView;
        gridData.DataBind();
    }
}
