using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.FormEngine;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_BizForms_BizForm_Edit_Header : CMSDeskPage
{
    protected int formID = 0;
    protected string mCurrent = "";
    protected int classID = 0;

    protected void Page_Load(object sender, EventArgs e)
    {

        if (DataHelper.GetNotEmpty(this.Request.QueryString["formID"], "") != "")
        {
            formID = Convert.ToInt32(this.Request.QueryString["formID"]);
            BizFormInfo mBizForm = BizFormInfoProvider.GetBizFormInfo(formID);
            if (mBizForm != null)
            {
                mCurrent = mBizForm.FormDisplayName;
                classID = mBizForm.FormClassID;
            }
        }
    
        if (!IsPostBack)
            this.InitalizeMenu();

        // initializes page title
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = ResHelper.GetString("BizForm.BizForms");
        pageTitleTabs[0, 1] = "~/CMSDesk/Tools/BizForms/BizForm_List.aspx";
        pageTitleTabs[0, 2] = "toolsmain";
        pageTitleTabs[1, 0] = mCurrent;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;
        PageTitle.TitleText = ResHelper.GetString("BizFormHeader.Title");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/BizForms/bizform.gif";
        
    }

    /// <summary>
    /// Initializes edit menu
    /// </summary>
    protected void InitalizeMenu()
    {
        bool isGeneralTabDisplayed = false;
        BasicTabControlMenu.Tabs = new string[5, 4];

        // check 'ReadForm' permission
        if (CMSContext.CurrentUser.IsAuthorizedPerResource("cms.form", "ReadForm"))
        {
            isGeneralTabDisplayed = true;
            BasicTabControlMenu.Tabs[0, 0] = ResHelper.GetString("General.General");
            BasicTabControlMenu.Tabs[0, 2] = "BizForm_Edit_General.aspx?formID=" + formID;
            BasicTabControlMenu.Tabs[1, 0] = ResHelper.GetString("BizForm.Fields");
            BasicTabControlMenu.Tabs[1, 2] = "BizForm_Edit_Fields.aspx?formID=" + formID;
            BasicTabControlMenu.Tabs[2, 0] = ResHelper.GetString("BizForm.Layout");
            BasicTabControlMenu.Tabs[2, 2] = "../../../cmssitemanager/development/DocumentTypes/DocumentType_Edit_Form.aspx?formclassid=" + classID;
            BasicTabControlMenu.Tabs[3, 0] = ResHelper.GetString("BizForm.Autoresponder");
            BasicTabControlMenu.Tabs[3, 2] = "BizForm_Edit_Autoresponder.aspx?formID=" + formID;

        }

        
        // check 'ReadData' permission
        if (CMSContext.CurrentUser.IsAuthorizedPerResource("cms.form", "ReadData"))
        {
            BasicTabControlMenu.Tabs[4, 0] = ResHelper.GetString("BizForm.Data");
            BasicTabControlMenu.Tabs[4, 2] = "BizForm_Edit_Data.aspx?formID=" + formID;
            if (!isGeneralTabDisplayed)
            {
                BasicTabControlMenu.SelectedTab = 4;
            }
        }



        BasicTabControlMenu.UrlTarget = "BizFormContent";
    }
}
