using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using CMS.CMSHelper;
using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.Ecommerce;

public partial class CMSDesk_Tools_Ecommerce_Configuration_PaymentOption_List : CMSDeskPage
{
    int siteId = 0;
        
    protected void Page_Load(object sender, EventArgs e)
    {
        // check 'EcommerceRead' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Ecommerce", "ConfigurationRead"))
        {
            CMSDeskPage.RedirectToAccessDenied("CMS.Ecommerce", "ConfigurationRead");
        }

        siteId = CMSContext.CurrentSite.SiteID;

        PageTitle.TitleText = ResHelper.GetString("PaymentOption_List.HeaderCaption");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/Configuration/PaymentOptions/payment.gif";
        imgNewItem.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/Configuration/PaymentOptions/addpayment.gif";

        


        UniGrid.OnAction += new OnActionEventHandler(uniGrid_OnAction);
        UniGrid.GridView.GridLines = GridLines.Horizontal;
        UniGrid.DataSource = PaymentOptionInfoProvider.GetAllPaymentsForSite(siteId, StatusEnum.Both);

        lnkNewItem.Text = ResHelper.GetString("PaymentOption_List.NewItemCaption");
    }


    /// <summary>
    /// Handles the UniGrid's OnAction event.
    /// </summary>
    /// <param name="actionName">Name of item (button) that throws event.</param>
    /// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
    protected void uniGrid_OnAction(string actionName, object actionArgument)
    {
        if (actionName == "edit")
        {
            Response.Redirect("PaymentOption_Edit.aspx?paymentOptionId=" + Convert.ToString(actionArgument));
        }
        else if (actionName == "delete")
        {
            // check 'ConfigurationModify' permission
            if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Ecommerce", "ConfigurationModify"))
            {
                CMSDeskPage.RedirectToAccessDenied("CMS.Ecommerce", "ConfigurationModify");
            }

            if (PaymentOptionInfoProvider.CheckDependencies(ValidationHelper.GetInteger(actionArgument, 0)))
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("Ecommerce.DeleteDisabled");
                return;
            }

            // delete PaymentOptionInfo object from database
            PaymentOptionInfoProvider.DeletePaymentOptionInfo(ValidationHelper.GetInteger(actionArgument, 0));

            UniGrid.DataSource = PaymentOptionInfoProvider.GetAllPaymentsForSite(siteId, StatusEnum.Both);
            UniGrid.ReloadData();
        }
    }


}
