using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Ecommerce;

public partial class CMSDesk_Tools_Ecommerce_Configuration_TaxClass_Header : CMSDeskPage
{
    protected int taxClassId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        taxClassId = ValidationHelper.GetInteger(Request.QueryString["taxclassid"], 0);

        if (!IsPostBack)
        {
            InitalizeMenu();
        }

        string taxClassName = "";
        TaxClassInfo tc = TaxClassInfoProvider.GetTaxClassInfo(taxClassId);
        if (tc != null)
        {
            taxClassName = tc.TaxClassDisplayName;
        }

        // initializes page title
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = ResHelper.GetString("TaxClass_Edit.ItemListLink");
        pageTitleTabs[0, 1] = "~/CMSDesk/Tools/Ecommerce/Configuration/TaxClasses/TaxClass_List.aspx";
        pageTitleTabs[0, 2] = "configEdit";
        pageTitleTabs[1, 0] = taxClassName;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;
        PageTitle.TitleText = ResHelper.GetString("TaxClass_Edit.HeaderCaption-Properties");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/Configuration/TaxClasses/taxclass.gif";
    }

    /// <summary>
    /// Initializes edit menu
    /// </summary>
    protected void InitalizeMenu()
    {
        BasicTabControlMenu.Tabs = new string[3, 4];
        BasicTabControlMenu.Tabs[0, 0] = ResHelper.GetString("General.General");
        BasicTabControlMenu.Tabs[0, 2] = "TaxClass_General.aspx?taxclassid=" + taxClassId.ToString();
        BasicTabControlMenu.Tabs[1, 0] = ResHelper.GetString("TaxClass_Edit.Countries");
        BasicTabControlMenu.Tabs[1, 2] = "TaxClass_Country.aspx?taxclassid=" + taxClassId.ToString();
        BasicTabControlMenu.Tabs[2, 0] = ResHelper.GetString("TaxClass_Edit.Header.States");
        BasicTabControlMenu.Tabs[2, 2] = "TaxClass_State.aspx?taxclassid=" + taxClassId.ToString();
        BasicTabControlMenu.UrlTarget = "taxClassContent";
    }
}
