using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.DataEngine;
using CMS.SiteProvider;
using CMS.Ecommerce;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Ecommerce_Configuration_TaxClass_New : CMSDeskPage
{
    protected int taxclassid = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // check 'EcommerceRead' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Ecommerce", "ConfigurationRead"))
        {
            CMSDeskPage.RedirectToAccessDenied("CMS.Ecommerce", "ConfigurationRead");
        }

        rfvTaxClassDisplayName.ErrorMessage = ResHelper.GetString("TaxClass_Edit.PleaseInsertDisplayName");
        rfvTaxClassName.ErrorMessage = ResHelper.GetString("TaxClass_Edit.PleaseInsertName");

        // control initializations				
        lblTaxClassDisplayName.Text = ResHelper.GetString("TaxClass_Edit.TaxClassDisplayNameLabel");
        lblTaxClassName.Text = ResHelper.GetString("TaxClass_Edit.TaxClassNameLabel");
        lblTaxZero.Text = ResHelper.GetString("TaxClass_Edit.lblTaxZero");

        btnOK.Text = ResHelper.GetString("General.OK");

        string currentTaxClass = ResHelper.GetString("TaxClass_Edit.NewItemCaption");

        // initializes page title control		
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = ResHelper.GetString("TaxClass_Edit.ItemListLink");
        pageTitleTabs[0, 1] = "~/CMSDesk/Tools/Ecommerce/Configuration/TaxClasses/TaxClass_List.aspx";
        pageTitleTabs[0, 2] = "";
        pageTitleTabs[1, 0] = currentTaxClass;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;
        PageTitle.TitleText = ResHelper.GetString("TaxClass_Edit.HeaderCaption_New");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/Configuration/TaxClasses/newtaxclass.gif";
    }


    /// <summary>
    /// Sets data to database.
    /// </summary>
    protected void btnOK_Click(object sender, EventArgs e)
    {
        // check 'ConfigurationModify' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Ecommerce", "ConfigurationModify"))
        {
            CMSDeskPage.RedirectToAccessDenied("CMS.Ecommerce", "ConfigurationModify");
        }

        string errorMessage = new Validator()
            .NotEmpty(txtTaxClassDisplayName.Text, ResHelper.GetString("TaxClass_Edit.PleaseInsertDisplayName"))
            .NotEmpty(txtTaxClassName.Text, ResHelper.GetString("TaxClass_Edit.PleaseInsertName")).Result;

        if (!ValidationHelper.IsCodeName(txtTaxClassName.Text))
        {
            errorMessage = ResHelper.GetString("General.ErrorCodeNameInIdentificatorFormat");
        }

        if (errorMessage == "")
        {
            TaxClassInfo taxClassObj = TaxClassInfoProvider.GetTaxClassInfo(txtTaxClassName.Text.Trim());

           														
            if (taxClassObj == null)
            {
                // if taxClassName value is unique
                taxClassObj = new TaxClassInfo();

                taxClassObj.TaxClassDisplayName = txtTaxClassDisplayName.Text.Trim();
                taxClassObj.TaxClassName = txtTaxClassName.Text.Trim();
                taxClassObj.TaxClassZeroIfIDSupplied = chkTaxZero.Checked;

                TaxClassInfoProvider.SetTaxClassInfo(taxClassObj);

                Response.Redirect("TaxClass_Frameset.aspx?taxclassid=" + Convert.ToString(taxClassObj.TaxClassID) + "&saved=1");
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("TaxClass_Edit.TaxClassNameExists");
            }

        }
        else
        {
            lblError.Visible = true;
            lblError.Text = errorMessage;
        }
    }

}
