using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.Ecommerce;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Ecommerce_Customers_Customers_List : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // check 'EcommerceRead' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Ecommerce", "EcommerceRead"))
        {
            CMSDeskPage.RedirectToAccessDenied("CMS.Ecommerce", "EcommerceRead");
        }

        PageTitle.TitleText = ResHelper.GetString("Customers_List.HeaderCaption");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/Customers/customers.gif";
        imgNewItem.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/Customers/addcustomer.gif";

        //UniGrid.DataSource = CustomerInfoProvider.GetCustomersList();
        UniGrid.OnAction += new OnActionEventHandler(uniGrid_OnAction);
        UniGrid.OnDataReload += new OnDataReload(UniGrid_OnDataReload);
        UniGrid.GridView.GridLines = GridLines.Horizontal;
        
        lnkNewItem.Text = ResHelper.GetString("Customers_List.NewItemCaption");
    }

    DataSet UniGrid_OnDataReload(string completeWhere)
    {
        return CustomerInfoProvider.GetCustomersList(completeWhere, null);
    }

   
    /// <summary>
    /// Handles the UniGrid's OnAction event.
    /// </summary>
    /// <param name="actionName">Name of item (button) that throws event.</param>
    /// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
    protected void uniGrid_OnAction(string actionName, object actionArgument)
    {
        if (actionName == "edit")
        {
            Response.Redirect("Customer_Edit_Frameset.aspx?customerid=" + Convert.ToString(actionArgument));
        }
        else if (actionName == "delete")
        {
            // check 'EcommerceModify' permission
            if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Ecommerce", "EcommerceModify"))
            {
                CMSDeskPage.RedirectToAccessDenied("CMS.Ecommerce", "EcommerceModify");
            }

            if (CustomerInfoProvider.CheckDependencies(ValidationHelper.GetInteger(actionArgument, 0)))
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("Ecommerce.DeleteDisabled");
                return;
            }

            // delete CustomerInfo object from database
            CustomerInfoProvider.DeleteCustomerInfo(ValidationHelper.GetInteger(actionArgument, 0));

            UniGrid.ReloadData();
        }
    }
}
