using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Ecommerce;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Ecommerce_DiscountCoupon_Discount_New : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // check 'EcommerceRead' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Ecommerce", "EcommerceRead"))
        {
            CMSDeskPage.RedirectToAccessDenied("CMS.Ecommerce", "EcommerceRead");
        }

        rfvCouponCode.ErrorMessage = ResHelper.GetString("DiscounCoupon_Edit.errorCode");
        rfvDisplayName.ErrorMessage = ResHelper.GetString("DiscounCoupon_Edit.errorDisplay");
        rvDiscountCouponValue.ErrorMessage = ResHelper.GetString("DiscountCoupon_Edit.errorValue");

        // control initializations				
        lblDiscountCouponCode.Text = ResHelper.GetString("DiscounCoupon_Edit.DiscountCouponCodeLabel");
        lblDiscountCouponDisplayName.Text = ResHelper.GetString("DiscounCoupon_Edit.DiscountCouponDisplayNameLabel");
        btnOK.Text = ResHelper.GetString("General.OK");

        
        lblDiscountCouponValidTo.Text = ResHelper.GetString("DiscounCoupon_Edit.DiscountCouponValidToLabel");
        lblDiscountCouponValidFrom.Text = ResHelper.GetString("DiscounCoupon_Edit.DiscountCouponValidFromLabel");
        lblDiscountCouponCode.Text = ResHelper.GetString("DiscounCoupon_Edit.DiscountCouponCodeLabel");
        lblDiscountCouponValue.Text = ResHelper.GetString("DiscounCoupon_Edit.DiscountCouponAbsoluteValueLabel");

        radFixed.Text = ResHelper.GetString("DiscounCoupon_Edit.radFixed");
        radPercentage.Text = ResHelper.GetString("DiscounCoupon_Edit.radPercentage");

        rfvCouponCode.ErrorMessage = ResHelper.GetString("DiscounCoupon_Edit.errorCode");

        dtPickerDiscountCouponValidTo.SupportFolder = "~/CMSAdminControls/Calendar";
        dtPickerDiscountCouponValidFrom.SupportFolder = "~/CMSAdminControls/Calendar";

        string currentDiscountCoupon = ResHelper.GetString("DiscounCoupon_Edit.NewItemCaption");

        // initializes page title control		
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = ResHelper.GetString("DiscounCoupon_Edit.ItemListLink");
        pageTitleTabs[0, 1] = "~/CMSDesk/Tools/Ecommerce/DiscountCoupon/Discount_List.aspx";
        pageTitleTabs[0, 2] = "";
        pageTitleTabs[1, 0] = currentDiscountCoupon;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;
        PageTitle.TitleText = ResHelper.GetString("DiscounCoupon_New.HeaderCaption");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/DiscountCoupon/newcoupon.gif";
    }

    /// <summary>
    /// Sets data to database.
    /// </summary>
    protected void btnOK_Click(object sender, EventArgs e)
    {
        // check 'EcommerceModify' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Ecommerce", "EcommerceModify"))
        {
            CMSDeskPage.RedirectToAccessDenied("CMS.Ecommerce", "EcommerceModify");
        }

        string errorMessage = new Validator().NotEmpty(txtDiscountCouponDisplayName.Text, ResHelper.GetString("DiscounCoupon_Edit.errorDisplay")).NotEmpty(txtDiscountCouponCode.Text, ResHelper.GetString("DiscounCoupon_Edit.errorCode")).Result;

        if (errorMessage == "")
        {

            // discountCouponCode must to be unique
            DiscountCouponInfo discountCouponObj = DiscountCouponInfoProvider.GetDiscountCouponInfo(txtDiscountCouponCode.Text.Trim());

            // if discountCouponCode value is unique														
            if ((discountCouponObj == null))
            {
                // create new item -> insert
                discountCouponObj = new DiscountCouponInfo();

                discountCouponObj.DiscountCouponCode = txtDiscountCouponCode.Text.Trim();
                discountCouponObj.DiscountCouponDisplayName = txtDiscountCouponDisplayName.Text.Trim();
                discountCouponObj.DiscountCouponIsExcluded = false;

                discountCouponObj.DiscountCouponIsFlatValue = true;

                if (radPercentage.Checked)
                {
                    discountCouponObj.DiscountCouponIsFlatValue = false;
                }

                discountCouponObj.DiscountCouponValue = ValidationHelper.GetDouble(txtDiscountCouponValue.Text.Trim(), 0.0);
                discountCouponObj.DiscountCouponCode = txtDiscountCouponCode.Text.Trim();
                discountCouponObj.DiscountCouponValidFrom = dtPickerDiscountCouponValidFrom.SelectedDateTime;
                discountCouponObj.DiscountCouponValidTo = dtPickerDiscountCouponValidTo.SelectedDateTime;

                DiscountCouponInfoProvider.SetDiscountCouponInfo(discountCouponObj);

                Response.Redirect("Discount_Edit_Frameset.aspx?discountid=" + Convert.ToString(discountCouponObj.DiscountCouponID) + "&saved=1");
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("DiscounCoupon_Edit.DiscountCouponCodeExists");
            }

        }
        else
        {
            lblError.Visible = true;
            lblError.Text = errorMessage;
        }
    }
}
