using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.DataEngine;
using CMS.SiteProvider;
using CMS.Ecommerce;


public partial class CMSDesk_Tools_Ecommerce_DiscountLevel_DiscountLevel_Edit : CMSDeskPage
{
	protected int discountLevelId = 0;
	
	protected void Page_Load(object sender, EventArgs e)
	{
		// TODO : Required field validator error messages initialization
				
		// control initializations				
		lblDiscountLevelValidFrom.Text = ResHelper.GetString("DiscountLevel_Edit.DiscountLevelValidFromLabel");
		lblDiscountLevelEnabled.Text = ResHelper.GetString("DiscountLevel_Edit.DiscountLevelEnabledLabel");
		lblDiscountLevelName.Text = ResHelper.GetString("DiscountLevel_Edit.DiscountLevelNameLabel");
		lblDiscountLevelValue.Text = ResHelper.GetString("DiscountLevel_Edit.DiscountLevelValueLabel");
		lblDiscountLevelValidTo.Text = ResHelper.GetString("DiscountLevel_Edit.DiscountLevelValidToLabel");
		lblDiscountLevelDisplayName.Text = ResHelper.GetString("DiscountLevel_Edit.DiscountLevelDisplayNameLabel");
        // Init Validators
        rfvDiscountLevelDisplayName.ErrorMessage = ResHelper.GetString("DiscountLevel_Edit.rfvDiscountLevelDisplayName.ErrorMessage");
        rfvDiscountLevelName.ErrorMessage = ResHelper.GetString("DiscountLevel_Edit.rfvDiscountLevelName.ErrorMessage");
        rfvDiscountLevelValue.ErrorMessage = ResHelper.GetString("DiscountLevel_Edit.rfvDiscountLevelValue.ErrorMessage");
        rvDiscountLevelValue.ErrorMessage = ResHelper.GetString("DiscountLevel_Edit.rvDiscountLevelValue.ErrorMessage");


		btnOK.Text = ResHelper.GetString("General.OK");	
		dtPickerDiscountLevelValidFrom.SupportFolder = "~/CMSAdminControls/Calendar";
		dtPickerDiscountLevelValidTo.SupportFolder = "~/CMSAdminControls/Calendar";

		string currentDiscountLevel = ResHelper.GetString("DiscountLevel_Edit.NewItemCaption");

		// get discountlLevel id from querystring		
        discountLevelId = ValidationHelper.GetInteger(Request.QueryString["discountLevelId"], 0);
        // edit existing
        if (discountLevelId > 0)
        {
            // check if there isnt already duplicate entry
            DiscountLevelInfo discountLevelObj = DiscountLevelInfoProvider.GetDiscountLevelInfo(discountLevelId);
            if (discountLevelObj != null)
            {
                currentDiscountLevel = discountLevelObj.DiscountLevelDisplayName;

                // fill editing form
                if (!IsPostBack)
                {
                    LoadData(discountLevelObj);

                    // show that the discountlLevel was created or updated successfully
                    if (ValidationHelper.GetString(Request.QueryString["saved"], "") == "1")
                    {
                        lblInfo.Visible = true;
                        lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
                    }
                }
            }
            // Set page title to "edit poperties"
            PageTitle.TitleText = ResHelper.GetString("DiscountLevel_Edit.HeaderCaption");
            PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/DiscountLevel/discountlevel.gif";
        }
        // Edit new
        else
        {
            // Set page title to "New item"
            PageTitle.TitleText = ResHelper.GetString("DiscountLevel_Edit.NewItemCaption");
            PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/DiscountLevel/newdiscountlevel.gif";
            // Set default value to enabled
            chkDiscountLevelEnabled.Checked = true;
        }

		// initializes page title control		
		string[,] pageTitleTabs = new string[2, 3];
		pageTitleTabs[0, 0] = ResHelper.GetString("DiscountLevel_Edit.ItemListLink");
		pageTitleTabs[0, 1] = "~/CMSDesk/Tools/Ecommerce/DiscountLevel/DiscountLevel_List.aspx";
		pageTitleTabs[0, 2] = "";
		pageTitleTabs[1, 0] = currentDiscountLevel;
		pageTitleTabs[1, 1] = "";
		pageTitleTabs[1, 2] = "";
		PageTitle.Breadcrumbs = pageTitleTabs;
		
	}


	/// <summary>
	/// Load data of editing discountLevel.
	/// </summary>
	/// <param name="discountlLevelObj">DiscountLevel object.</param>
	protected void LoadData(DiscountLevelInfo discountLevelObj)
	{
	
		dtPickerDiscountLevelValidFrom.SelectedDateTime = discountLevelObj.DiscountLevelValidFrom;
		chkDiscountLevelEnabled.Checked = discountLevelObj.DiscountLevelEnabled;
		txtDiscountLevelName.Text = discountLevelObj.DiscountLevelName;
		txtDiscountLevelValue.Text = Convert.ToString(discountLevelObj.DiscountLevelValue);
		dtPickerDiscountLevelValidTo.SelectedDateTime = discountLevelObj.DiscountLevelValidTo;
		txtDiscountLevelDisplayName.Text = discountLevelObj.DiscountLevelDisplayName;

	 }

	/// <summary>
	/// Sets data to database.
	/// </summary>
	protected void btnOK_Click(object sender, EventArgs e)
	{
        string errorMessage = new Validator().NotEmpty(txtDiscountLevelDisplayName.Text, ResHelper.GetString("DiscountLevel_Edit.rfvDiscountLevelDisplayName.ErrorMessage"))
                                             .NotEmpty(txtDiscountLevelName.Text, ResHelper.GetString("DiscountLevel_Edit.rfvDiscountLevelName.ErrorMessage"))
                                             .NotEmpty(txtDiscountLevelValue.Text, ResHelper.GetString("DiscountLevel_Edit.rfvDiscountLevelValue.ErrorMessage")).Result;

        if (!ValidationHelper.IsCodeName(txtDiscountLevelName.Text))
        {
            errorMessage = ResHelper.GetString("General.ErrorCodeNameInIdentificatorFormat");
        }
        else
        {
            // from/to date validation
            if ((dtPickerDiscountLevelValidFrom.SelectedDateTime != DateTime.MinValue) &&
            (dtPickerDiscountLevelValidTo.SelectedDateTime != DateTime.MinValue) &&
            (dtPickerDiscountLevelValidFrom.SelectedDateTime >= dtPickerDiscountLevelValidTo.SelectedDateTime))
            {
                errorMessage = ResHelper.GetString("General.DateOverlaps");
            }
        }

		if (errorMessage == "")
        {

            // get discount by name
            DiscountLevelInfo discountLevelObj = DiscountLevelInfoProvider.GetDiscountLevelInfo(txtDiscountLevelName.Text.Trim());
            // if name is unique OR ids are same
            if ((discountLevelObj==null) || (discountLevelObj.DiscountLevelID == discountLevelId))
            {   
                // if name is unique
                if ((discountLevelObj==null))
                {
                   // and id not exist -> insert new
                    discountLevelObj = DiscountLevelInfoProvider.GetDiscountLevelInfo(discountLevelId);
                   if (discountLevelObj == null)
                   {
                       // Create new DiscountLevelInfo
                        discountLevelObj = new DiscountLevelInfo();
                   }
                }

                // Set values
                discountLevelObj.DiscountLevelValidFrom = dtPickerDiscountLevelValidFrom.SelectedDateTime;
                discountLevelObj.DiscountLevelEnabled = chkDiscountLevelEnabled.Checked;
                discountLevelObj.DiscountLevelName = txtDiscountLevelName.Text.Trim();
                discountLevelObj.DiscountLevelValue = Convert.ToDouble(txtDiscountLevelValue.Text.Trim());
                discountLevelObj.DiscountLevelValidTo = dtPickerDiscountLevelValidTo.SelectedDateTime;
                discountLevelObj.DiscountLevelDisplayName = txtDiscountLevelDisplayName.Text.Trim();

                DiscountLevelInfoProvider.SetDiscountLevelInfo(discountLevelObj);

                Response.Redirect("DiscountLevel_Edit.aspx?discountLevelId=" + Convert.ToString(discountLevelObj.DiscountLevelID) + "&saved=1");
            }
            else 
            {
				lblError.Visible = true;
				lblError.Text = ResHelper.GetString("DiscountLevel_Edit.DiscountLevelNameExists");
			}
        }
		else
		{
			lblError.Visible = true;
			lblError.Text = errorMessage;
		}
	}
}
