using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.Ecommerce;


public partial class CMSDesk_Tools_Ecommerce_DiscountLevel_DiscountLevel_List : CMSDeskPage
{
	protected void Page_Load(object sender, EventArgs e)
	{

		PageTitle.TitleText = ResHelper.GetString("DiscountLevel_List.HeaderCaption");
		PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/DiscountLevel/discountlevels.gif";
		imgNewItem.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/DiscountLevel/adddiscountlevel.gif";
        // Set unigrid properties
		UniGrid.OnAction += new OnActionEventHandler(uniGrid_OnAction);
        UniGrid.OnExternalDataBound += new OnExternalDataBoundEventHandler(UniGrid_OnExternalDataBound);
		UniGrid.GridView.GridLines = GridLines.Horizontal;

		lnkNewItem.Text = ResHelper.GetString("DiscountLevel_List.NewItemCaption");
	}


    object UniGrid_OnExternalDataBound(object sender, string sourceName, object parameter)
    {
        switch (sourceName.ToLower())
        {
            case "discountvalue":
                DataRowView row = (DataRowView)parameter;
                double value = ValidationHelper.GetDouble(row["DiscountLevelValue"], 0);
                return value.ToString() + "%";
        }
        return parameter;
    }


	/// <summary>
	/// Handles the UniGrid's OnAction event.
	/// </summary>
	/// <param name="actionName">Name of item (button) that throws event.</param>
	/// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
	protected void uniGrid_OnAction(string actionName, object actionArgument)
	{
		if (actionName == "edit")
		{
			Response.Redirect("DiscountLevel_Edit.aspx?discountLevelId=" + Convert.ToString(actionArgument));
		}
		else if (actionName == "delete")
		{
			// delete DiscountlLevelInfo object from database
			DiscountLevelInfoProvider.DeleteDiscountLevelInfo(Convert.ToInt32(actionArgument));
		}
	}
}
