using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Ecommerce_Header : CMSDeskPage
{
    protected void Page_PreInit(object sender, EventArgs e)
    {
        BasicTabControlMenu.SelectedTab = ValidationHelper.GetInteger(Request.QueryString["selectedtab"], 0);
        if (BasicTabControlMenu.SelectedTab == 7)
        {
            pnlLeft.SkinID = "TabsLeftEcommConfig";
            pnlRight.SkinID = "TabsRightEcommConfig";
        }
        else
        {
            pnlLeft.SkinID = "TabsLeft";
            pnlRight.SkinID = "TabsRight";
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        PageTitle.TitleText = ResHelper.GetString("Ecomerce.HeaderCaption");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/ecommercemodule.gif";

        if (!IsPostBack)
        {
            InitalizeMenu();
        }
    }

    /// <summary>
    /// Initializes menu
    /// </summary>
    protected void InitalizeMenu()
    {
        BasicTabControlMenu.Tabs = new string[8, 4];
        BasicTabControlMenu.Tabs[0, 0] = ResHelper.GetString("Ecommerce.Orders");
        BasicTabControlMenu.Tabs[0, 2] = "Orders/Order_List.aspx";
        BasicTabControlMenu.Tabs[1, 0] = ResHelper.GetString("Ecommerce.Customers");
        BasicTabControlMenu.Tabs[1, 2] = "Customers/Customer_List.aspx";
        BasicTabControlMenu.Tabs[2, 0] = ResHelper.GetString("Ecommerce.Products");
        BasicTabControlMenu.Tabs[2, 2] = "Products/Product_List.aspx";
        BasicTabControlMenu.Tabs[3, 0] = ResHelper.GetString("Ecommerce.Manufacturers");
        BasicTabControlMenu.Tabs[3, 2] = "Manufacturers/Manufacturer_List.aspx";
        BasicTabControlMenu.Tabs[4, 0] = ResHelper.GetString("Ecommerce.Suppliers");
        BasicTabControlMenu.Tabs[4, 2] = "Suppliers/supplier_list.aspx";
        BasicTabControlMenu.Tabs[5, 0] = ResHelper.GetString("Ecommerce.Discounts");
        BasicTabControlMenu.Tabs[5, 2] = "DiscountCoupon/Discount_List.aspx";
        BasicTabControlMenu.Tabs[6, 0] = ResHelper.GetString("Ecommerce.DiscountLevels");
        BasicTabControlMenu.Tabs[6, 2] = "DiscountLevel/DiscountLevel_List.aspx";
        BasicTabControlMenu.Tabs[7, 0] = ResHelper.GetString("Ecommerce.Configuration");
        BasicTabControlMenu.Tabs[7, 2] = "Configuration/Configuration_Frameset.aspx";

        BasicTabControlMenu.UrlTarget = "ecommerceContent";
    }
}
