using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Ecommerce;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Ecommerce_Orders_Order_Edit_Invoice : CMSDeskPage
{
    int orderId = 0;
    OrderInfo order = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        // check 'EcommerceRead' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Ecommerce", "EcommerceRead"))
        {
            CMSDeskPage.RedirectToAccessDenied("CMS.Ecommerce", "EcommerceRead");
        }

        // Register the dialog script
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);

        lblInvoiceNumber.Text = ResHelper.GetString("order_invoice.lblInvoiceNumber");
        btnGenerate.Text = ResHelper.GetString("order_invoice.btnGenerate");
        btnPrintPreview.Text = ResHelper.GetString("order_invoice.btnPrintPreview");

        if (ValidationHelper.GetInteger(Request.QueryString["orderid"], 0) != 0)
        {
            orderId = ValidationHelper.GetInteger(Request.QueryString["orderid"], 0);
        }
        order = OrderInfoProvider.GetOrderInfo(orderId);
        
        if (order == null)
        {
            btnGenerate.Enabled = false;
            btnPrintPreview.Enabled = false;
            return;
        }

        ltlScript.Text = ScriptHelper.GetScript("function showPrintPreview() { modalDialog('Order_Edit_InvoicePrint.aspx?orderid=" + orderId.ToString() + "', 'InvoicePrint', 650, 700);}");

        if (!IsPostBack)
        {
            txtInvoiceNumber.Text = order.OrderInvoiceNumber;
            lblInvoice.Text = order.OrderInvoice;
        }
    }

    protected void btnGenerate_Click1(object sender, EventArgs e)
    {
        // check 'EcommerceModify' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Ecommerce", "EcommerceModify"))
        {
            CMSDeskPage.RedirectToAccessDenied("CMS.Ecommerce", "EcommerceModify");
        }

        order.OrderInvoiceNumber = txtInvoiceNumber.Text;
        OrderInfoProvider.SetOrderInfo(order);
        if (CMSContext.CurrentSite != null)
        {
            lblInvoice.Text = OrderInfoProvider.GetInvoice(orderId, CMSContext.CurrentSite.SiteID, CMSContext.CurrentSite.SiteDefaultCountryID);
            order.OrderInvoice = lblInvoice.Text;
            OrderInfoProvider.SetOrderInfo(order);

            lblInfo.Visible = true;
            lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
        }
    }
}
