using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Ecommerce;

public partial class CMSDesk_Tools_Ecommerce_Products_Product_Edit_Header : CMSDeskPage
{
    protected int productId = 0;

    protected void Page_PreInit(object sender, EventArgs e)
    {
        int hideBreadcrumbs = ValidationHelper.GetInteger(Request.QueryString["hidebreadcrumbs"], 0);

        if (hideBreadcrumbs == 1)
        {
            pnlTitle.SkinID = "PageTitle";
        }
        else
        {
            pnlTitle.SkinID = "TabsPageTitle";
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {

        string currentProduct= "";
        productId = ValidationHelper.GetInteger(Request.QueryString["productId"], 0);
        if (productId > 0)
        {
            SKUInfo productInfoObj = SKUInfoProvider.GetSKUInfo(productId);

            if (productInfoObj != null)
            {
                currentProduct = productInfoObj.SKUName;
            }
        }

        int hideBreadcrumbs = ValidationHelper.GetInteger(Request.QueryString["hidebreadcrumbs"], 0);

        if (hideBreadcrumbs == 0)
        {
            // initializes page title control		
            string[,] pageTitleTabs = new string[2, 3];
            pageTitleTabs[0, 0] = ResHelper.GetString("Product_Edit_Header.ItemListLink");
            pageTitleTabs[0, 1] = "~/CMSDesk/Tools/Ecommerce/Products/Product_List.aspx";
            pageTitleTabs[0, 2] = "ecommerceContent";
            pageTitleTabs[1, 0] = currentProduct;
            pageTitleTabs[1, 1] = "";
            pageTitleTabs[1, 2] = "";
            PageTitle.Breadcrumbs = pageTitleTabs;
        }
        PageTitle.TitleText = ResHelper.GetString("Product_Edit_Header.HeaderCaption");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/Products/Product.gif";

        BasicTabControlMenu.Tabs = new string[3, 4];
        BasicTabControlMenu.Tabs[0, 0] = ResHelper.GetString("Product_Edit_Header.General");
        BasicTabControlMenu.Tabs[0, 2] = "Product_Edit_General.aspx?productId=" + productId.ToString();
        BasicTabControlMenu.Tabs[1, 0] = ResHelper.GetString("Product_Edit_Header.Tax");
        BasicTabControlMenu.Tabs[1, 2] = "Product_Edit_Tax.aspx?productId=" + productId.ToString();
        BasicTabControlMenu.Tabs[2, 0] = ResHelper.GetString("Product_Edit_Header.VolumeDiscounts");
        BasicTabControlMenu.Tabs[2, 2] = "Product_Edit_VolumeDiscount_List.aspx?productId=" + productId.ToString();

        BasicTabControlMenu.UrlTarget = "ProductContent";
    }
}
