using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.Ecommerce;

public partial class CMSDesk_Tools_Ecommerce_Products_Product_Edit_VolumeDiscount_List : CMSDeskPage
{
    private string productID = "";    
    
    protected void Page_Load(object sender, EventArgs e)
	{
        // Get parameters from URL
        productID = ValidationHelper.GetString(Request.QueryString["productID"], "");

        // Set unigrid properties
        SetUnigridProperties();
        
        // Set URL of new volume discount editing page
        lnkNewItem.NavigateUrl = "Product_Edit_VolumeDiscount_Edit.aspx?ProductID=" + productID;
		lnkNewItem.Text = ResHelper.GetString("Product_Edit_VolumeDiscount_List.NewItemCaption");
        imgNewItem.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Ecommerce/Products/addvolumediscount.gif";
   	}


	/// <summary>
	/// Handles the UniGrid's OnAction event.
	/// </summary>
	/// <param name="actionName">Name of item (button) that throws event.</param>
	/// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
	protected void UniGrid_OnAction(string actionName, object actionArgument)
	{
		if (actionName.ToLower()  == "edit")
		{
			Response.Redirect("Product_Edit_VolumeDiscount_Edit.aspx?productID=" + productID + "&volumeDiscountID=" + Convert.ToString(actionArgument));
		}
		else if (actionName.ToLower() == "delete")
		{
			// delete VolumeDiscountInfo object from database
			VolumeDiscountInfoProvider.DeleteVolumeDiscountInfo(Convert.ToInt32(actionArgument));
		}
	}


    /// <summary>
    /// Handles the UniGrid's OnExternalDataBound event.
    /// </summary>
    /// <param name="sender">Sender.</param>
    /// <param name="sourceName">Source name.</param>
    /// <param name="parameter">Parameter.</param>
    protected object UniGrid_OnExternalDataBound(object sender, string sourceName, object parameter)
    {
        switch (sourceName.ToLower())
        {
            case "discountvalue":
                DataRowView row = (DataRowView)parameter;
                double value = ValidationHelper.GetDouble(row["VolumeDiscountValue"], 0);
                bool isFlat = ValidationHelper.GetBoolean(row["VolumeDiscountIsFlatValue"], false);
                // If value is relative, add "%" next to the value.
                if (isFlat)
                {
                    CurrencyInfo ci = CurrencyInfoProvider.GetMainCurrency();
                    return CurrencyInfoProvider.GetFormatedPrice(value, ci);
                }
                else
                {
                    return value.ToString() + "%";
                }
        }
        return parameter;
    }


    protected void SetUnigridProperties()
    {
        // Set action handler
        UniGrid.OnAction += new OnActionEventHandler(UniGrid_OnAction);

        // Set ExternalDataBound handler
        UniGrid.OnExternalDataBound += new OnExternalDataBoundEventHandler(UniGrid_OnExternalDataBound);
        UniGrid.GridView.GridLines = GridLines.Horizontal;

        // Set Unigrid query parameters
        object[,] parameters = new object[1, 3];
        parameters[0, 0] = "@VolumeDiscountSKUID";
        parameters[0, 1] = productID;
        UniGrid.QueryParameters = parameters;

        // Set query condition
        UniGrid.WhereCondition = "VolumeDiscountSKUID=@VolumeDiscountSKUID";

        // Set where condition
        UniGrid.OrderBy = "VolumeDiscountMinCount ASC";
    }

}
