using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.DataEngine;
using CMS.Newsletter;
using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Newsletters_Newsletters_Newsletter_AddSubscriber : CMSDeskPage
{
    protected int newsletterId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        newsletterId = ValidationHelper.GetInteger(Request.QueryString["newsletterid"], 0);

        PageTitleAddSubscriber.TitleText = ResHelper.GetString("Newsletter_Subscribers.AddSubscriber");
        PageTitleAddSubscriber.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Newsletters/Newsletters/addsubscriber.gif";
        btnSearch.Text = ResHelper.GetString("Newsletter_Subscribers.Search");
        btnAddSubscriber.Text = ResHelper.GetString("Newsletter_Subscribers.AddSubscriber");
        lblTextToSearch.Text = ResHelper.GetString("Newsletter_Subscribers.TextToSearch");
        lblSendConfirmation.Text = ResHelper.GetString("Newsletter_Subscribers.SendConfirmation");

        if (newsletterId == 0)
        {
            btnSearch.Enabled = false;
            btnAddSubscriber.Enabled = false;
            chkSendConfirmation.Enabled = false;
            return;
        }
        if (!IsPostBack)
        {
            chkSendConfirmation.Checked = false;
        }
    }

    /// <summary>
    /// Search all subscribers data for given text string
    /// </summary>
    /// <param name="sender">Sender</param>
    /// <param name="e">Event argument</param>
    protected void btnSearch_Click(object sender, EventArgs e)
    {
        if (newsletterId > 0)
        {
            Newsletter news = NewsletterProvider.GetNewsletter(newsletterId);
            if (news != null)
            {
                GeneralConnection cn = ConnectionHelper.GetConnection();
                DataSet ds = null;

                int siteId = news.NewsletterSiteID;
                // find all roles whose name contains specified string
                string filter = txtTextToSearch.Text.Replace("'", "''");
                ds = cn.ExecuteQuery("newsletter.subscriber.selectall", null, "((SubscriberEmail LIKE '%" + filter + "%' OR SubscriberFirstName LIKE '%" + filter + "%' OR SubscriberLastName LIKE '%" + filter + "%' " + ") AND SubscriberSiteID = " + siteId.ToString() + ")", "SubscriberLastName");

                //DataRow dr = null;
                if ((ds != null) && (ds.Tables.Count > 0) && (ds.Tables[0].Rows.Count > 0))
                {
                    lstSubscribers.Items.Clear();
                    foreach (System.Data.DataRow subscriberRow in ds.Tables[0].Rows)
                    {
                        ListItem li = new ListItem(System.Convert.ToString(subscriberRow["SubscriberLastName"]) + ", " + System.Convert.ToString(subscriberRow["SubscriberFirstName"]) + " (" + System.Convert.ToString(subscriberRow["SubscriberEmail"]) + ")", System.Convert.ToString(subscriberRow["SubscriberID"]));
                        lstSubscribers.Items.Add(li);
                    }
                }
                else
                {
                    lstSubscribers.Items.Clear();
                }
            }
        }
    }

    /// <summary>
    /// Subscribe subscriber selected in lstSubscribers to current role.
    /// </summary>
    /// <param name="sender">Sender</param>
    /// <param name="e">Event argument</param>
    protected void btnAddSubscriber_Click(object sender, EventArgs e)
    {
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.newsletter", "configure"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.newsletter", "configure");
        }
        if (lstSubscribers.SelectedIndex > -1)
        {
            int subscriberId = 0; 
            for (int i = lstSubscribers.SelectedIndex; i < lstSubscribers.Items.Count; i++)
            {
                if (lstSubscribers.Items[i].Selected)
                {
                    subscriberId = Convert.ToInt32(lstSubscribers.Items[i].Value);
                    if ((subscriberId > 0) && (newsletterId > 0))
                    {
                        //if subscriber is subscribed, unsubscribe him
                        if (!SubscriberProvider.IsSubscribed(subscriberId, newsletterId))
                        {
                            try
                            {
                                SubscriberProvider.Subscribe(subscriberId, newsletterId, DateTime.Now, chkSendConfirmation.Checked);
                            }
                            catch { };
                        }
                    }
                }
            }
        }
        CloseWindow();
    }


    // <summary>Generates script that closes the window and refreshes the parent page.</summary>
    private void CloseWindow()
    {
        ltlScript.Text = ScriptHelper.GetScript("CloseAndRefresh();");
    } 
        
}
