using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Newsletter;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Newsletters_Newsletters_Newsletter_Issue_Edit : CMSDeskPage
{
    protected int issueId = 0;
    protected Issue issue = null;
    protected string mSave = null;
    string imagesUrl = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        imagesUrl = ResolveUrl("~/App_Themes/" + this.Page.Theme + "/Images/CMSDesk/Content/");
        this.imgSave.ImageUrl = imagesUrl + "save.gif";
        mSave = ResHelper.GetString("EditMenu.IconSave");

        lnkSave.Attributes.Add("onclick", "ClearToolbar();frames[0].SaveContent(false);return false;");

        issueId = ValidationHelper.GetInteger(Request.QueryString["issueid"], 0);
        if (issueId == 0)
        {
            return;
        }
        
        issue = IssueProvider.GetIssue(issueId);
        if (issue != null)
        {
            Newsletter news = NewsletterProvider.GetNewsletter(issue.IssueNewsletterID);
            if (news != null)
            {
                if (news.NewsletterType == "D")
                {
                    lblInfo.Visible = true;
                    lblInfo.Text = ResHelper.GetString("Newsletter_Issue_Edit.CannotBeEdited");
                    contentHeader.Visible = false;
                    contentBody.Visible = false;
                    pnlMenu.Visible = false;
                    return;
                }
                else
                {
                    contentHeader.IssueID = issueId;
                    contentBody.IssueID = issueId;
                }
            }
        }
    }


    protected override void OnPreRender(EventArgs e)
    {
        this.lblInfo.Visible = (this.lblInfo.Text != "");
        this.lblError.Visible = (this.lblError.Text != "");
        //this.pnlInfo.Visible = (this.lblInfo.Text != "") || (this.lblError.Text != ""); 
        base.OnPreRender(e);
    }


    protected void btnOK_Click(object sender, EventArgs e)
    {
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.newsletter", "authorissues"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.newsletter", "authorissues");
        }
        if (issue == null)
        {
            return;
        }

        string res = contentHeader.SaveContent(issue);
        if (res == "")
        {
                IssueProvider.SetIssue(issue);
                this.lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
        }

        if (res != "")
        {
            this.lblError.Text = res;
        }
    }
}
