using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.Newsletter;
using CMS.GlobalHelper;

public partial class CMSDesk_Tools_Newsletters_Newsletters_Newsletter_Issue_Header : CMSDeskPage
{
    protected int newsletterIssueId = 0;
    protected Issue issue = null;
    
    protected void Page_Load(object sender, EventArgs e)
    {
        // get newsletter issue id from querystring
        if ((Request.QueryString["issueid"] != null) && (Request.QueryString["issueid"] != ""))
        {
            newsletterIssueId = Convert.ToInt32(Request.QueryString["issueid"]);
        }
        if (newsletterIssueId == 0)
        {
            return;
        }
        Issue issue = IssueProvider.GetIssue(newsletterIssueId);
        if (issue == null)
        {
            return;
        }
        
        // initializes page title control		
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = ResHelper.GetString("Newsletter_Issue_List.HeaderCaption");
        pageTitleTabs[0, 1] = "~/CMSDesk/Tools/Newsletters/Newsletters/Newsletter_Issue_List.aspx?newsletterid=" + issue.IssueNewsletterID;
        pageTitleTabs[0, 2] = "newsletterContent";
        pageTitleTabs[1, 0] = issue.IssueSubject;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;
        //PageTitle.TitleText = ResHelper.GetString("Newsletter_Issue_Header.NewsletterIssueProperties");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Newsletters/Newsletters/issue.gif";

        bool isSent = (issue.IssueMailoutTime == CMS.ExtendedControls.DateTimePicker.NOT_SELECTED?false:(issue.IssueMailoutTime < DateTime.Now));

        if (isSent)
        {
            lblSent.Text = ResHelper.GetString("Newsletter_Issue_Header.AlreadySent");
        }
        else
        {
            lblSent.Text = ResHelper.GetString("Newsletter_Issue_Header.NotSentYet");
        }

        if (!IsPostBack)
        {
            InitalizeMenu(issue);
        }
    }

    /// <summary>
    /// Initializes newsletter menu
    /// </summary>
    protected void InitalizeMenu(Issue lIssue)
    {
        Newsletter news = NewsletterProvider.GetNewsletter(lIssue.IssueNewsletterID);
        if (news != null)
        {
            if (news.NewsletterType == "D")
            {
                BasicTabControlMenu.Tabs = new string[1, 4];
                BasicTabControlMenu.Tabs[0, 0] = ResHelper.GetString("Newsletter_Issue_Header.Send");
                BasicTabControlMenu.Tabs[0, 2] = "Newsletter_Issue_Send.aspx?issueid=" + newsletterIssueId;
            }
            else
            {
                BasicTabControlMenu.Tabs = new string[3, 4];
                BasicTabControlMenu.Tabs[0, 0] = ResHelper.GetString("Newsletter_Issue_Header.Edit");
                BasicTabControlMenu.Tabs[0, 2] = "Newsletter_Issue_Edit.aspx?issueid=" + newsletterIssueId;
                BasicTabControlMenu.Tabs[1, 0] = ResHelper.GetString("Newsletter_Issue_Header.Send");
                BasicTabControlMenu.Tabs[1, 2] = "Newsletter_Issue_Send.aspx?issueid=" + newsletterIssueId;
                BasicTabControlMenu.Tabs[2, 0] = ResHelper.GetString("Newsletter_Issue_Header.Preview");
                BasicTabControlMenu.Tabs[2, 2] = "Newsletter_Issue_Preview.aspx?issueid=" + newsletterIssueId;
            }
            BasicTabControlMenu.UrlTarget = "newsletterIssueContent";
        }
    }
}
