using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Newsletter;

public partial class CMSDesk_Tools_Newsletters_Newsletters_Newsletter_Issue_New_Preview : CMSDeskPage
{
    protected int newsletterIssueId = 0;
    protected string backUrl = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        btnBack.Text = ResHelper.GetString("Newsletter_Issue_New_Preview.Back");
        btnNext.Text = ResHelper.GetString("Newsletter_Issue_New_Preview.Next");

        lblStep2.Text = ResHelper.GetString("Newsletter_Issue_New_Preview.Step2");

        // initializes page title control		
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = ResHelper.GetString("newsletter_issue_list.headercaption");
        pageTitleTabs[0, 1] = "~/CMSDesk/Tools/Newsletters/Newsletters/Newsletter_Issue_List.aspx";
        pageTitleTabs[0, 2] = "newsletterContent";
        pageTitleTabs[1, 0] = ResHelper.GetString("newsletter_issue_list.newitemcaption");
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;
        PageTitle.TitleText = ResHelper.GetString("newsletter_issue_list.title");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Newsletters/Newsletters/newissue.gif";

        newsletterIssueId = ValidationHelper.GetInteger(Request.QueryString["issueid"], 0);
        if (newsletterIssueId == 0)
        {
            btnNext.Enabled = false;
            string newsletterId = ValidationHelper.GetString(Request.QueryString["newsletterid"], "0");
            backUrl = "Newsletter_Issue_New_Edit.aspx?newsletterid=" + newsletterId;
            pageTitleTabs[0, 1] += "?newsletterid=" + newsletterId;
            return;
        }
        
        backUrl = "Newsletter_Issue_New_Edit.aspx?issueid=" + newsletterIssueId.ToString();
        Issue issue = IssueProvider.GetIssue(newsletterIssueId);
        pageTitleTabs[0, 1] += "?newsletterid=" + issue.IssueNewsletterID.ToString();
    }


    protected void btnBack_Click(object sender, EventArgs e)
    {
        Response.Redirect(backUrl);
    }


    protected void btnNext_Click(object sender, EventArgs e)
    {
        Response.Redirect("Newsletter_Issue_New_Send.aspx?issueid=" + newsletterIssueId.ToString());
    }
}
