using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;


using CMS.GlobalHelper;
using CMS.Newsletter;
using CMS.EmailEngine;
using CMS.ExtendedControls;


public partial class CMSDesk_Tools_Newsletters_Newsletters_Newsletter_Issue_New_Send : CMSDeskPage
{
    protected int newsletterIssueId = 0;
    protected int newsletterId = 0;
    Issue issue = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        newsletterIssueId = ValidationHelper.GetInteger(Request.QueryString["issueid"], 0);

        if (newsletterIssueId > 0)
        {
            issue = IssueProvider.GetIssue(newsletterIssueId);
        }
        else
        {
            btnFinish.Enabled = false;
            return;
        }

        if (issue != null)
        {
            newsletterId = issue.IssueNewsletterID;
        }

        //btnFinish.OnClientClick = "parent.frames['newsletterContent'].location.href='Newsletter_Issue_List.aspx?newsletterid=" + newsletterId + "';";

        // initializes page title control		
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = ResHelper.GetString("newsletter_issue_list.headercaption");
        pageTitleTabs[0, 1] = "~/CMSDesk/Tools/Newsletters/Newsletters/Newsletter_Issue_List.aspx?newsletterid=" + newsletterId;
        pageTitleTabs[0, 2] = "newsletterContent";
        pageTitleTabs[1, 0] = ResHelper.GetString("newsletter_issue_list.newitemcaption");
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;
        PageTitle.TitleText = ResHelper.GetString("newsletter_issue_list.title");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Newsletters/Newsletters/newissue.gif";

        lblSendNow.Text = ResHelper.GetString("newsletter_issue_new_send.sendnow");
        lblSendLater.Text = ResHelper.GetString("newsletter_issue_new_send.sendlater");
        lblSchedule.Text = ResHelper.GetString("newsletter_issue_new_send.schedule");
        lblDateTime.Text = ResHelper.GetString("newsletter_issue_new_send.datetime");
        btnFinish.Text = ResHelper.GetString("newsletter_issue_new_send.finish");
        lblStep3.Text = ResHelper.GetString("Newsletter_Issue_New_Send.Step3");

        if (!IsPostBack)
        {
            radSendNow.Checked = true;
        }

        calendarControl.SupportFolder = "~/CMSAdminControls/Calendar";
        calendarControl.DateTimeTextBox.CssClass = "EditingFormCalendarTextBox";
    }
    
    protected void btnFinish_Click(object sender, EventArgs e)
    {
        if (radSendNow.Checked) //Send now
        {
            IssueProvider.SendIssue(newsletterIssueId);
        }
        else if (radSchedule.Checked) //Schedule sending
        {
            if (calendarControl.SelectedDateTime == DateTimePicker.NOT_SELECTED)
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("newsletter_issue_list.NoTimeSelected");
                return;
            }
            else
            {
                IssueProvider.SendIssue(newsletterIssueId, calendarControl.SelectedDateTime);
            }
        }
        //else if (radSendLater.Checked) => send later => do nothing now
        ltlScript.Text = ScriptHelper.GetScript("parent.frames['newsletterContent'].location.href='Newsletter_Issue_List.aspx?newsletterid=" + newsletterId + "';");
    }

    protected void radGroupSend_CheckedChanged(object sender, EventArgs e)
    {
        if (radSchedule.Checked)
        {
            calendarControl.Enabled = true;
        }
        else
        {
            calendarControl.Enabled = false;
        }
    }

}
