using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Newsletter;

public partial class CMSDesk_Tools_Newsletters_Newsletters_Newsletter_Preview : System.Web.UI.UserControl
{
    protected int newsletterIssueId = 0;
    
    protected void Page_Load(object sender, EventArgs e)
    {
        InitGUI();

        newsletterIssueId = ValidationHelper.GetInteger(Request.QueryString["issueid"], 0);

        // issue ID validation
        Issue issue = IssueProvider.GetIssue(newsletterIssueId);
        if (issue == null)
        {
            lblError.Visible = true;
            lblError.Text = ResHelper.GetString("Newsletter_Issue_New_Preview.NoIssue");

            string newsletterId = ValidationHelper.GetString(Request.QueryString["newsletterid"], "0");
            return;
        }


        lblSubject.Text = ResHelper.GetString("Newsletter_Issue_New_Preview.Subject") + " " + ResHelper.LocalizeString(issue.IssueSubject);

        // reading all subscribers
        DataSet subscribers = SubscriberProvider.GetAllSubscribersOfNewsletter(issue.IssueNewsletterID);
        string script = "";
        if (!DataHelper.DataSourceIsEmpty(subscribers))
        {
            // generate javascript based on subscribers
            script += "newsletterIssueId =" + newsletterIssueId.ToString() + "; \n";
            script += "var guid = new Array(" + subscribers.Tables[0].Rows.Count + "); \n ";
            script += "var email = new Array(" + subscribers.Tables[0].Rows.Count + "); \n ";
            script += "var subscribers = new Array(guid, email); \n ";
            for (int i = 0; i < subscribers.Tables[0].Rows.Count; i++)
            {
                script += "guid[" + i.ToString() + "] = '" + subscribers.Tables[0].Rows[i]["SubscriberGUID"] + "'; \n ";
                script += "email[" + i.ToString() + "] = '" + subscribers.Tables[0].Rows[i]["SubscriberEmail"] + "'; \n ";
            }
        }
        else
        {
            // no subscribers? => hide 'prev' and 'next' link buttons
            pnlLinkButtons.Visible = false;

            // generate void javascript 
            script += "newsletterIssueId =" + newsletterIssueId.ToString() + "; \n ";
            script += "var guid = new Array(1); \n ";
            script += "var email = new Array(1); \n ";
            script += "var subscribers = new Array(guid, email); \n ";
            script += "guid[1] = 0; \n ";
            script += "email[1] = 0; \n ";
        }
        ltlScript.Text = ScriptHelper.GetScript(script);

        if (!IsPostBack)
        {
            ltlPageLoadScript.Text = ScriptHelper.GetScript(" pageLoad(); ");
        }

    }

    /// <summary>
    /// GUI initialization.
    /// </summary>
    protected void InitGUI()
    {
        lblSubscriber.Text = ResHelper.GetString("Newsletter_Issue_New_Preview.Subscriber") + "&nbsp;&nbsp;&nbsp;&nbsp;";

        lnkNext.Text = ResHelper.GetString("Newsletter_Issue_New_Preview.Next");
        lblNext.Text = ResHelper.GetString("Newsletter_Issue_New_Preview.Next");
        lnkPrevious.Text = ResHelper.GetString("Newsletter_Issue_New_Preview.Previous");
        lblPrevious.Text = ResHelper.GetString("Newsletter_Issue_New_Preview.Previous");

    }
}
