using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Polls;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Polls_Polls_Header : CMSDeskPage
{
    protected int pollId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // Check 'Read' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.polls", "Read"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.polls", "Read");
        }

        // Get the poll ID
        pollId = ValidationHelper.GetInteger(this.Request.QueryString["pollId"], 0);
        
        PollInfo pi = PollInfoProvider.GetPollInfo(pollId);
        if (pi != null)
        {
            if (!IsPostBack)
            {
                InitalizeMenu();
            }

            // Initialize the page title
            string[,] pageTitleTabs = new string[2, 3];
            pageTitleTabs[0, 0] = ResHelper.GetString("Polls_Edit.itemlistlink");
            pageTitleTabs[0, 1] = "~/CMSDesk/Tools/Polls/Polls_List.aspx";
            pageTitleTabs[0, 2] = "toolsmain";
            pageTitleTabs[1, 0] = pi.PollDisplayName;
            pageTitleTabs[1, 1] = "";
            pageTitleTabs[1, 2] = "";

            PageTitle.Breadcrumbs = pageTitleTabs;
            PageTitle.TitleText = ResHelper.GetString("Polls_Edit.headercaption");
            PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Polls/poll.gif";
        }
    }


    /// <summary>
    /// Initializes edit menu
    /// </summary>
    protected void InitalizeMenu()
    {
        BasicTabControlMenu.Tabs = new string[5, 4];

        BasicTabControlMenu.Tabs[0, 0] = ResHelper.GetString("General.General");
        BasicTabControlMenu.Tabs[0, 2] = "Polls_General.aspx?pollId=" + pollId;
        BasicTabControlMenu.Tabs[1, 0] = ResHelper.GetString("Polls_Edit.Answers");
        BasicTabControlMenu.Tabs[1, 2] = "Polls_Answer_List.aspx?pollId=" + pollId;
        BasicTabControlMenu.Tabs[2, 0] = ResHelper.GetString("Polls_Edit.Security");
        BasicTabControlMenu.Tabs[2, 2] = "Polls_Security.aspx?pollId=" + pollId;
        BasicTabControlMenu.Tabs[3, 0] = ResHelper.GetString("Polls_Edit.Sites");
        BasicTabControlMenu.Tabs[3, 2] = "Polls_Sites.aspx?pollId=" + pollId;
        BasicTabControlMenu.Tabs[4, 0] = ResHelper.GetString("Polls_Edit.View");
        BasicTabControlMenu.Tabs[4, 2] = "Polls_View.aspx?pollId=" + pollId;

        BasicTabControlMenu.UrlTarget = "pollContent";
    }
}
