using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.Polls;
using CMS.CMSHelper;
using CMS.GlobalHelper;

public partial class CMSDesk_Tools_Polls_Polls_View : CMSDeskPage
{
    /// <summary>
    /// PollID.
    /// </summary>
    protected int pollId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // Check 'Read' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.polls", "Read"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.polls", "Read");
        }

        // Get PollID from querystring
        pollId = ValidationHelper.GetInteger(Request.QueryString["pollId"], 0);

        PollInfo pi = PollInfoProvider.GetPollInfo(pollId);

        if (pi != null)
        {
            PollView1.PollCodeName = pi.PollCodeName;
            PollView1.CountType = CountTypeEnum.Percentage;
            PollView1.ShowGraph = true;
            PollView1.ShowResultsAfterVote = true;
            PollView1.CheckPermissions = false;
            PollView1.CheckVoted = false;
            PollView1.HideWhenNotAuthorized = false;
            PollView1.CheckOpen = false;
        }
    }
}
