using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.LicenseProvider;
using CMS.Reporting;

public partial class CMSDesk_Tools_Reporting_Category_Header : CMSDeskPage
{
    protected int categoryId = 0;
    //protected int siteId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // check 'Read' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.reporting", "Read"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.reporting", "Read");
        }

        string currentReportCategory = ResHelper.GetString("");

        if ((Request.QueryString["categoryid"] != null) && (Request.QueryString["categoryid"] != ""))
        {
            categoryId = ValidationHelper.GetInteger(Request.QueryString["categoryid"], 0);
            ReportCategoryInfo category = ReportCategoryInfoProvider.GetReportCategoryInfo(categoryId);
            currentReportCategory = Server.HtmlEncode(category.CategoryDisplayName);
        }

        // initializes page title control		
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = ResHelper.GetString("Reporting.ReportCategoryList");
        pageTitleTabs[0, 1] = "~/CMSDesk/Tools/Reporting/ReportCategory_List.aspx";
        pageTitleTabs[0, 2] = "toolsmain";
        pageTitleTabs[1, 0] = currentReportCategory;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;
        PageTitle.TitleText = ResHelper.GetString("Reporting.ReportCategoryHeaderCaption");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Reporting/reportcategory.gif";

        if (!IsPostBack)
        {
            InitalizeMenu();
        }
    }

    /// <summary>
    /// Initializes user edit menu
    /// </summary>
    protected void InitalizeMenu()
    {
        string generalString = ResHelper.GetString("Reporting.General");
        string reportString = ResHelper.GetString("Reporting.Reports");        

        BasicTabControlMenu.Tabs = new string[2, 4];
        BasicTabControlMenu.Tabs[0, 0] = reportString;
        BasicTabControlMenu.Tabs[0, 2] = "Report_List.aspx?categoryid=" + categoryId.ToString();
        BasicTabControlMenu.Tabs[1, 0] = generalString;
        BasicTabControlMenu.Tabs[1, 2] = "ReportCategory_General.aspx?categoryid=" + categoryId.ToString();

        BasicTabControlMenu.UrlTarget = "categoryContent";
    }
}
