using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.Reporting;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Reporting_ReportCategory_List : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {

        // Check 'Read' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.reporting", "Read"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.reporting", "Read");
        }

        PageTitle.TitleText = ResHelper.GetString("ReportCategory_List.HeaderCaption");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Reporting/reportcategories.gif";
        imgNewItem.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Reporting/addreportcategory.gif";

        UniGrid.OnAction += new OnActionEventHandler(uniGrid_OnAction);
        UniGrid.GridView.GridLines = GridLines.Horizontal;

        lnkNewItem.Text = ResHelper.GetString("ReportCategory_List.NewItemCaption");
    }


    /// <summary>
    /// Handles the UniGrid's OnAction event.
    /// </summary>
    /// <param name="actionName">Name of item (button) that throws event.</param>
    /// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
    protected void uniGrid_OnAction(string actionName, object actionArgument)
    {
        if (actionName == "edit")
        {
            Response.Redirect("Category_Frameset.aspx?CategoryID=" + Convert.ToString(actionArgument));
        }
        else if (actionName == "delete")
        {
            // Check 'Read' permission
            if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.reporting", "Modify"))
            {
                CMSDeskPage.RedirectToAccessDenied("cms.reporting", "Modify");
            }  

            // delete ReportCategoryInfo object from database
            ReportCategoryInfoProvider.DeleteReportCategoryInfo(Convert.ToInt32(actionArgument));
        }
    }
}
