using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Reporting;
using CMS.CMSHelper;

public partial class CMSDesk_Tools_Reporting_Report_header : CMSDeskPage
{
    protected int reportId = 0;
    protected int categoryId = 0;
    protected int saved = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        // Check 'Read' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.reporting", "Read"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.reporting", "Read");
        }
        reportId = ValidationHelper.GetInteger(Request.QueryString["reportid"], 0);
        saved = ValidationHelper.GetInteger(Request.QueryString["saved"], 0);
        
        string currentReport = "";

        ReportInfo ri = ReportInfoProvider.GetReportInfo(reportId);

        categoryId = ValidationHelper.GetInteger(Request.QueryString["categoryId"],0);
        string reportListLink = "~/CMSDesk/Tools/Reporting/Report_List.aspx";
        if (ri != null)
        {
            currentReport = ri.ReportDisplayName;
            reportListLink +="?categoryId="+categoryId;
        }


        // initializes page title control		
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = ResHelper.GetString("Report_Header.ReportList");
        pageTitleTabs[0, 1] = reportListLink;
        pageTitleTabs[0, 2] = "categoryContent";
        pageTitleTabs[1, 0] = currentReport;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle.Breadcrumbs = pageTitleTabs;
        
        PageTitle.TitleText = ResHelper.GetString("Report_Header.HeaderCaption");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Reporting/Report.gif";


        if (!IsPostBack)
        {
            InitalizeMenu();
        }
    }

    /// <summary>
    /// Initializes user edit menu
    /// </summary>
    protected void InitalizeMenu()
    {

        BasicTabControlMenu.Tabs = new string[4, 4];
        BasicTabControlMenu.Tabs[0, 0] = ResHelper.GetString("Report_Header.View");
        BasicTabControlMenu.Tabs[0, 2] = "Report_View.aspx?reportid=" + reportId.ToString();
        BasicTabControlMenu.Tabs[1, 0] = ResHelper.GetString("Report_Header.General");
        BasicTabControlMenu.Tabs[1, 2] = "Report_General.aspx?reportid=" + reportId.ToString();
        BasicTabControlMenu.Tabs[2, 0] = ResHelper.GetString("Report_Header.Parameters");
        BasicTabControlMenu.Tabs[2, 2] = "Report_Parameters.aspx?reportid=" + reportId.ToString();
        BasicTabControlMenu.Tabs[3, 0] = ResHelper.GetString("Report_Header.SavedReports");
        BasicTabControlMenu.Tabs[3, 2] = "./SavedReports/SavedReports_List.aspx?reportid=" + reportId.ToString();
        
        BasicTabControlMenu.SelectedTab = saved;
        
        BasicTabControlMenu.UrlTarget = "reportContent";
    }
}
