using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.GlobalHelper;
using CMS.Reporting;
using CMS.CMSHelper;

public partial class Reporting_SavedReport_View : CMSDeskPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        // Check 'Read' permission
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.reporting", "Read"))
        {
            CMSDeskPage.RedirectToAccessDenied("cms.reporting", "Read");
        }

        if ((!IsPostBack) && (ValidationHelper.GetInteger(Request.QueryString["View"], 0) == 1))
        {
            ltlScript.Text += ScriptHelper.GetScript("parent.frames['reportHeader'].SetSavedTab()");
        }

        // Initialize controls
        PageTitle.TitleText = ResHelper.GetString("SavedReport_View.HeaderCaption");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Reporting/SavedReports/savedreport.gif";
        imgPrint.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/Tools/Reporting/SavedReports/print.gif";
        btnPrint.Text = ResHelper.GetString("SavedReport_View.Print");
        btnSendToEMail.Text = ResHelper.GetString("SavedReport_View.SendToEmail"); ;

        // Creates SavedReport obj
        int savedReportId = ValidationHelper.GetInteger(Request.QueryString["reportId"], 0);
        SavedReportInfo sri = SavedReportInfoProvider.GetSavedReportInfo(savedReportId);
        if (sri != null)
        {

            ReportInfo ri = ReportInfoProvider.GetReportInfo(sri.SavedReportReportID);
            if (ri != null)
            {
                // Initialize pagetitle breadcrumbs
                string[,] pageTitleTabs = new string[2, 3];
                pageTitleTabs[0, 0] = ri.ReportDisplayName;
                pageTitleTabs[0, 1] = "~/CMSDesk/Tools/Reporting/SavedReports/SavedReports_List.aspx?reportid=" + ri.ReportID.ToString();
                pageTitleTabs[0, 2] = "";
                pageTitleTabs[1, 0] = sri.SavedReportTitle;
                pageTitleTabs[1, 1] = "";
                pageTitleTabs[1, 2] = "";
                PageTitle.Breadcrumbs = pageTitleTabs;
            }

            ltlHtml.Text = sri.SavedReportHTML;

        }

        ltlModal.Text = ScriptHelper.GetScript("function myModalDialog(url, name, width, height) { " + 
            "win = window; " +
            "var dHeight = height; var dWidth = width; " +
            "if (( document.all )&&(navigator.appName != 'Opera')) { " +
            "try { win = wopener.window; } catch (e) {} " +
            "if ( parseInt(navigator.appVersion.substr(22, 1)) < 7 ) { dWidth += 4; dHeight += 58; }; " +
            "dialog = win.showModalDialog(url, this, 'dialogWidth:' + dWidth + 'px;dialogHeight:' + dHeight + 'px;resizable:yes;scroll:yes'); " +
            "} else { " +
            "oWindow = win.open(url, name, 'height=' + dHeight + ',width=' + dWidth + ',toolbar=no,directories=no,menubar=no,modal=yes,dependent=yes,resizable=yes,scroll=yes,scrollbars=yes'); oWindow.opener = this; oWindow.focus(); } } ");

        this.btnPrint.OnClientClick = "myModalDialog('SavedReport_Print.aspx?reportid=" + savedReportId.ToString() + "', 'SavedReportPrint', 650, 700); return false;";

    }
}
