<%@ Control Language="C#" AutoEventWireup="true" CodeFile="ShoppingCartContent.ascx.cs"
    Inherits="CMSEcommerce_ShoppingCartContent" %>
<%@ Register Assembly="CMS.ExtendedControls" Namespace="CMS.ExtendedControls" TagPrefix="cc1" %>
<asp:Panel ID="pnlCartContent" runat="server" DefaultButton="btnUpdate">
<asp:Label ID="lblTitle" runat="server" CssClass="BlockTitle" EnableViewState="false" />
<div class="BlockContent">
    <asp:Label ID="lblInfo" runat="server" SkinID="LabelInfo" Visible="false" EnableViewState="false"></asp:Label>    
    <asp:Label ID="lblError" runat="server"  CssClass="ErrorLabel" EnableViewState="false"
        Visible="false" />    
    <table width="100%">
        <tr>
            <td style="text-align: left;">
                <asp:Panel ID="pnlNewItem" runat="server">
                    <asp:Image ID="imgNewItem" runat="server" SkinID="NewItemImage" />
                    <asp:LinkButton ID="lnkNewItem" runat="server" SkinID="NewItemLink" />
                </asp:Panel>
            </td>
            <td style="text-align: right;">
                <asp:Panel ID="pnlCurrency" runat="server">
                    <asp:Label ID="lblCurrency" runat="server" />
                    <cc1:localizeddropdownlist ID="drpCurrency" runat="server" AutoPostBack="True" OnSelectedIndexChanged="drpCurrency_SelectedIndexChanged" />
                </asp:Panel>
            </td>
        </tr>
        <tr>
            <td colspan="2">
                <asp:GridView ID="gridData" runat="server" AutoGenerateColumns="false" CellPadding="3"
                    AllowSorting="true" SkinID="UniGridGrid" GridLines="horizontal" Width="100%">
                    <HeaderStyle HorizontalAlign="Left" CssClass="UniGridHead" />
                    <Columns>
                        <asp:TemplateField Visible="false">
                            <ItemTemplate>
                                <asp:Label ID="lblID" runat="server" Text='<%# Eval("SKUID")%>' />
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField>
                            <HeaderStyle Width="50" />
                            <ItemStyle HorizontalAlign="Center" />
                            <ItemTemplate>
                                <asp:CheckBox ID="chkRemove" runat="server" Checked="false" />
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField>   
                            <ItemTemplate><%# Eval("SKUName")%></ItemTemplate> 
                        </asp:TemplateField>
                        <asp:TemplateField>
                            <HeaderStyle Width="56" HorizontalAlign="Left" />
                            <ItemTemplate>
                                <asp:TextBox ID="txtUnits" runat="server" Text='<%# Eval("SKUUnits")%>' CssClass="UnitsTextBox" MaxLength="9" />
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderStyle-Wrap="false">
                            <ItemStyle HorizontalAlign="Right" />
                            <HeaderStyle HorizontalAlign="Right" Width="80" />
                            <ItemTemplate>
                                <asp:Label ID="lblSKUPrice" runat="server" Text='<%# string.Format("{0:F}",Eval("SKUPrice")) %>' />
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderStyle-Wrap="false">
                            <ItemStyle HorizontalAlign="Right" Width="80" />
                            <HeaderStyle HorizontalAlign="Right" />
                            <ItemTemplate>
                                <asp:Label ID="lblUnitDiscount" runat="server" Text='<%# string.Format("{0:F}",Eval("UnitDiscount")) %>' />
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderStyle-Wrap="false">
                            <ItemStyle HorizontalAlign="Right" />
                            <HeaderStyle HorizontalAlign="Right" Width="80" />
                            <ItemTemplate>
                                <asp:Label ID="lblTax" runat="server" Text='<%# string.Format("{0:F}",Eval("Tax")) %>' />
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderStyle-Wrap="false">
                            <ItemStyle HorizontalAlign="Right" />
                            <HeaderStyle HorizontalAlign="Right" Width="100" />
                            <ItemTemplate>
                                <asp:Label ID="lblSubtotal" runat="server" Text='<%# string.Format("{0:F}",Eval("Subtotal")) %>' />
                            </ItemTemplate>
                        </asp:TemplateField>
                    </Columns>
                </asp:GridView>
            </td>
        </tr>
        <tr>
            <td style="text-align: left;">
            </td>
            <td style="text-align: right;">
                <asp:PlaceHolder ID="plcCoupon" runat="server">
                    <asp:Label ID="lblCoupon" runat="server" />&nbsp;
                    <asp:TextBox ID="txtCoupon" runat="server" />
                </asp:PlaceHolder>
            </td>
        </tr>
        <tr>
            <td colspan="2">&nbsp;</td>
        </tr>
        <tr>
            <td>
            </td>
            <td>
                <asp:Panel ID="pnlPrice" runat="server" CssClass="PricePanel">
                    <table>
                        <tr>
                            <td>
                                <asp:Label ID="lblShippingPrice" runat="server" /></td>
                            <td style="text-align:right">
                                <asp:Label ID="lblShippingPriceValue" runat="server" /></td>
                        </tr>
                        <tr>
                            <td>
                                <b><asp:Label ID="lblTotalPrice" runat="server" /></b></td>
                            <td style="text-align:right">
                                <b><asp:Label ID="lblTotalPriceValue" runat="server" /></b></td>
                        </tr>
                        <tr>
                            <td colspan="2" align="right">
                                <asp:Button ID="btnUpdate" runat="server" OnClick="btnUpdate_Click1" CssClass="ContentButton" /></td>
                        </tr>
                    </table>
                    <asp:Label ID="lblTotalTax" runat="server" /><br />
                    <asp:Label ID="lblTaxSubtotal" runat="server" /><br />
                    <asp:Label ID="lblRoundedDifference" runat="server" /><br />
                </asp:Panel>
            </td>
        </tr>
    </table>     
</div>
<asp:Literal ID="ltlAlert" runat="server" EnableViewState="false" />
<asp:Literal ID="ltlScript" runat="server" EnableViewState="true" />
</asp:Panel>
<script language="javascript" type="text/javascript">
<!--
    // Opens the "Add product to shopping cart" in modal dialog
    function OpenAddProductDialog()
    {           
       modalDialog('Order_Edit_AddItems.aspx', 'addProduct', 700, 540);
    }
-->
</script>

