using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.Ecommerce;
using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.FormEngine;

public partial class CMSFormControls_DiscountLevelSelector : FormEngineUserControl
{
    // init state variables
    private int mDiscountLevelId = 0;
    private bool mAddNoneRecord = false;
    private string mDropDownItemEnabledCss = "";
    private string mDropDownItemDisabledCss = "";


    #region " Public properties "

    /// <summary>
    /// DiscountLevel
    /// </summary>
    public int DiscountLevel
    {
        get { return ValidationHelper.GetInteger (drpDiscountLevel.SelectedValue, 0) ;}
        set { mDiscountLevelId = value; }
    }
    

    /// <summary>
    /// Add none record (option) to dropdownlist
    /// </summary>
    public bool AddNoneRecord
    {
        get { return mAddNoneRecord;  }
        set { mAddNoneRecord = value; }
    }


    /// <summary>
    /// Enabled dropdownlist item css style.
    /// </summary>
    public string DropDownItemEnabledCss
    {
        get
        {
            return mDropDownItemEnabledCss;
        }
        set
        {
            mDropDownItemEnabledCss = value;
        }
    }


    /// <summary>
    /// Disabled dropdownlist item css style.
    /// </summary>
    public string DropDownItemDisabledCss
    {
        get
        {
            return mDropDownItemDisabledCss;
        }
        set
        {
            mDropDownItemDisabledCss = value;
        }
    }


    /// <summary>
    /// Gets or sets field value.
    /// </summary>
    public override object Value
    {
        get
        {
            return ValidationHelper.GetInteger(drpDiscountLevel.SelectedValue, 0); ;
        }
        set
        {
            mDiscountLevelId = ValidationHelper.GetInteger(value, 0);
        }
    }

    #endregion


    protected void Page_Load(object sender, EventArgs e)
    {
        if ((!StopProcessing && !Page.IsPostBack) || ((this.DropDownItemEnabledCss != "") || (this.DropDownItemDisabledCss != "")))
        {
            LoadData();
        }
    }

    protected void LoadData()
    {
        // Get all discount levels from db
        DataSet ds = DiscountLevelInfoProvider.GetAllDiscountLevelInfo();

/* TODO - remove ASAP
        // We will add "none" option
        if (!DataHelper.DataSourceIsEmpty(ds) && this.AddNoneRecord)
        {
            // Create new row in table
            DataRow NoneRow = ds.Tables[0].NewRow();
            // Set properties
            NoneRow["DiscountLevelDisplayName"] = ResHelper.GetString("discountlevelselector.dropdownlist.nonerow");
            NoneRow["DiscountLevelId"] = 0;
            // Insert row
            ds.Tables[0].Rows.InsertAt(NoneRow, 0);
        }

*/
        // Remember previously selected item
        ListItem li = drpDiscountLevel.SelectedItem;

        drpDiscountLevel.DataSource = ds;
        drpDiscountLevel.DataTextField = "DiscountLevelDisplayName";
        drpDiscountLevel.DataValueField = "DiscountLevelId";
        drpDiscountLevel.DataBind();

        // We will add "none" option, if needed
        if (this.AddNoneRecord)
        {
            drpDiscountLevel.Items.Insert(0, new ListItem(ResHelper.GetString("discountlevelselector.dropdownlist.nonerow"), "0"));
        }

        if ((this.DropDownItemEnabledCss != "") || (this.DropDownItemDisabledCss != ""))
        {
            EcommerceFunctions.MarkEnabledAndDisabledItems(drpDiscountLevel, "DiscountLevelId", "DiscountLevelEnabled");
        }

        if ((li != null) && (drpDiscountLevel.Items.FindByValue(mDiscountLevelId.ToString()) != null))
        {
            drpDiscountLevel.SelectedValue = li.Value;
        }
        else if ((drpDiscountLevel.SelectedValue != null) && (mDiscountLevelId != 0) && (drpDiscountLevel.Items.FindByValue(mDiscountLevelId.ToString()) != null))
        {
            drpDiscountLevel.SelectedValue = mDiscountLevelId.ToString();
        }   
    }
}
