using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.SiteProvider;
using CMS.DataEngine;
using CMS.SettingsProvider;
using CMS.FormEngine;

public partial class CMSWebParts_Designers_LargeTextArea : FormEngineUserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string mJavaScript = "";

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);

        btnMore.OnClientClick += "ShowLargeTextArea('" + txtArea.ClientID + "');return false;";

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "ShowLargeTextArea", ScriptHelper.GetScript("function  ShowLargeTextArea(txtClientID) { modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/LargeTextAreaDesigner.aspx") + "?areaid=' + txtClientID,'ShowLargeTextArea', 1024, 600); return false;}"));

        // Set this text area
        mJavaScript += "function SetAreaValue(areaId, areaText ){ document.getElementById(areaId).value = areaText; return false }\n";
        // send value from this text area
        mJavaScript += "function GetAreaValue(areaId)  { return document.getElementById(areaId).value; return false;  }\n";

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "AreaGlobal", ScriptHelper.GetScript(mJavaScript));

    }

    /// <summary>
    /// Width
    /// </summary>
    public Unit Width
    {
        get
        {
            return txtArea.Width;
        }
        set
        {
            txtArea.Width = value;
        }
    }

    /// <summary>
    /// Rows
    /// </summary>
    public int Rows
    {
        get
        {
            return txtArea.Rows;
        }
        set
        {
            txtArea.Rows = value;
        }
    }

    /// <summary>
    /// Gets or sets field value.
    /// </summary>
    public override object Value
    {
        get
        {
            return this.txtArea.Text;
        }
        set
        {
            this.txtArea.Text = (string)value;
        }
    }


    /// <summary>
    /// Returns the arraylist of the field IDs (Client IDs of the inner controls) that should be spell checked
    /// </summary>
    public override ArrayList GetSpellCheckFields()
    {
        ArrayList result = new ArrayList();
        result.Add(this.txtArea.ClientID);

        return result;
    }

}
