using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.Polls;

public partial class CMSFormControls_PollSelector : CMS.FormEngine.FormEngineUserControl
{
    private string mPollCodeName = null;


    /// <summary>
    /// Gets or sets field value.
    /// </summary>
    public override object Value
    {
        get
        {
            return ValidationHelper.GetString(drpPolls.SelectedValue, "");
        }
        set
        {
            mPollCodeName = ValidationHelper.GetString(value, "");
        }
    }


    protected void Page_Load(object sender, EventArgs e)
    {
        if ((!Page.IsPostBack) && (CMSContext.CurrentSite != null))
        {
            DataSet ds = PollInfoProvider.GetPolls(CMSContext.CurrentSite.SiteName);
            if (!DataHelper.DataSourceIsEmpty(ds))
            {
                drpPolls.DataSource = ds;
                drpPolls.DataTextField = "PollDisplayName";
                drpPolls.DataValueField = "PollCodeName";
                drpPolls.DataBind();
            }

            if ((mPollCodeName != null) && (mPollCodeName != "") && (drpPolls.Items != null) && (drpPolls.Items.FindByValue(mPollCodeName) != null))
            {
                drpPolls.SelectedValue = mPollCodeName;
            }
        }

    }
}
