using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.FormEngine;
using CMS.CMSHelper;
using CMS.GlobalHelper;

public partial class CMSFormControls_SelectBizForm : CMS.FormEngine.FormEngineUserControl
{

    private int mBizFormId = 0;
    private string mBizFormName = null;

    ///<summary>Gets or sets field value.</summary>
    public override object Value
    {
        get
        {
            return BizFormName;
        }
        set
        {
            BizFormName = ValidationHelper.GetString(value, null);
        }
    }

    ///<summary>Gets or sets BizForm Id.</summary>
    public int BizFormId
    {
        set
        {
            BizFormInfo bfi = BizFormInfoProvider.GetBizFormInfo(value);
            if (bfi != null)
            {
                drpBizForm.SelectedValue = bfi.FormID.ToString();
            }
        }
        get
        {
            return mBizFormId;
        }
    }

    ///<summary>Gets or sets BizForm Name.</summary>
    public string BizFormName
    {
        set
        {
            if (value != null)
            {
                BizFormInfo bfi = BizFormInfoProvider.GetBizFormInfo(value, CMSContext.CurrentSite.SiteName);
                if (bfi != null)
                {
                    drpBizForm.SelectedValue = bfi.FormID.ToString();
                }
            }
        }
        get
        {
            return mBizFormName;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            // Load all BizForms for currensite
            DataSet ds = BizFormInfoProvider.GetBizFormsForSite(CMSContext.CurrentSite.SiteID);
            if (ds != null)
            {
                drpBizForm.DataSource = ds.Tables[0].DefaultView;
                drpBizForm.DataTextField = "FormDisplayName";
                drpBizForm.DataValueField = "FormId";
                drpBizForm.DataBind();
            }
        }

        loadPrivateData();

    }

    private void loadPrivateData()
    {
        BizFormInfo bfi = BizFormInfoProvider.GetBizFormInfo(ValidationHelper.GetInteger(drpBizForm.SelectedValue, 0));
        if (bfi != null)
        {
            mBizFormId = bfi.FormID;
            mBizFormName = bfi.FormName;
        }
    }

}
