using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SiteProvider;

public partial class CMSFormControls_SelectCssStylesheet : CMS.FormEngine.FormEngineUserControl
{
    private string mStylesheetCodeName = "";
    private bool mAddNoneRecord = true;


    /// <summary>
    /// Indicates whether "none record" should be added to the dropdownlist
    /// </summary>
    public bool AddNoneRecord
    {
        get
        {
            return mAddNoneRecord;
        }
        set
        {
            mAddNoneRecord = value;
        }
    }


    /// <summary>
    /// Css stylesheet code name.
    /// </summary>
    public string StylesheetCodeName
    {
        get { return ValidationHelper.GetString(drpCssStylesheet.SelectedValue, ""); }
        set { mStylesheetCodeName = value; }
    }


    /// <summary>
    /// Get or sets stylesheet name.
    /// </summary>
    public override object Value
    {
        get
        {
            return ValidationHelper.GetString(drpCssStylesheet.SelectedValue, "");
        }
        set
        {
            mStylesheetCodeName = ValidationHelper.GetString(value, "");
        }
    }


    protected void Page_Load(object sender, EventArgs e)
    {

        if (!Page.IsPostBack)
        {
            drpCssStylesheet.DataTextField = "StylesheetDisplayName";
            drpCssStylesheet.DataValueField = "StylesheetName";

            // Get all stylesheets from database
            drpCssStylesheet.DataSource = CssStylesheetInfoProvider.GetAllCssStylesheets();
            drpCssStylesheet.DataBind();

            // Add "none record" if required
            if (this.AddNoneRecord)
            {
                ListItem li = new ListItem(ResHelper.GetString("SelectCssStylesheet.NoneRecord"), "");
                drpCssStylesheet.Items.Insert(0, li);
            }            

            // Try to select specified item
            ListItem selectedItem = drpCssStylesheet.Items.FindByValue(mStylesheetCodeName);
            if (selectedItem != null)
            {
                selectedItem.Selected = true;
            }
        }

    }
}

