using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.Reporting;
using CMS.GlobalHelper;
using CMS.DataEngine;

public partial class CMSFormControls_SelectReport : CMS.FormEngine.FormEngineUserControl
{

    private int mReportId = 0;
    private string mReportName = null;

    ///<summary>Gets or sets field value.</summary>
    public override object Value
    {
        get
        {
            return ReportName;
        }
        set
        {
            ReportName = ValidationHelper.GetString(value, null);
        }
    }

    ///<summary>Gets or sets Report Id.</summary>
    public int ReportId
    {
        set
        {
            ReportInfo ri = ReportInfoProvider.GetReportInfo(value);
            if (ri != null)
            {
                drpReport.SelectedValue = ri.ReportID.ToString();
            }
        }
        get
        {
            return mReportId;
        }
    }

    ///<summary>Gets or sets Report Name.</summary>
    public string ReportName
    {
        set
        {
            if (value != null)
            {
                ReportInfo ri = ReportInfoProvider.GetReportInfo(value);
                if (ri != null)
                {
                    drpReport.SelectedValue = ri.ReportID.ToString();
                }
            }
        }
        get
        {
            return mReportName;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            // Load all categories and reports
            GeneralConnection conn = ConnectionHelper.GetConnection();

            DataSet ds = conn.ExecuteQuery("Reporting.Report.selectCategoryAndReport", null);

            if (ds != null && !DataHelper.DataSourceIsEmpty(ds))
            {
                drpReport.DataSource = ds.Tables[0].DefaultView;
                drpReport.DataTextField = "CategoryAndReportName";
                drpReport.DataValueField = "ReportId";
                drpReport.DataBind();
            }
        }

        loadPrivateData();

    }

    private void loadPrivateData()
    {
        ReportInfo ri = ReportInfoProvider.GetReportInfo(ValidationHelper.GetInteger(drpReport.SelectedValue, 0));
        if (ri != null)
        {
            mReportId = ri.ReportID;
            mReportName = ri.ReportName;
        }
    }

}
