using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;

public partial class CMSFormControls_selectdocument : CMS.FormEngine.FormEngineUserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        btnSelect.Text = ResHelper.GetString("FormControls_SelectDocument.btnSelect");
        btnSelect.Attributes.Add("onclick", "SelectDocumentDialog('" + txtName.ClientID + "','" + hdnNodeGUID.ClientID + "','" + txtName.Text + "'); return false;");

        btnClear.Text = ResHelper.GetString("FormControls_SelectDocument.btnClear");
        btnClear.OnClientClick = "ClearDocument('" + txtName.ClientID + "','" + hdnNodeGUID.ClientID + "'); return false;";

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "ClearDocument", ScriptHelper.GetScript("function ClearDocument(txtClientID, hdnNodeGuid){ document.getElementById(txtClientID).value=''; document.getElementById(hdnNodeGuid).value=''; }"));
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "SelectDocument", ScriptHelper.GetScript("function SelectDocumentDialog(txtClientID,txtNodeGUIDClienID,aliasPath){modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/DocumentSelection.aspx") + "?txtElem=' + txtClientID + '&txtElem1=' + txtNodeGUIDClienID + '&aliasPath=' + aliasPath,'DocumentSelection', 400, 500); return false;}" +
                                                                                                                 "function SelectDocument(aliasPath,nodeGUID,txtClientID,txtNodeGUIDClienID){if((aliasPath != '') && (txtClientID != '') && (nodeGUID != '') && (txtNodeGUIDClienID != '')) { document.getElementById(txtClientID).value = aliasPath; document.getElementById(txtNodeGUIDClienID).value = nodeGUID }return false;}"));
        txtName.Text = GetNodeName(this.hdnNodeGUID.Value);
    }


    /// <summary>
    /// Gets or sets field value.
    /// </summary>
    public override object Value
    {
        get
        {
            return this.hdnNodeGUID.Value;
        }
        set
        {
            if (value != null)
            {
                txtName.Text = GetNodeName(value);
            }
            this.hdnNodeGUID.Value = (string)value;
        }
    }


    /// <summary>
    /// Get node name from guid
    /// </summary>
    /// <param name="objGuid">Guid object</param>
    /// <returns></returns>
    private string GetNodeName(object objGuid)
    {
        Guid nodeGuid = ValidationHelper.GetGuid(objGuid, Guid.Empty);
        if (nodeGuid != Guid.Empty)
        {
            TreeProvider tp = new TreeProvider();
            CMS.TreeEngine.TreeNode node = tp.SelectSingleNode(nodeGuid, CMSContext.CurrentUser.PreferredCultureCode, CMSContext.CurrentSite.SiteName);
            if (node != null)
            {
                return node.NodeAliasPath;
            }
        }

        return "";
    }
}
