using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.PortalEngine;

public partial class CMSFormControls_selectpagetemplate : CMS.FormEngine.FormEngineUserControl
{
    public override bool Enabled
    {
        get
        {
            return base.Enabled;
        }
        set
        {
            base.Enabled = value;
            this.btnClear.Enabled = value;
            this.txtTemplate.Enabled = value;
            this.btnSelect.Enabled = value;
        }
    }


    PageTemplateInfo pti = null;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (IsPostBack)
        {
            int currentId = ValidationHelper.GetInteger(this.hdnTemplateCode.Value, 0);
            pti = PageTemplateInfoProvider.GetPageTemplateInfo(currentId);
        }

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "SelectTemplate", ScriptHelper.GetScript(
            "function OpenSelectTemplateDialog (selectorId){modalDialog('" + ResolveUrl("~/CMSDesk/PortalEngine/SelectTemplate.aspx") + "?selectorid=' + selectorId, 'Page template selection', 700, 500); return false;} \n" +
            "function SelectTemplate(templateID, templateName, selectorId) { if (document.getElementById(selectorId + '_txtTemplate') != null) document.getElementById(selectorId + '_txtTemplate').value = templateName; if (document.getElementById(selectorId + '_hdnTemplateCode') != null) document.getElementById(selectorId + '_hdnTemplateCode').value = templateID; if ((templateName != null)&&(templateName != '')) document.getElementById(selectorId + '_btnClear').disabled = false;} \n" +
            "function ClearTemplate(selectorId) { document.getElementById(selectorId + '_txtTemplate').value = ''; document.getElementById(selectorId + '_hdnTemplateCode').value = 0; document.getElementById(selectorId + '_btnClear').disabled = true; return false;} \n"
            ));

        btnSelect.OnClientClick = "return OpenSelectTemplateDialog('" + this.ClientID + "');";
        btnClear.Attributes.Add("onclick", "return ClearTemplate('" + this.ClientID + "');");

        btnSelect.Text = ResHelper.GetString("SelectTemplate.SelectButtonText");
        btnClear.Text = ResHelper.GetString("SelectTemplate.ClearButtonText");
    }


    protected override void OnPreRender(EventArgs e)
    {
        LoadData();
        
        base.OnPreRender(e);
    }


    /// <summary>
    /// Loads the control data
    /// </summary>
    public void LoadData()
    {
        if (pti != null)
        {
            this.hdnTemplateCode.Value = pti.CodeName;
            this.txtTemplate.Text = pti.DisplayName;
            this.btnClear.Enabled = true;
        }
        else
        {
            this.txtTemplate.Text = "";
            this.hdnTemplateCode.Value = "";
            this.btnClear.Enabled = false;
        }
    }


    /// <summary>
    /// Page template ID
    /// </summary>
    public int PageTemplateID
    {
        get
        {
            if ( pti != null )
            {
                return pti.PageTemplateId;
            }
            else
            {
                return 0;
            }
        }
        set
        {
            pti = PageTemplateInfoProvider.GetPageTemplateInfo(value);
        }
    }


    /// <summary>
    /// Gets or sets field value (Page template code name)
    /// </summary>
    public override object Value
    {
        get
        {
            if (pti != null)
            {
                return pti.CodeName;
            }
            else
            {
                return "";
            }
        }
        set
        {
            string currentCodeName = ValidationHelper.GetString(value, "");
            pti = PageTemplateInfoProvider.GetPageTemplateInfo(currentCodeName);
             
            LoadData();
        }
    }
}

