using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.SiteProvider;


public partial class CMSFormControls_selectsite : CMS.FormEngine.FormEngineUserControl, System.Web.UI.ICallbackEventHandler
{
    private string _callbackArg;

    #region CallBackHandling

    public void RaiseCallbackEvent(string eventArgument)
    {
        _callbackArg = eventArgument;
    }

    private string Validate(string value)
    {
        try
        {
            // site exists
            SiteInfo si = SiteInfoProvider.GetSiteInfo(value);
            return string.Empty;
        }
        catch
        {
            // site does not exist
            if (value != string.Empty)
            {
                return ResHelper.GetString("FormControls_SelectSite.NotExist").Replace("%%code%%", value);
            }
        }
        return "";
    }


    public string GetCallbackResult()
    {
        return Validate(_callbackArg);
    }

    #endregion

    protected void Page_Load(object sender, EventArgs e)
    {
        string argument = "document.getElementById('" + txtName.ClientID + "').value";
        string clientCallback = "CheckSite";
        string CallbackRef = Page.ClientScript.GetCallbackEventReference(this, argument, clientCallback, "'" + lblStatus.ClientID + "'");
        txtName.Attributes["onchange"] = String.Format("javascript:{0}", CallbackRef);

        btnSelect.Text = ResHelper.GetString("FormControls_SelectSite.btnSelect");
        btnSelect.OnClientClick = "SelectSiteDialog('" + txtName.ClientID + "','" + lblStatus.ClientID + "'); return false;";

        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "SelectSite", ScriptHelper.GetScript("function  SelectSiteDialog(txtClientID,lblClientID){modalDialog('" + ResolveUrl("~/CMSWebParts/Designers/SiteSelection.aspx") + "?lblElem=' + lblClientID + '&txtElem=' + txtClientID,'SiteSelection', 400, 500); return false;}" +
                                                                                                              "function SelectSite(siteCode,txtClientID,lblClientID){if((lblClientID != '') && (txtClientID != '')) { document.getElementById(txtClientID).value = siteCode; document.getElementById(lblClientID).innerHTML='';} return false;}" + 
                                                                                                              "function CheckSite(result, context){document.getElementById(context).innerHTML = result; return false; }"));      
        
        this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), ScriptHelper.DIALOG_SCRIPT_KEY, ScriptHelper.DialogScript);
    }


    /// <summary>
    /// Gets or sets field value.
    /// </summary>
    public override object Value
    {
        get
        {
            return this.txtName.Text;
        }
        set
        {
            this.txtName.Text = (string)value;
        }
    }


    /// <summary>
    /// Return true if user control is valid.
    /// </summary>
    /// <returns></returns>
    public override bool IsValid()
    {
        string ValidationResult = Validate(txtName.Text);
        if (ValidationResult == string.Empty)
        {
            return true;
        }
        else
        {
            this.ValidationError = ValidationResult;
            return false;
        }
    }
}
