// TODO: create styles for classes ForumFlatView_PostIndent, ForumFlatView_Panel, ForumFlatView_PostContent

using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.Forums;
using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.URLRewritingEngine;

public partial class CMSForum_ForumFlatView : System.Web.UI.UserControl
{
    /// <summary>
    /// Forum properties
    /// </summary>
    public ForumProperties mForumProperties = new ForumProperties();

    private bool isAuthenticated = false;
    private string mControlPath = "~/CMSForum/ForumPost.ascx";
    private string threadId = "";
    private string SearchText = "";
    private bool mSearchResults = false;

    private bool showThreads = false;
    //private bool showSubscribe = false;


    private string threadName = "";


    #region "Public properties"

    /// <summary>
    /// Enable display user picture.
    /// </summary>
    public bool EnablePicture
    {
        get { return mForumProperties.EnablePicture; ; }
        set { mForumProperties.EnablePicture = value; }
    }


    /// <summary>
    /// Max. picture width
    /// </summary>
    public int MaxPictureWidth
    {
        get { return mForumProperties.MaxPictureWidth; }
        set { mForumProperties.MaxPictureWidth = value; }
    }


    /// <summary>
    /// Max picture height
    /// </summary>
    public int MaxPictureHeight
    {
        get { return mForumProperties.MaxPictureHeight; }
        set { mForumProperties.MaxPictureHeight = value; }
    }


    /// <summary>
    /// Enable signature
    /// </summary>
    public bool EnableSignature
    {
        get { return mForumProperties.EnableSignature; }
        set { mForumProperties.EnableSignature = value; }
    }


    /// <summary>
    /// Is true when flatView is used to view search results
    /// </summary>
    public bool SearchResults
    {
        get { return mSearchResults; }
        set { mSearchResults = value; }
    }


    /// <summary>
    ///  flat view mode
    /// </summary>
    public FlatModeEnum FlatMode
    {
        get { return mForumProperties.FlatMode; }
        set { mForumProperties.FlatMode = value; }
    }


    /// <summary>
    /// Enable subscription
    /// </summary>
    public bool EnableSubscription
    {
        get { return mForumProperties.EnableSubscription; }
        set { mForumProperties.EnableSubscription = value; }
    }


    /// <summary>
    /// CheckPermissions
    /// </summary>
    public bool CheckPermissions
    {
        get { return mForumProperties.CheckPermissions; }
        set { mForumProperties.CheckPermissions = value; }
    }


    /// <summary>
    /// If set public user can read, no insert new post
    /// </summary>
    public bool NoAuthenticatedRead
    {
        get { return mForumProperties.NoAuthenticatedRead; }
        set { mForumProperties.NoAuthenticatedRead = value; }
    }


    /// <summary>
    /// AdHoc forum
    /// </summary>
    public bool AdHocForum
    {
        get { return mForumProperties.AdHocForum; }
        set { mForumProperties.AdHocForum = value; }
    }


    /// <summary>
    /// Forum Id
    /// </summary>
    public int ForumID
    {
        get { return mForumProperties.ForumID; }
        set { mForumProperties.ForumID = value; }
    }


    /// <summary>
    /// Post reply id
    /// </summary>
    public int PostReplyId
    {
        get { return mForumProperties.PostReplyId; }
        set { mForumProperties.PostReplyId = value; }
    }


    /// <summary>
    /// Post id
    /// </summary>
    public int PostId
    {
        get { return mForumProperties.PostId; }
        set { mForumProperties.PostId = value; }
    }


    /// <summary>Enable paging</summary>
    public bool EnablePaging
    {
        get { return mForumProperties.EnablePaging; }
        set { mForumProperties.EnablePaging = value; }
    }


    /// <summary>Page size</summary>
    public int PageSize
    {
        get { return mForumProperties.PageSize; }
        set { mForumProperties.PageSize = value; }
    }


    /// <summary> Stop processing </summary>
    public bool StopProcessing
    {
        get { return mForumProperties.StopProcessing; }
        set { mForumProperties.StopProcessing = value; }
    }


    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get { return mForumProperties.WhereCondition; }
        set { mForumProperties.WhereCondition = value; }
    }


    /// <summary>
    /// Path
    /// </summary>
    public string PostPath
    {
        get { return mForumProperties.PostPath; }
        set { mForumProperties.PostPath = value; }
    }


    /// <summary>
    /// Max relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get { return mForumProperties.MaxRelativeLevel; }
        set { mForumProperties.MaxRelativeLevel = value; }
    }


    /// <summary>
    /// Select only approved
    /// </summary>
    public bool SelectOnlyApproved
    {
        get { return mForumProperties.SelectOnlyApproved; }
        set { mForumProperties.SelectOnlyApproved = value; }
    }


    /// <summary>
    /// Path to post control
    /// </summary>
    public string PostControlPath
    {
        get { return mControlPath; }
        set { mControlPath = ValidationHelper.GetString(value, "~/CMSForum/ForumPost.ascx"); }
    }

    #endregion


    /// <summary>
    /// Return post numbers
    /// </summary>
    /// <param name="postNum">Default post count</param>
    /// <param name="path">Post path</param>
    /// <returns></returns>
    public string GetPostNumbers(object postNum, object path)
    {
        if (!this.mForumProperties.SelectOnlyApproved)
        {
            string mPath = ValidationHelper.GetString(path, "");

            DataSet jds = ForumPostInfoProvider.SelectForumPosts(this.ForumID, "/%", "PostIDPath = '" + mPath + "' OR PostIDPath LIKE '" + mPath + "'+'/%'", null, -1, false);
            if (!DataHelper.DataSourceIsEmpty(jds))
            {
                return jds.Tables[0].Rows.Count.ToString();
            }
        }

        return ValidationHelper.GetString(ValidationHelper.GetInteger(postNum, 0), "0");
    }


    protected void Page_Load(object sender, EventArgs e)
    {
        frmNewPost.mForumProperties = this.mForumProperties;

        //Check if isn't unsubscribe request
        mForumProperties.CheckUnsubscribe();


        // If search results are showed, get Forum ID from query string
        if (mSearchResults)
        {
            if (ValidationHelper.GetInteger(Request.QueryString[mForumProperties.QueryStringForumID], 0) != 0)
            {
                this.ForumID = ValidationHelper.GetInteger(Request.QueryString[mForumProperties.QueryStringForumID], 0);
            }
        }



        // Set view mode
        if (IsPostBack)
        {
            FlatMode = ForumModes.GetFlatMode(drpModes.SelectedValue);
        }

        // Get threadId and search text from query strings, if exists
        if (ValidationHelper.GetString(Request.QueryString[mForumProperties.QueryStringThread], "") != "")
        {
            threadId = ValidationHelper.GetString(Request.QueryString[mForumProperties.QueryStringThread], "");
        }

        if (ValidationHelper.GetString(Request.QueryString["SearchForum"], "") != "")
        {
            SearchText = ValidationHelper.GetString(Request.QueryString["SearchForum"], "");


            if (!mForumProperties.IsSearchResult)
            {
                StopProcessing = true;
                return;
            }
        }


        // Show thread
        if (threadId != null && threadId != "")
        {
            Threads.Visible = false;
            Posts.Visible = true;

            dtgThreads.Enabled = false;
            dtgFlat.Enabled = true;

            showThreads = true;

            lblModes.Visible = true;
            drpModes.Visible = true;


            lblModes.Text = ResHelper.GetString("FlatForum.ModesLabel");

            // If isn't postback fill dropdownlist with view modes
            if (!IsPostBack)
            {
                ListItem li = new ListItem(ResHelper.GetString("FlatForum.ModeThreaded"), "Threaded");
                drpModes.Items.Add(li);
                li = new ListItem(ResHelper.GetString("FlatForum.ModeNewest"), "NewestToOldest");
                drpModes.Items.Add(li);
                li = new ListItem(ResHelper.GetString("FlatForum.ModeOldest"), "OldestToNewest");
                drpModes.Items.Add(li);

                drpModes.SelectedValue = FlatMode.ToString();
            }
        }


        // If forum is AdHoc try get it by documentId
        if (this.AdHocForum)
        {
            if (CMSContext.CurrentDocument != null)
            {
                int documentId = CMSContext.CurrentDocument.DocumentID;
                ForumInfo mFi = ForumInfoProvider.GetForumInfoByDocument(documentId);

                if (mFi != null)
                {
                    this.ForumID = mFi.ForumID;
                }
            }
        }

        bool mClosed = false;
        isAuthenticated = mForumProperties.CheckPermission(this.ForumID);
        //Check permissions
        if (((!isAuthenticated) && (!NoAuthenticatedRead)) && (this.Visible))
        {
            StopProcessing = true;
            return;
        }

        if (this.StopProcessing) return;

        dtgFlat.AllowPaging = this.EnablePaging;
        dtgFlat.PageSize = this.PageSize;

        // Geto forum info and set forum header text
        ForumInfo fi = ForumInfoProvider.GetForumInfo(this.ForumID);
        if (fi != null)
        {
            lblForumHeader.Text = HTMLHelper.HTMLEncode(ResHelper.LocalizeString(fi.ForumDisplayName));
            lblForumHeaderDescription.Text = HTMLHelper.HTMLEncode(ResHelper.LocalizeString(fi.ForumDescription));

            // ForumPost1.DisplayEmail = fi.ForumDisplayEmails;

            if (!fi.ForumOpen)
            {
                mClosed = true;
            }
        }

        // If is ad-hoc forum displayed hide info area
        if (this.AdHocForum)
        {
            plcInfoArea.Visible = false;
        }

        // New thread and subscription link
        if ((this.ForumID > 0 || this.AdHocForum) && (!mClosed))
        {

            lnkNewThread.Visible = true;
            lnkNewThread.Text = ResHelper.GetString("Forums.Forum.lnkNewThread");
            lnkNewThread.NavigateUrl = "javascript:NewThread();";

            if (EnableSubscription)
            {
                lnkSubscription.Visible = true;
                lnkSubscription.Text = ResHelper.GetString("Forums.Forum.SubscribeForum");
                lnkSubscription.NavigateUrl = "javascript:NewSubscribe(0);";
            }
        }

        // Hide new thread and subscription for No authenticated  ca n read a nd for thread view
        if ((!isAuthenticated) && (NoAuthenticatedRead) || ((threadId != null) && (threadId.Trim() != "")))
        {
            lnkNewThread.Visible = false;
            //  ForumPost1.AllowReply = false;
            lnkSubscription.Visible = false;

            lblSeparator.Visible = false;
        }

        //Hide new subscribe
        frmNewsubscribe.Visible = false;


        // Hide New post
        frmNewPost.Visible = false;
        frmNewPost.ForumID = this.ForumID;
        frmNewPost.AdHocForum = this.AdHocForum;
        frmNewPost.EnableSubscription = this.EnableSubscription;

        // Set data to forms
        frmNewPost.ReplyToPostID = ValidationHelper.GetInteger(hdnPostId.Value, -1);

        frmNewsubscribe.ForumID = this.ForumID;
        frmNewsubscribe.PostID = ValidationHelper.GetInteger(this.hdnSubscribeId.Value, 0);

        // Hide lnk "NEW THREAD"
        if ((frmNewPost.ReplyToPostID >= 0))
        {
            lnkNewThread.Visible = false;
            lnkSubscription.Visible = false;
            lblModes.Visible = false;
            drpModes.Visible = false;
            lblSeparator.Visible = false;
            BreadCrumbs.Visible = false;
        }

        //Load data
        GetData();

        //Set Data for breadcrumbs
        string mForumName = "";
        string mPath = "";
        string mThreadName = "";
        string mGroupName = "";
        if (fi != null)
        {
            mForumName = fi.ForumDisplayName;
            ForumGroupInfo fgi = ForumGroupInfoProvider.GetForumGroupInfo(fi.ForumGroupID);
            if (fgi != null)
            {
                mGroupName = ResHelper.LocalizeString(fgi.GroupDisplayName);
            }
        }

        string query = HttpContext.Current.Request.Url.Query;
        string url = URLRewriter.CurrentURL;

        if (url.Contains("?"))
        {
            url = url.Remove(url.IndexOf('?'));
        }

        query = UrlHelper.RemoveUrlParameter(query, "AliasPath");
        query = UrlHelper.RemoveUrlParameter(query, mForumProperties.QueryStringThread);
        query = UrlHelper.AddUrlParameter(query, mForumProperties.QueryStringThread, mPath);


        // Special insert breadcrumbs for search result
        if ((SearchText != null) && (SearchText.Trim() != ""))
        {
            string[,] pageTitleTabs = null;

            lnkNewThread.Visible = false;
            lnkSubscription.Visible = false;

            if (!threadId.StartsWith("/"))
            {
                mPath = "/" + threadId;
            }

            mThreadName = threadName;

            pageTitleTabs = new string[2, 3];

            pageTitleTabs[0, 0] = ResHelper.GetString("ForumResults.SearchResults");
            pageTitleTabs[0, 1] = url + UrlHelper.RemoveUrlParameter(UrlHelper.RemoveUrlParameter(query, mForumProperties.QueryStringForumID), mForumProperties.QueryStringThread);
            pageTitleTabs[0, 2] = "";
            pageTitleTabs[1, 0] = mThreadName;
            pageTitleTabs[1, 1] = "";
            pageTitleTabs[1, 2] = "";

            BreadCrumbs.Breadcrumbs = pageTitleTabs;
            BreadCrumbs.SeparatorText = " > ";

        }
        else // Breadcrumbs for Forum
        {

            //Show thread breadcrumbs
            if ((threadId != null) && (threadId != ""))
            {

                if (!threadId.StartsWith("/"))
                {
                    mPath = "/" + threadId;
                }

                mThreadName = threadName;

                string[,] pageTitleTabs = null;

                // Only Flat forum
                if (ValidationHelper.GetString(Request.QueryString[mForumProperties.QueryStringForumID], "") == "")
                {
                    pageTitleTabs = new string[2, 3];

                    pageTitleTabs[0, 0] = HTMLHelper.HTMLEncode(ResHelper.LocalizeString(HttpUtility.HtmlDecode(mForumName)));
                    pageTitleTabs[0, 1] = url + query;
                    pageTitleTabs[0, 2] = "";
                    pageTitleTabs[1, 0] = mThreadName;
                    pageTitleTabs[1, 1] = "";
                    pageTitleTabs[1, 2] = "";
                }
                else // Group forum
                {
                    pageTitleTabs = new string[3, 3];

                    pageTitleTabs[0, 0] = mGroupName;
                    pageTitleTabs[0, 1] = url + UrlHelper.RemoveUrlParameter(query, mForumProperties.QueryStringForumID);
                    pageTitleTabs[0, 2] = "";
                    pageTitleTabs[1, 0] = HTMLHelper.HTMLEncode(ResHelper.LocalizeString(HttpUtility.HtmlDecode(mForumName)));
                    pageTitleTabs[1, 1] = url + query;
                    pageTitleTabs[1, 2] = "";
                    pageTitleTabs[2, 0] = mThreadName;
                    pageTitleTabs[2, 1] = "";
                    pageTitleTabs[2, 2] = "";
                }

                BreadCrumbs.Breadcrumbs = pageTitleTabs;
                BreadCrumbs.SeparatorText = " > ";
            }
            else // Show breadcrumbs for forum
            {
                if (Request.QueryString[mForumProperties.QueryStringForumID] == null || ValidationHelper.GetString(Request.QueryString[mForumProperties.QueryStringForumID], "") == "")
                {
                }
                else
                {
                    string[,] pageTitleTabs = null;

                    pageTitleTabs = new string[2, 3];

                    pageTitleTabs[0, 0] = HTMLHelper.HTMLEncode(ResHelper.LocalizeString(HttpUtility.HtmlDecode(mGroupName))); ;
                    pageTitleTabs[0, 1] = url + UrlHelper.RemoveUrlParameter(query, mForumProperties.QueryStringForumID);
                    pageTitleTabs[0, 2] = "";
                    pageTitleTabs[1, 0] = HTMLHelper.HTMLEncode(ResHelper.LocalizeString(HttpUtility.HtmlDecode(mForumName)));
                    pageTitleTabs[1, 1] = "";
                    pageTitleTabs[1, 2] = "";

                    BreadCrumbs.Breadcrumbs = pageTitleTabs;
                    BreadCrumbs.SeparatorText = " > ";
                    BreadCrumbs.Visible = true;

                    lblSeparator.Text = " | ";
                    lblSeparator.Visible = true;
                }
            }
        }

        // Register javascripts
        if (this.Visible)
        {
            // Register javascripts
            this.Page.ClientScript.RegisterClientScriptBlock(typeof(string), "ForumScripts",
                       ScriptHelper.GetScript(
                       "function ReplyToPost(postId) { \n " +
                       "document.getElementById('" + hdnPostId.ClientID + "').value = postId; \n" +
                       this.Page.ClientScript.GetPostBackEventReference(this.btnPostb, null) +
                       "}\n" +

                       "function ShowPost(showId) { \n " +
                       "document.getElementById('" + hdnShowId.ClientID + "').value = showId; \n" +
                       this.Page.ClientScript.GetPostBackEventReference(this.btnPostb, null) +
                       "}\n" +

                       "function NewThread() { \n " +
                       "document.getElementById('" + hdnPostId.ClientID + "').value = 0; \n" +
                       this.Page.ClientScript.GetPostBackEventReference(this.btnPostb, null) +
                       "}\n" +

                       "function NewSubscribe(subscribeId) { \n " +
                       "document.getElementById('" + this.hdnSubscribeId.ClientID + "').value = subscribeId; \n" +
                       this.Page.ClientScript.GetPostBackEventReference(this.btnPostb, null) +
                       "}\n" +

                       "function SelectNode(nodeElem) { }\n "));
        }

        frmNewPost.OnInsertPost += new EventHandler(frmNewPost_OnInsertPost);
        frmNewPost.mForumProperties = this.mForumProperties;

    }


    /// <summary>
    /// OnInsertPost handler
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    void frmNewPost_OnInsertPost(object sender, EventArgs e)
    {
        // If forum id isn't sets, set it from sender forum ID
        if (this.ForumID == 0)
        {
            this.ForumID = ((CMSForum_ForumNewPost)sender).ForumID;
        }
        
        // Get forum info
        ForumInfo forInf = ForumInfoProvider.GetForumInfo(this.ForumID);

        // Load data
        GetData();

        frmNewPost.AllowRedirect = false;

        // Display correct area for current forum
        if (showThreads)
        {
            dtgFlat.Visible = true;
            BreadCrumbs.Visible = true;
        }
        else
        {
            dtgThreads.Visible = true;
            lnkNewThread.Visible = true;
            if (frmNewPost.EnableSubscription)
            {
                lblLinkSeparator.Visible = true;
                lnkSubscription.Visible = true;
            }
        }

        // Display confirmation message if forum is moderated
        if (forInf != null)
        {
            if (forInf.ForumModerated)
            {
                plcInformations.Visible = true;
                lblInformations.Text = ResHelper.GetString("Forums.ModeratedPostAdded");
            }
        }


    }

    /// <summary>
    /// Return HTML encoded string
    /// </summary>
    /// <param name="value"></param>
    /// <returns></returns>
    public string GetEncodedValue(object value)
    {
        string toReturn = Server.HtmlDecode(value.ToString());
        return Server.HtmlEncode(toReturn);
    }

    /// <summary>
    /// Load data
    /// </summary>
    private void GetData()
    {
        // Load data for posts or Threads
        if ((threadId != null) && (threadId != ""))
        {
            dtgFlat.PageIndexChanged += new DataGridPageChangedEventHandler(dtgFlat_PageIndexChanged);

            // Create post path
            string mPath = "";

            if (!threadId.StartsWith("/"))
            {
                mPath = "/" + threadId;
            }

            mPath = mPath.TrimEnd('%');
            mPath = mPath.TrimEnd('/');

            mPath += "%";

            // Set post order
            string mOrder = "PostIDPath,PostTime";

            if (FlatMode == FlatModeEnum.NewestToOldest)
            {
                mOrder = "PostTime DESC";
            }

            if (FlatMode == FlatModeEnum.OldestToNewest)
            {
                mOrder = "PostTime";
            }

            // Load posts dataset
            DataSet dsPosts = ForumPostInfoProvider.SelectForumPosts(this.ForumID, mPath, this.WhereCondition, mOrder, this.MaxRelativeLevel, this.SelectOnlyApproved);

            // Create posts view
            if (!DataHelper.DataSourceIsEmpty(dsPosts))
            {
                threadName = Server.HtmlEncode(ValidationHelper.GetString(dsPosts.Tables[0].Rows[0]["PostSubject"], ""));

                dtgFlat.DataSource = dsPosts;
                dtgFlat.ItemDataBound += new DataGridItemEventHandler(dtgFlat_ItemDataBound);
                dtgFlat.DataBind();
            }
        }
        else if (this.ForumID > 0) // Threads 
        {
            dtgThreads.PageIndexChanged += new DataGridPageChangedEventHandler(dtgThreads_PageIndexChanged);

            // Load posts dataset
            DataSet dsPosts = ForumPostInfoProvider.SelectForumPosts(this.ForumID, this.PostPath, this.WhereCondition, "PostThreadLastPostTime DESC", 0, this.SelectOnlyApproved);

            // Create thread view
            if (!DataHelper.DataSourceIsEmpty(dsPosts))
            {
                threadName = Server.HtmlEncode(ValidationHelper.GetString(dsPosts.Tables[0].Rows[0]["PostSubject"], ""));

                dtgThreads.DataSource = dsPosts;
                dtgThreads.Columns[0].HeaderText = ResHelper.GetString("ForumThreadList.ThreadName");
                dtgThreads.Columns[1].HeaderText = ResHelper.GetString("ForumThreadList.CreatedBy");
                dtgThreads.Columns[2].HeaderText = ResHelper.GetString("ForumThreadList.Posts");
                dtgThreads.Columns[3].HeaderText = ResHelper.GetString("ForumThreadList.LastUser");
                dtgThreads.DataBind();
            }
        }
    }


    /// <summary>
    /// Set actual page index in thread list
    /// </summary>
    /// <param name="source"></param>
    /// <param name="e"></param>
    void dtgThreads_PageIndexChanged(object source, DataGridPageChangedEventArgs e)
    {
        dtgThreads.CurrentPageIndex = e.NewPageIndex;
        dtgThreads.DataBind();
    }

    /// <summary>
    /// Return last user
    /// </summary>
    /// <param name="username"></param>
    /// <param name="postPath"></param>
    /// <returns></returns>
    public string GetLastUser(object username, string postPath)
    {
        if ((!mForumProperties.SelectOnlyApproved) && (username == null || username.ToString() == ""))
        {
            DataSet ds = ForumPostInfoProvider.SelectForumPosts(this.ForumID, "/%", null, "PostTime Desc", -1, false, 1);
            if (!DataHelper.DataSourceIsEmpty(ds))
            {
                ForumPostInfo fpi = new ForumPostInfo(ds.Tables[0].Rows[0]);
                if (fpi != null)
                {
                    return fpi.PostUserName;
                }
            }
        }

        return username.ToString();
    }

    /// <summary>
    /// Return last time
    /// </summary>
    /// <param name="time"></param>
    /// <param name="postPath"></param>
    /// <returns></returns>
    public string GetLastPostTime(object time, string postPath)
    {
        if ((!mForumProperties.SelectOnlyApproved)&&(time == null || time.ToString() == ""))
        {
            DataSet ds = ForumPostInfoProvider.SelectForumPosts(this.ForumID, "/%", null, "PostTime Desc", -1, false, 1);
            if (!DataHelper.DataSourceIsEmpty(ds))
            {
                ForumPostInfo fpi = new ForumPostInfo(ds.Tables[0].Rows[0]);
                if (fpi != null)
                {
                    return fpi.PostTime.ToString();
                }
            }
        }

        return time.ToString();
    }

    /// <summary>
    /// Return thread link
    /// </summary>
    public string ThreadLink(object postId)
    {
        // Get path from postId
        string mPath = ForumPostInfoProvider.GetPath("", ValidationHelper.GetInteger(postId, 0)).TrimStart('/');

        // Get current url
        string url = HttpContext.Current.Request.RawUrl;

        // Returns the url handled by handler404 page
        url = URLRewriter.GetHandledUrl(url);

        // Remove "aliaspath" from url
        url = UrlHelper.RemoveParameterFromUrl(url, "aliaspath");
        
        // Add forum parameters to the querystring
        url = UrlHelper.AddParameterToUrl(url, mForumProperties.QueryStringThread, mPath);

        return url;

    }


    /// <summary>
    /// Set actual page index
    /// </summary>
    /// <param name="source"></param>
    /// <param name="e"></param>
    void dtgFlat_PageIndexChanged(object source, DataGridPageChangedEventArgs e)
    {
        // Set new page index and databind it
        dtgFlat.CurrentPageIndex = e.NewPageIndex;
        dtgFlat.DataBind();
    }


    /// <summary>
    /// DataGrid item databound
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    void dtgFlat_ItemDataBound(object sender, DataGridItemEventArgs e)
    {
        if (e.Item.DataItem != null)
        {
            // Load post control
            ForumPostControl mForumPost = (ForumPostControl)this.LoadControl(mControlPath);
            
            // Set forum properties
            mForumPost.mForumProperties = this.mForumProperties;
            mForumPost.EnableSubscription = this.EnableSubscription;

            // Disable reply and subscription if it is not allowed
            if ((!isAuthenticated) && (NoAuthenticatedRead))
            {
                mForumPost.AllowReply = false;
                mForumPost.EnableSubscription = false;
            }

            // if post is in max level disable reply and subscribe
            if ((this.MaxRelativeLevel != -1) && (ValidationHelper.GetInteger(((DataRowView)e.Item.DataItem).Row["PostLevel"], 0)) >= this.MaxRelativeLevel)
            {
                mForumPost.AllowReply = false;
                mForumPost.EnableSubscription = false;
            }

            // Check if forum display emails
            ForumInfo fi = ForumInfoProvider.GetForumInfo(this.ForumID);
            if (fi != null)
            {
                mForumPost.DisplayEmail = fi.ForumDisplayEmails;
            }

            // Set post datarow
            mForumPost.PostSrcDataRow = ((DataRowView)e.Item.DataItem).Row;

            // Generate HTML code

            Literal divs = new Literal();
            Literal endDivs = new Literal();
            string div = "";
            string endDiv = "";

            if (((DataRowView)e.Item.DataItem != null) && (FlatMode == FlatModeEnum.Threaded))
            {
                int level = ValidationHelper.GetInteger(((DataRowView)e.Item.DataItem)["PostLevel"], 0);
                for (int i = 0; i < level; i++)
                {
                    div += "<div class=\"PostIndent\">\n";
                    endDiv += "</div>\n";
                }
            }

            divs.Text = div;
            endDivs.Text = endDiv;

            e.Item.Cells[0].Controls.Clear();

            e.Item.Cells[0].Controls.Add(divs);
            e.Item.Cells[0].Controls.Add(mForumPost);
            e.Item.Cells[0].Controls.Add(endDivs);
        }
    }

    
    /// <summary>
    /// Hidden button click handler
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnPostb_Click(object sender, EventArgs e)
    {
        // Display separator if it's necessary
        if (lnkNewThread.Visible && lnkSubscription.Visible)
        {
            lblLinkSeparator.Text = " | ";
            lblLinkSeparator.Visible = true;
        }

        // Hide links to new thread, reply... if it isn't allowed
        if ((isAuthenticated) || (NoAuthenticatedRead))
        {
            // Show post
            if (ValidationHelper.GetInteger(hdnShowId.Value, 0) != 0)
            {
                dtgFlat.Visible = false;
                dtgThreads.Visible = false;
                frmNewPost.Visible = false;
                hdnShowId.Value = "";
                lblModes.Visible = false;
                drpModes.Visible = false;
                return;
            }
        }

        if (isAuthenticated)
        {
            //Subscribe
            if (ValidationHelper.GetInteger(this.hdnSubscribeId.Value, -1) >= 0)
            {
                lnkNewThread.Visible = false;
                lnkSubscription.Visible = false;

                frmNewsubscribe.Visible = true;
                dtgFlat.Visible = false;
                dtgThreads.Visible = false;
                frmNewsubscribe.ForumID = this.ForumID;
                frmNewsubscribe.PostID = ValidationHelper.GetInteger(this.hdnSubscribeId.Value, 0);
                frmNewPost.Visible = false;

                lblModes.Visible = false;
                drpModes.Visible = false;
                lblSeparator.Visible = false;
                BreadCrumbs.Visible = false;


                lblLinkSeparator.Visible = false;
                //this.hdnSubscribeId.Value = "";
            }
            else
            {
                // Reply to post or New thread post
                if (ValidationHelper.GetInteger(hdnPostId.Value, -1) >= 0)
                {
                    frmNewPost.ClearForm();
                    dtgFlat.Visible = false;
                    dtgThreads.Visible = false;
                    lblModes.Visible = false;
                    drpModes.Visible = false;
                    lblLinkSeparator.Visible = false;

                    frmNewPost.ReplyToPostID = ValidationHelper.GetInteger(hdnPostId.Value, 0);
                    // ForumPost1.Visible = false;
                    frmNewPost.Visible = true;
                    return;
                }
            }
        }
    }


    /// <summary> 
    /// Render 
    /// </summary>
    /// <param name="writer"></param>
    protected override void Render(HtmlTextWriter writer)
    {
        // Do not render any content if stop processing is defined
        if (!this.StopProcessing)
        {
            if (lnkNewThread.Visible && lnkSubscription.Visible)
            {
                lblLinkSeparator.Text = " | ";
                lblLinkSeparator.Visible = true;
            }

            base.Render(writer);
        }
    }

}
