CREATE TABLE [CMS_State] (
		[StateID]              int NOT NULL IDENTITY(1, 1),
		[StateDisplayName]     nvarchar(200) NOT NULL,
		[StateName]            nvarchar(200) NOT NULL,
		[StateCode]            nvarchar(100) NULL,
		[CountryID]            int NOT NULL
)
ON [PRIMARY]
ALTER TABLE [CMS_State]
	ADD
	CONSTRAINT [PK_CMS_State]
	PRIMARY KEY
	([StateID])
	ON [PRIMARY]
IF OBJECT_ID(N'[CMS_State]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Country]') IS NOT NULL
	AND OBJECT_ID(N'[FK_CMS_State_CMS_Country]') IS NULL
BEGIN
		ALTER TABLE [CMS_State]
			WITH NOCHECK
			ADD CONSTRAINT [FK_CMS_State_CMS_Country]
			FOREIGN KEY ([CountryID]) REFERENCES [CMS_Country] ([CountryID])
			NOT FOR REPLICATION
END
CREATE INDEX [FK_CMS_State]
	ON [CMS_State] ([CountryID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_State]
	ON [CMS_State] ([StateDisplayName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_State_1]
	ON [CMS_State] ([StateName])
	ON [PRIMARY]
