CREATE TABLE [CMS_Tree] (
		[NodeID]                        int NOT NULL IDENTITY(1, 1),
		[NodeAliasPath]                 nvarchar(450) NOT NULL,
		[NodeName]                      nvarchar(100) NOT NULL,
		[NodeAlias]                     nvarchar(50) NOT NULL,
		[NodeClassID]                   int NOT NULL,
		[NodeParentID]                  int NOT NULL,
		[NodeLevel]                     int NOT NULL,
		[NodeACLID]                     int NULL,
		[NodeSiteID]                    int NOT NULL,
		[NodeGUID]                      uniqueidentifier NULL,
		[NodeOrder]                     int NULL,
		[IsSecuredNode]                 bit NULL,
		[NodeCacheMinutes]              int NULL,
		[NodeSKUID]                     int NULL,
		[NodeDocType]                   ntext NULL,
		[NodeHeadTags]                  ntext NULL,
		[NodeBodyElementAttributes]     ntext NULL,
		[NodeInheritPageLevels]         nvarchar(200) NULL,
		[NodeChildNodesCount]           int NULL,
		[RequiresSSL]                   bit NULL,
		[NodeLinkedNodeID]              int NULL,
		[NodeOwner]                     int NULL,
		[NodeCustomData]                ntext NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [CMS_Tree]
	ADD
	CONSTRAINT [PK__CMS_Tree__20C1E124]
	PRIMARY KEY
	([NodeID])
	ON [PRIMARY]
IF OBJECT_ID(N'[CMS_Tree]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_ACL]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Tree__NodeAC__21B6055D]') IS NULL
BEGIN
		ALTER TABLE [CMS_Tree]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Tree__NodeAC__21B6055D]
			FOREIGN KEY ([NodeACLID]) REFERENCES [CMS_ACL] ([ACLID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_Tree]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Class]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Tree__NodeCl__22AA2996]') IS NULL
BEGIN
		ALTER TABLE [CMS_Tree]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Tree__NodeCl__22AA2996]
			FOREIGN KEY ([NodeClassID]) REFERENCES [CMS_Class] ([ClassID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_Tree]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Site]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Tree__NodeSi__239E4DCF]') IS NULL
BEGIN
		ALTER TABLE [CMS_Tree]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Tree__NodeSi__239E4DCF]
			FOREIGN KEY ([NodeSiteID]) REFERENCES [CMS_Site] ([SiteID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_Tree]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Tree]') IS NOT NULL
	AND OBJECT_ID(N'[FK_CMS_Tree_CMS_Tree]') IS NULL
BEGIN
		ALTER TABLE [CMS_Tree]
			ADD CONSTRAINT [FK_CMS_Tree_CMS_Tree]
			FOREIGN KEY ([NodeLinkedNodeID]) REFERENCES [CMS_Tree] ([NodeID])
END
IF OBJECT_ID(N'[CMS_Tree]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_Tree]') IS NOT NULL
	AND OBJECT_ID(N'[FK_CMS_Tree_CMS_Tree1]') IS NULL
BEGIN
		ALTER TABLE [CMS_Tree]
			ADD CONSTRAINT [FK_CMS_Tree_CMS_Tree1]
			FOREIGN KEY ([NodeID]) REFERENCES [CMS_Tree] ([NodeID])
END
IF OBJECT_ID(N'[CMS_Tree]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_User]') IS NOT NULL
	AND OBJECT_ID(N'[FK_CMS_Tree_CMS_User]') IS NULL
BEGIN
		ALTER TABLE [CMS_Tree]
			ADD CONSTRAINT [FK_CMS_Tree_CMS_User]
			FOREIGN KEY ([NodeOwner]) REFERENCES [CMS_User] ([UserID])
END
CREATE INDEX [IX_CMS_Tree]
	ON [CMS_Tree] ([NodeAlias])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_1]
	ON [CMS_Tree] ([NodeAliasPath])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_10]
	ON [CMS_Tree] ([NodeLinkedNodeID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_11]
	ON [CMS_Tree] ([NodeOwner])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_2]
	ON [CMS_Tree] ([NodeName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_3]
	ON [CMS_Tree] ([NodeClassID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_4]
	ON [CMS_Tree] ([NodeParentID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_5]
	ON [CMS_Tree] ([NodeLevel])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_6]
	ON [CMS_Tree] ([NodeACLID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_7]
	ON [CMS_Tree] ([NodeSiteID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_8]
	ON [CMS_Tree] ([NodeGUID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_9]
	ON [CMS_Tree] ([NodeOrder])
	ON [PRIMARY]
CREATE UNIQUE INDEX [IX_CMS_Tree_NodeGUID_NodeSiteID]
	ON [CMS_Tree] ([NodeSiteID], [NodeGUID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_NodeLinkedNodeID]
	ON [CMS_Tree] ([NodeLinkedNodeID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_Tree_NodeOwner]
	ON [CMS_Tree] ([NodeOwner])
	ON [PRIMARY]
