CREATE TABLE [CMS_WorkflowHistory] (
		[WorkflowHistoryID]     int NOT NULL IDENTITY(1, 1),
		[VersionHistoryID]      int NOT NULL,
		[StepID]                int NULL,
		[StepDisplayName]       nvarchar(450) NOT NULL,
		[ApprovedByUserID]      int NULL,
		[ApprovedWhen]          datetime NULL,
		[Comment]               ntext NULL,
		[WasRejected]           bit NOT NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [CMS_WorkflowHistory]
	ADD
	CONSTRAINT [PK__CMS_WorkflowHist__7F2BE32F]
	PRIMARY KEY
	([WorkflowHistoryID])
	ON [PRIMARY]
IF OBJECT_ID(N'[CMS_WorkflowHistory]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_User]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Workf__Appro__00200768]') IS NULL
BEGIN
		ALTER TABLE [CMS_WorkflowHistory]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Workf__Appro__00200768]
			FOREIGN KEY ([ApprovedByUserID]) REFERENCES [CMS_User] ([UserID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_WorkflowHistory]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_WorkflowStep]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Workf__StepI__02084FDA]') IS NULL
BEGIN
		ALTER TABLE [CMS_WorkflowHistory]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Workf__StepI__02084FDA]
			FOREIGN KEY ([StepID]) REFERENCES [CMS_WorkflowStep] ([StepID])
			NOT FOR REPLICATION
END
IF OBJECT_ID(N'[CMS_WorkflowHistory]') IS NOT NULL
	AND OBJECT_ID(N'[CMS_VersionHistory]') IS NOT NULL
	AND OBJECT_ID(N'[FK__CMS_Workf__Versi__01142BA1]') IS NULL
BEGIN
		ALTER TABLE [CMS_WorkflowHistory]
			WITH NOCHECK
			ADD CONSTRAINT [FK__CMS_Workf__Versi__01142BA1]
			FOREIGN KEY ([VersionHistoryID]) REFERENCES [CMS_VersionHistory] ([VersionHistoryID])
			NOT FOR REPLICATION
END
CREATE INDEX [IX_CMS_WorkflowHistory]
	ON [CMS_WorkflowHistory] ([VersionHistoryID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_WorkflowHistory_1]
	ON [CMS_WorkflowHistory] ([StepID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_WorkflowHistory_2]
	ON [CMS_WorkflowHistory] ([StepDisplayName])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_WorkflowHistory_3]
	ON [CMS_WorkflowHistory] ([ApprovedByUserID])
	ON [PRIMARY]
CREATE INDEX [IX_CMS_WorkflowHistory_4]
	ON [CMS_WorkflowHistory] ([ApprovedWhen])
	ON [PRIMARY]
