CREATE PROCEDURE [Proc_CMS_Site_DeleteRoot]
	@SiteID int
AS
BEGIN
	-- Delete complete site workflow history
	DELETE FROM CMS_WorkflowHistory WHERE 
		VersionHistoryID IN (SELECT VersionHistoryID FROM CMS_VersionHistory WHERE 
			DocumentID IN (SELECT DocumentID FROM CMS_Document WHERE 
				DocumentNodeID IN (SELECT NodeID FROM CMS_Tree WHERE NodeSiteID=@SiteID)));
	-- Update the documents
	UPDATE CMS_Document SET DocumentCheckedOutVersionHistoryID = NULL, DocumentCheckedOutByUserID = NULL, 
		DocumentCheckedOutWhen = NULL WHERE 
			DocumentCheckedOutVersionHistoryID IN (SELECT VersionHistoryID FROM CMS_VersionHistory WHERE 
				DocumentID IN (SELECT DocumentID FROM CMS_Document WHERE 
					DocumentNodeID IN (SELECT NodeID FROM CMS_Tree WHERE NodeSiteID=@SiteID)));
	UPDATE CMS_Document SET DocumentPublishedVersionHistoryID = NULL WHERE
		DocumentPublishedVersionHistoryID IN (SELECT VersionHistoryID FROM CMS_VersionHistory WHERE 
			DocumentID IN (SELECT DocumentID FROM CMS_Document WHERE 
				DocumentNodeID IN (SELECT NodeID FROM CMS_Tree WHERE NodeSiteID=@SiteID)));
	-- Delete complete version history
	DELETE FROM CMS_VersionHistory WHERE 
		DocumentID IN (SELECT DocumentID FROM CMS_Document WHERE 
			DocumentNodeID IN (SELECT NodeID FROM CMS_Tree WHERE NodeSiteID=@SiteID));
	-- Delete the document data
	DELETE FROM CMS_Document WHERE 
		DocumentNodeID IN (SELECT NodeID FROM CMS_Tree WHERE NodeSiteID=@SiteID);
	-- Delete root eventlog data
	DELETE FROM CMS_EventLog WHERE NodeID IN (SELECT NodeID FROM CMS_Tree WHERE NodeSiteID=@SiteID);
	-- Delete the node data
	DELETE FROM CMS_Tree WHERE NodeSiteID=@SiteID;
END
