-- =============================================
-- Author:		<Author,,Name>
-- Create date: <Create Date,,>
-- Description:	<Description,,>
-- =============================================
CREATE PROCEDURE [Proc_CMS_User_RemoveDependences]
	@ID int
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
	BEGIN TRANSACTION;
	-- deletes dependences in CMS_UserSite and CMS_UserRole
    DELETE FROM [CMS_UserSite] WHERE UserID=@ID;
	DELETE FROM [CMS_UserRole] WHERE UserID=@ID;
	-- delete dependences in Forums_ForumModerators
	DELETE FROM [Forums_ForumModerators] WHERE UserID=@ID;
	-- updates dependences in CMS_EventLog, CMC_Document, CMS_VersionHistory and CMS_WorkflowHistory
	UPDATE [CMS_Document] SET DocumentCreatedByUserID=NULL WHERE DocumentCreatedByUserID=@ID;
	UPDATE [CMS_Document] SET DocumentCheckedOutByUserID=NULL WHERE DocumentCheckedOutByUserID=@ID;
	UPDATE [CMS_Document] SET DocumentModifiedByUserID=NULL WHERE DocumentModifiedByUserID=@ID;
	UPDATE [CMS_EventLog] SET UserID=NULL WHERE UserID=@ID
	UPDATE CMS_VersionHistory SET ModifiedByUserID=NULL WHERE ModifiedByUserID=@ID;
	UPDATE CMS_WorkflowHistory SET ApprovedByUserID=NULL WHERE ApprovedByUserID=@ID;
	-- remove dependences in NodeOwner
	UPDATE [CMS_Tree] SET NodeOwner=NULL WHERE NodeOwner=@ID;
	-- remove dependences in CMS_ACLItem
	DELETE FROM CMS_ACLItem WHERE UserID = @ID;
	UPDATE CMS_ACLItem SET LastModifiedByUserID=NULL WHERE LastModifiedByUserID=@ID;
	-- update dependences in COM_Customer, COM_OrderStatusUser, COM_ShoppingCart
	UPDATE COM_Customer SET CustomerUserID=NULL WHERE CustomerUserID=@ID;
	UPDATE COM_OrderStatusUser SET ChangedByUserID=NULL WHERE ChangedByUserID=@ID;
	UPDATE COM_ShoppingCart SET ShoppingCartUserID=NULL WHERE ShoppingCartUserID=@ID;
	-- remove dependences in COM_UserDepartment
	DELETE FROM COM_UserDepartment WHERE UserID=@ID;
	-- remove dependences in [COM_Wishlist]
	DELETE FROM [COM_Wishlist] WHERE UserID=@ID;
	
	-- set null to saved reports
	UPDATE Reporting_SavedReport SET SavedReportCreatedByUserID = NULL WHERE SavedReportCreatedByUserID=@ID
	-- set null to checkouted templates, layouts and css styles
	UPDATE CMS_PageTemplate SET PageTemplateLayoutCheckedOutByUserID = NULL WHERE PageTemplateLayoutCheckedOutByUserID = @ID;
	UPDATE CMS_Layout SET LayoutCheckedOutByUserID = NULL WHERE LayoutCheckedOutByUserID=@ID;
	UPDATE CMS_CssStyleSheet SET StylesheetCheckedOutByUserID = NULL WHERE StylesheetCheckedOutByUserID=@ID;
	-- Blog_Comment - set CommentUserID a CommentApprovedByUserID to null
	UPDATE Blog_Comment SET CommentUserID = NULL WHERE CommentUserID=@ID;
	UPDATE Blog_Comment SET CommentApprovedByUserID = NULL WHERE CommentApprovedByUserID=@ID;
	COMMIT TRANSACTION;
END
