CREATE TABLE [Reporting_SavedGraph] (
		[SavedGraphID]                int NOT NULL IDENTITY(1, 1),
		[SavedGraphSavedReportID]     int NOT NULL,
		[SavedGraphGUID]              uniqueidentifier NOT NULL,
		[SavedGraphBinary]            image NOT NULL,
		[SavedGraphMimeType]          nvarchar(100) NOT NULL
)
ON [PRIMARY]
TEXTIMAGE_ON [PRIMARY]
ALTER TABLE [Reporting_SavedGraph]
	ADD
	CONSTRAINT [PK_Reporting_SavedGraph]
	PRIMARY KEY
	([SavedGraphID])
	ON [PRIMARY]
IF OBJECT_ID(N'[Reporting_SavedGraph]') IS NOT NULL
	AND OBJECT_ID(N'[Reporting_SavedReport]') IS NOT NULL
	AND OBJECT_ID(N'[FK_Reporting_SavedGraph_Reporting_SavedReport]') IS NULL
BEGIN
		ALTER TABLE [Reporting_SavedGraph]
			ADD CONSTRAINT [FK_Reporting_SavedGraph_Reporting_SavedReport]
			FOREIGN KEY ([SavedGraphSavedReportID]) REFERENCES [Reporting_SavedReport] ([SavedReportID])
END
CREATE INDEX [FK_Reporting_SavedGraph]
	ON [Reporting_SavedGraph] ([SavedGraphSavedReportID])
	ON [PRIMARY]
CREATE INDEX [IX_Reporting_SavedGraph]
	ON [Reporting_SavedGraph] ([SavedGraphGUID])
	ON [PRIMARY]
