using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.LicenseProvider;
using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class CMSMessages_FeatureNotAvailable : MessagePage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if ((Request.QueryString["domainname"] != null) && (Request.QueryString["domainname"] != ""))
        {
            LicenseKeyInfo lki = LicenseKeyInfoProvider.GetLicenseKeyInfo(Request.QueryString["domainname"]);
            if (lki != null)
            {
                LabelMessage.Text = ResHelper.GetString("CMSSiteManager.FeatureNotAvailable").Replace("%%name%%", lki.Edition.ToString());
            }
            else
            {
                LabelMessage.Text = ResHelper.GetString("CMSSiteManager.LicenseNotFound").Replace("%%name%%", Request.QueryString["domainname"]);
            }
        }
        this.titleElem.TitleText = ResHelper.GetString("CMSSiteManager.AccesDenied");
        this.titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/denied.gif";
    }
}
