using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class CMSMessages_invalidWebsite : MessagePage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string mDomain = "";
        string mPrefix = "http://";

        this.titleElem.TitleText = ResHelper.GetString("Message.InvalidWebSite");
        this.titleElem.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/denied.gif";

        if (HttpContext.Current != null && HttpContext.Current.Request != null)
        {
            mDomain = HttpContext.Current.Request.Url.Host;
            if (HttpContext.Current.Request.Url.Port != 80)
                mDomain = mDomain + ":" + HttpContext.Current.Request.Url.Port.ToString();

        }

        if (this.Page != null && this.Page.Request != null && this.Page.Request.Url != null)
            if (this.Page.Request.Url.OriginalString.StartsWith("https://"))
            {
                mPrefix = "https://";
            }

        if (HttpContext.Current != null && HttpContext.Current.Request != null)
        {
            lblMessage.Text = ResHelper.GetString("Message.TextInvalidWebSite") + " ";
            lblMessageUrl.Text = mPrefix + mDomain + HttpContext.Current.Request.RawUrl;
        }

        lblInfo1.Text = ResHelper.GetString("Message.InfoInvalidWebSite1") + " ";
        lnkSiteManager.Text = ResHelper.GetString("Message.LinkInvalidWebSite");
        lblInfo2.Text = " " + ResHelper.GetString("Message.InfoInvalidWebSite2") + " ";
        lblInfoDomain.Text = mDomain;

    }
}
