using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.TreeEngine;
using CMS.GlobalHelper;
using CMS.WorkflowEngine;
using CMS.SiteProvider;
using CMS.CMSHelper;

public partial class CMSPages_GetProduct : System.Web.UI.Page
{
    protected int productId = 0;
    protected SiteInfo currentSite = null;
    protected string url = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // Initialization
        productId = ValidationHelper.GetInteger(Request.QueryString["productId"], 0);
        currentSite = CMSContext.CurrentSite;


        if ((productId > 0) && (currentSite != null))
        {
            TreeProvider tree = new TreeProvider();
            DataSet ds = tree.SelectNodes(currentSite.SiteName, "/%", TreeProvider.ALL_CULTURES, true, "cms.product", "NodeSKUID = " + productId);
            if (!DataHelper.DataSourceIsEmpty(ds))
            {
                // Ger specified product url 
                url = CMSContext.GetUrl(Convert.ToString(ds.Tables[0].Rows[0]["NodeAliasPath"]));                
            }
        }

        if (url != "")
        {
            // Redirect to specified product 
            Response.Redirect(url);
        }
        else
        {
            // Display error message
            lblInfo.Visible = true;
            lblInfo.Text = ResHelper.GetString("GetProduct.NotFound");
        }
    }
}
