using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.ExtendedControls;
using CMS.SiteProvider;
using CMS.SettingsProvider;

public partial class login : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        LocalizedLabel lblItem = (LocalizedLabel)Login1.FindControl("lblUserName");
        if (lblItem != null)
        {
            lblItem.Text = "{$LogonForm.UserName$}";
        }
        lblItem = (LocalizedLabel)Login1.FindControl("lblPassword");
        if (lblItem != null)
        {
            lblItem.Text = "{$LogonForm.Password$}";
        }

        // Display culture link due to value of the key stored in the web.config file
        bool showCultureSelector = ValidationHelper.GetBoolean(ConfigurationManager.AppSettings["CMSShowLogonCultureSelector"], true);
        if (showCultureSelector)
        {
            LinkButton lnkLanguage = (LinkButton)Login1.FindControl("lnkLanguage");
            if (lnkLanguage != null)
            {
                lnkLanguage.Visible = true;

                // Ensure language selection panel functionality
                HtmlGenericControl pnlLanguage = (HtmlGenericControl)Login1.FindControl("pnlLanguage");
                if (pnlLanguage != null)
                {
                    lnkLanguage.Text = ResHelper.GetString("LogonForm.SelectLanguage");

                    this.ltlScript.Text = ScriptHelper.GetScript("function ShowLanguage(id){var panel=document.getElementById(id);if(panel!=null){panel.style.display=(panel.style.display == 'block')?'none':'block';}}");
                    lnkLanguage.Attributes.Add("onclick", "ShowLanguage('" + pnlLanguage.ClientID + "'); return false;");
                }
            }
        }

        LocalizedCheckBox chkItem = (LocalizedCheckBox)Login1.FindControl("chkRememberMe");
        if (chkItem != null)
        {
            chkItem.Text = "{$LogonForm.RememberMe$}";
        }
        LocalizedButton btnItem = (LocalizedButton)Login1.FindControl("LoginButton");
        if (btnItem != null)
        {
            btnItem.Text = "{$LogonForm.LogOnButton$}";
        }

        // Load UI cultures for the dropdown list
        if (!IsPostBack)
        {
            LoadCultures();
        }

        Label lblVersion = (Label)Login1.FindControl("lblVersion");
        if (lblVersion != null)
        {
            lblVersion.Text = ResHelper.GetString("Footer.Version") + "&nbsp;" + CMSContext.SYSTEM_VERSION + "&nbsp;" + ResHelper.GetString("Footer.Build") + "&nbsp;" + typeof(TreeProvider).Assembly.GetName().Version.Major + "." + typeof(TreeProvider).Assembly.GetName().Version.Minor + "." + typeof(TreeProvider).Assembly.GetName().Version.Build;
        }

        Login1.LoggingIn += new LoginCancelEventHandler(Login1_LoggingIn);
        Login1.LoggedIn += new EventHandler(Login1_LoggedIn);
        Login1.LoginError += new EventHandler(Login1_LoginError);

        if (!IsPostBack)
        {
            Login1.UserName = ValidationHelper.GetString(Request.QueryString["username"], "");
        }

        //if ( !IsPostBack )
        //{
        //    Login1.UserName = CookieHelper.GetValue("RememberMeName");
        //}
    }

    void Login1_LoginError(object sender, EventArgs e)
    {
        Login1.FailureText = ResHelper.GetString("Login_FailureText");
    }


    void Login1_LoggedIn(object sender, EventArgs e)
    {
        if (Response.Cookies.Count > 0)
        {
            foreach (string s in Response.Cookies.AllKeys)
            {
                if (s == FormsAuthentication.FormsCookieName)
                {
                    if (Login1.RememberMeSet == true)
                    {
                        // Change the value to increase the cookies expiration by
                        Response.Cookies[s].Expires = DateTime.Now.AddYears(1);
                        //CookieHelper.SetValue("RememberMeName", Login1.UserName, DateTime.Now.AddYears(1));
                    }
                }
            }
        }

        DropDownList drpCulture = (DropDownList)Login1.FindControl("drpCulture");
        if (drpCulture != null)
        {

            string selectedCulture = drpCulture.SelectedValue;
            
            // Not the default culture
            if (selectedCulture != "")
            {
                UserInfo ui = UserInfoProvider.GetUserInfo(Login1.UserName);
                ui.PreferredUICultureCode = selectedCulture;
                UserInfoProvider.SetUserInfo(ui);
            }
        }
    }


    void Login1_LoggingIn(object sender, LoginCancelEventArgs e)
    {
        if (((CheckBox)Login1.FindControl("chkRememberMe")).Checked)
        {
            Login1.RememberMeSet = true;
        }
        else
        {
            Login1.RememberMeSet = false;
        }
    }


    /// <summary>
    /// Load UI cultures for the dropdown list
    /// </summary>
    private void LoadCultures()
    {
        DropDownList drpCulture = (DropDownList)Login1.FindControl("drpCulture");
        if (drpCulture != null)
        {
            DataSet ds = UICultureInfoProvider.GetAllUICultures();
            drpCulture.DataValueField = "UICultureCode";
            drpCulture.DataTextField = "UICultureName";
            drpCulture.DataSource = ds;
            drpCulture.DataBind();

            // Add default value
            drpCulture.Items.Insert(0, new ListItem(ResHelper.GetString("LogonForm.DefaultCulture"), ""));
        }
    }
}
