using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.Newsletter;
using CMS.Forums;
using CMS.CMSHelper;

public partial class CMSPages_unsubscribe : System.Web.UI.Page
{

    protected void Page_Load(object sender, EventArgs e)
    {

        // Forums
        int subId = ValidationHelper.GetInteger(Request.QueryString["subId"], 0);
        Guid subGuid = ValidationHelper.GetGuid(Request.QueryString["subGuid"], Guid.Empty);

        if (subGuid != Guid.Empty || subId != 0)
        {

            ForumSubscriptionInfo fsi = null;

            if (subGuid != Guid.Empty)
            {
                fsi = ForumSubscriptionInfoProvider.GetForumSubscriptionInfo(subGuid);
            }
            else if (subId > 0)
            {
                fsi = ForumSubscriptionInfoProvider.GetForumSubscriptionInfo(subId);
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("Forum.UnsubscribeUnsuccessfull");
                return;
            }

            if (fsi != null)
            {
                ForumSubscriptionInfoProvider.DeleteForumSubscriptionInfo(fsi.SubscriptionID);

                lblInfo.Visible = true;
                lblInfo.Text = ResHelper.GetString("Unsubscribe.Unsubscribed");
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("forum.invalidsubscribeid");
            }

            return;
        }


        // Newsletters
        Guid subscriberGuid = ValidationHelper.GetGuid(Request.QueryString["subscriberguid"], Guid.Empty);
        Guid newsletterGuid = ValidationHelper.GetGuid(Request.QueryString["newsletterguid"], Guid.Empty);
        int siteId = 0;

        // Get site id
        if (CMSContext.CurrentSite != null)
        {
            siteId = CMSContext.CurrentSite.SiteID;
        }

        if ((subscriberGuid != Guid.Empty) && (newsletterGuid != Guid.Empty) && (siteId != 0))
        {
            if (SubscriberProvider.IsSubscribed(subscriberGuid, newsletterGuid, siteId))
            {
                SubscriberProvider.Unsubscribe(subscriberGuid, newsletterGuid, siteId);
                lblInfo.Visible = true;
                lblInfo.Text = ResHelper.GetString("Unsubscribe.Unsubscribed");

                //if subscriber has unsubscribed after some issue, increase number of unsubscribed persons of that issue by 1
                int issueId = ValidationHelper.GetInteger(Request.QueryString["issueid"], 0);
                if (issueId > 0)
                {
                    Issue issue = IssueProvider.GetIssue(issueId);
                    if (issue != null)
                    {
                        issue.IncreaseUnsubscribedNumber();
                        IssueProvider.SetIssue(issue);
                    }
                }
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("Unsubscribe.NotSubscribed");
            }
        }
        else
        {
            lblError.Visible = true;
            if (subscriberGuid == Guid.Empty)
            {
                lblError.Text += ResHelper.GetString("Unsubscribe.SubscriberDoesNotExist");
            }
            if (newsletterGuid == Guid.Empty)
            {
                lblError.Text += " \n\r " + ResHelper.GetString("Unsubscribe.NewsletterDoesNotExist");
            }
        }
    }
}
