using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.GlobalHelper;
using CMS.DataEngine;
using CMS.EventLog;
using CMS.SiteProvider;

public partial class SiteManager_Administration_EventLog_EventLog_Details : AdministrationPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        PageTitle.TitleText = ResHelper.GetString("EventLogDetails.Header");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/administration/eventlog/eventdetail.gif";

        // Set table labels
        lblEventID.Text = ResHelper.GetString("EventLogDetails.EventID");
        lblEventType.Text = ResHelper.GetString("EventLogDetails.EventType");
        lblEventTime.Text = ResHelper.GetString("EventLogDetails.EventTime");
        lblSource.Text = ResHelper.GetString("EventLogDetails.Source");
        lblEventCode.Text = ResHelper.GetString("EventLogDetails.EventCode");
        lblUserID.Text = ResHelper.GetString("EventLogDetails.UserID");
        lblUserName.Text = ResHelper.GetString("EventLogDetails.UserName");
        lblIPAddress.Text = ResHelper.GetString("EventLogDetails.IPAddress");
        lblNodeID.Text = ResHelper.GetString("EventLogDetails.NodeID");
        lblNodeName.Text = ResHelper.GetString("EventLogDetails.NodeName");
        lblEventDescription.Text = ResHelper.GetString("EventLogDetails.EventDescription");
        lblSiteName.Text = ResHelper.GetString("EventLogDetails.SiteName");
        lblEventUrl.Text = ResHelper.GetString("EventLogDetails.EventUrl");
        lblMachineName.Text = ResHelper.GetString("EventLogDetails.MachineName");
        
        // Set button
        btnClose.Text = ResHelper.GetString("EventLogDetails.Close");
        btnClose.Attributes.Add("onclick", "window.close();");

        // Get EventID value
        if (Request.QueryString["eventid"] != null)
        {
            LoadData(Convert.ToInt32(Request.QueryString["eventid"]));
        }
    }


    /// <summary>
    /// Loads data of specific EventLog from DB.
    /// </summary>
    /// <param name="eventId">EventLog ID</param>
    protected void LoadData(int eventId)
    {
        GeneralConnection genConn = ConnectionHelper.GetConnection();
        EventLogProvider eventProvider = new EventLogProvider(genConn);

        // Select specified event
        DataRow eventRow = eventProvider.GetEvent(eventId);
        
        if (eventRow != null)
        {
            string eventType = ValidationHelper.GetString(eventRow["EventType"], "");

            // Rewrite event type text.
            switch (eventType.ToUpper())
            {
                case "I":
                    lblEventTypeValue.Text = ResHelper.GetString("EventLogList.EventTypeInformation");
                    break;
                case "E":
                    lblEventTypeValue.Text = ResHelper.GetString("EventLogList.EventTypeError");
                    break;
                case "W":
                    lblEventTypeValue.Text = ResHelper.GetString("EventLogList.EventTypeWarning");
                    break;
            }

            lblEventIDValue.Text = ValidationHelper.GetString(eventRow["EventID"], "");
            lblEventTimeValue.Text = ValidationHelper.GetString(eventRow["EventTime"], "");
            lblSourceValue.Text = ValidationHelper.GetString(eventRow["Source"], "");
            lblEventCodeValue.Text = ValidationHelper.GetString(eventRow["EventCode"], "");
            lblUserIDValue.Text = ValidationHelper.GetString(eventRow["UserID"], "");
            lblUserNameValue.Text = ValidationHelper.GetString(eventRow["UserName"], "");
            lblIPAddressValue.Text = ValidationHelper.GetString(eventRow["IPAddress"], "");
            lblNodeIDValue.Text = ValidationHelper.GetString(eventRow["NodeID"], "");
            lblNodeNameValue.Text = ValidationHelper.GetString(eventRow["DocumentName"], "");
            lblEventDescriptionValue.Text = ValidationHelper.GetString(eventRow["EventDescription"], "");

            if ( !DataHelper.IsEmpty(eventRow["SiteID"]))
            {
                lblSiteNameValue.Text = SiteInfoProvider.GetSiteInfo(Convert.ToInt32(eventRow["SiteID"])).DisplayName;
            }
            lblMachineNameValue.Text = ValidationHelper.GetString(eventRow["EventMachineName"], "");
            lblEventUrlValue.Text = ValidationHelper.GetString(eventRow["EventUrl"], "");
        } 
    }
}
