using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.GlobalHelper;
using CMS.SiteProvider;
using CMS.CMSHelper;


public partial class SiteManager_Administration_Users_User_Edit : AdministrationPage
{
    protected int userId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        if ((Request.QueryString["userid"] != null) && (Request.QueryString["userid"] != ""))
        {
            userId = Convert.ToInt32(Request.QueryString["userid"]);
        }

        if (!IsPostBack)
        {
            InitalizeMenu();
        }

        string users = ResHelper.GetString("Administration-User_Edit.Users");
        string currentUser = UserInfoProvider.GetUserNameById(userId);
        string title = ResHelper.GetString("Administration-User_Edit.Title");

        //initializes PageTitle
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = users;
        pageTitleTabs[0, 1] = "~/CMSSiteManager/Administration/Users/User_List.aspx?siteid=" + ValidationHelper.GetInteger(Request.QueryString["siteid"], 0).ToString();
        pageTitleTabs[0, 2] = "adminmain";
        pageTitleTabs[1, 0] = currentUser;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        PageTitle1.Breadcrumbs = pageTitleTabs;
        PageTitle1.TitleText = title;
        PageTitle1.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Administration/Users/user.gif";
    }

    /// <summary>
    /// Initializes user edit menu
    /// </summary>
    protected void InitalizeMenu()
    {
        string generalString = ResHelper.GetString("Administration-User_Edit.General");
        string passwordString = ResHelper.GetString("Administration-User_Edit.Password");
        string rolesString = ResHelper.GetString("Administration-User_Edit.Roles");
        string sitesString = ResHelper.GetString("Administration-User_Edit.Sites");
        string customFieldsString = ResHelper.GetString("Administration-User_Edit.CustomFields");
        string departmentsString = ResHelper.GetString("Administration-User_Edit.Departments");

        // is e-commerce on site? => show department tab
        bool ecommerceOnSite = false;
        if (CMSContext.CurrentSite != null)
        {
            ResourceInfo ri = ResourceInfoProvider.GetResourceInfo("CMS.Ecommerce");
            if (ri != null)
            {
                ecommerceOnSite = ResourceInfoProvider.IsResourceOnSite(ri.ResourceId, CMSContext.CurrentSite.SiteID);
            }
        }
        int departmentTab = (ecommerceOnSite ? 1 : 0);

        if (CMSContext.CurrentUser.IsGlobalAdministrator)
        {
            BasicTabControlMenu.Tabs = new string[5 + departmentTab, 4];
            BasicTabControlMenu.Tabs[3, 0] = sitesString;
            BasicTabControlMenu.Tabs[3, 2] = "User_Edit_Sites.aspx?userid=" + userId;
            BasicTabControlMenu.Tabs[4, 0] = rolesString;
            BasicTabControlMenu.Tabs[4, 2] = "User_Edit_Roles.aspx?userid=" + userId;
        }
        else
        {
            BasicTabControlMenu.Tabs = new string[4 + departmentTab, 4];
            BasicTabControlMenu.Tabs[3, 0] = rolesString;
            BasicTabControlMenu.Tabs[3, 2] = "User_Edit_Roles.aspx?userid=" + userId;
        }
        BasicTabControlMenu.Tabs[0, 0] = generalString;
        BasicTabControlMenu.Tabs[0, 2] = "User_Edit_General.aspx?userid=" + userId;
        BasicTabControlMenu.Tabs[1, 0] = passwordString;
        BasicTabControlMenu.Tabs[1, 2] = "User_Edit_Password.aspx?userid=" + userId;
        BasicTabControlMenu.Tabs[2, 0] = customFieldsString;
        BasicTabControlMenu.Tabs[2, 2] = "User_Edit_CustomFields.aspx?userid=" + userId;

        // is e-commerce on site? => show department tab
        if (ecommerceOnSite)
        {
            int cnt = BasicTabControlMenu.Tabs.GetLength(0) - 1;
            BasicTabControlMenu.Tabs[cnt, 0] = departmentsString;
            BasicTabControlMenu.Tabs[cnt, 2] = "User_Edit_Departments.aspx?userid=" + userId;
        }

        BasicTabControlMenu.UrlTarget = "content";
    }
}
