using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class CMSSiteManager_Administration_Users_User_Edit_CustomFields : AdministrationPage
{
    protected int userId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        formUserCustomFields.OnAfterSave += new CMS.FormEngine.DataForm.OnAfterSaveEventHandler(formUserCustomFields_OnAfterSave);

        // set edit mode
        userId = ValidationHelper.GetInteger(Request.QueryString["userID"], 0);        
        if (userId > 0)
        {
            formUserCustomFields.ItemID = userId;
        }
        else
        {
            formUserCustomFields.Enabled = false;
        }
    }


    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        formUserCustomFields.BasicForm.SubmitButton.CssClass = "ContentButton";
    }


    void formUserCustomFields_OnAfterSave()
    {
        // Check modify permission
        if ((CMSContext.CurrentSite != null) && (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Administration", "Modify")))
        {
            RedirectToCMSDeskAccessDenied("CMS.Administration", "Modify");
        }

        this.lblInfo.Visible = true;
        this.lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
    }
}
