using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.SiteProvider;
using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class SiteManager_Administration_Users_User_Edit_Password : AdministrationPage
{
    const string hiddenPassword = "********";

    protected void Page_Load(object sender, EventArgs e)
    {
        ButtonSetPassword.Text = ResHelper.GetString("Administration-User_Edit_Password.SetPassword");
        LabelPassword.Text = ResHelper.GetString("Administration-User_Edit_Password.NewPassword");
        LabelConfirmPassword.Text = ResHelper.GetString("Administration-User_Edit_Password.ConfirmPassword");
        
        if (!IsPostBack)
        {
            if (Request.QueryString["userid"] != null)            
            {   
                int userId = Convert.ToInt32(Request.QueryString["userid"]);
                string userName = UserInfoProvider.GetUserNameById(userId);
                UserInfo ui = UserInfoProvider.GetUserInfo(userName);
                if (ui.GetValue("UserPassword") != null)
                {
                    string password = ui.GetValue("UserPassword").ToString();
                    if (password.Length > 0)
                    {
                        TextBoxPassword.Attributes.Add("value", hiddenPassword);
                        TextBoxConfirmPassword.Attributes.Add("value", hiddenPassword);
                    }
                }
            }
        }
    }

    /// <summary>
    /// Set password of current user.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ButtonSetPassword_Click(object sender, EventArgs e)
    {
        // Check modify permission
        if ((CMSContext.CurrentSite != null) && (!CMSContext.CurrentUser.IsAuthorizedPerResource("CMS.Administration", "Modify")))
        {
            RedirectToCMSDeskAccessDenied("CMS.Administration", "Modify");
        }

        if (Request.QueryString["userid"] != null)
        {
            if (TextBoxConfirmPassword.Text == TextBoxPassword.Text)
            {
                if (TextBoxPassword.Text != hiddenPassword) //password has been changed
                {
                    int userId = Convert.ToInt32(Request.QueryString["userid"]);
                    string userName = UserInfoProvider.GetUserNameById(userId);
                    UserInfoProvider.SetPassword(userName, TextBoxPassword.Text);

                    // Show actual information to the user
                    if (TextBoxPassword.Text != String.Empty)
                    {
                        TextBoxPassword.Attributes.Add("value", hiddenPassword);
                        TextBoxConfirmPassword.Attributes.Add("value", hiddenPassword);
                    }
                    else
                    {
                        TextBoxPassword.Attributes.Add("value", "");
                        TextBoxConfirmPassword.Attributes.Add("value", "");
                    }

                    lblInfo.Visible = true;
                    lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
                }
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("Administration-User_Edit_Password.PasswordsDoNotMatch");
            }
        }
    }
}
