using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.TreeEngine;

public partial class SiteManager_Development_DocumentTypes_DocumentType_List : SiteManagerPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        PageTitle.TitleText = ResHelper.GetString("DocumentType_List.Title");
        PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/DocumentTypes/doctypes.gif";
        ImageNewDoctype.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/DocumentTypes/adddoctype.gif";

        uniGrid.OnAction += new OnActionEventHandler(uniGrid_OnAction);
        uniGrid.GridView.GridLines = GridLines.Horizontal;

        HyperlinkNewDoctype.Text = ResHelper.GetString("DocumentType_List.NewDoctype");
    }


    /// <summary>
    /// Handles the UniGrid's OnAction event.
    /// </summary>
    /// <param name="actionName">Name of item (button) that throws event.</param>
    /// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
    protected void uniGrid_OnAction(string actionName, object actionArgument)
    {
        if (actionName == "edit")
        {
            Response.Redirect("DocumentType_Edit.aspx?documenttypeid=" + actionArgument.ToString());
        }
        else if (actionName == "delete")
        {

            DataClassInfo dci = DataClassInfoProvider.GetDataClass(Convert.ToInt32(actionArgument));

            // delete dataclass and its dependeces
            try
            {
                DataClassInfoProvider.DeleteDataClass(dci.ClassName);
            }
            catch
            {
                lblError.Text = ResHelper.GetString("DocumentType_List.DeleteFailed");
                lblError.Visible = true;
            }
        }
    }
}
