using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.PortalEngine;

public partial class CMSSiteManager_Development_PageTemplates_PageTemplate_WebParts : SiteManagerPage
{
    /// <summary>
    /// PageTemplateID.
    /// </summary>
    protected int templateId = 0;


    /// <summary>
    /// Page load.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
        // Initialize controls.        
        lblWarning.Text = ResHelper.GetString("PageTemplate_WebParts.Warning");
        lblWPConfig.Text = ResHelper.GetString("PageTemplate_WebParts.WebPartsConfiguration");
        btnOK.Text = ResHelper.GetString("General.OK");

        // Get 'templateid' from querystring.
        if (Request.QueryString["templateid"] != null)
        {
            templateId = Convert.ToInt32(Request.QueryString["templateId"]);
        }
        if (!IsPostBack)
        {
            // Get PageTemplateInfo of specified 'templateid'.
            PageTemplateInfo pti = PageTemplateInfoProvider.GetPageTemplateInfo(templateId);
            if (pti != null)
            {
                txtWebParts.Text = pti.WebParts;
            }            
        }        
    }


    /// <summary>
    /// Handle btnOK's OnClick event.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnOK_Click(object sender, EventArgs e)
    {
        string errorMessage = "";

        // Get PageTemplateInfo.
        PageTemplateInfo pti = PageTemplateInfoProvider.GetPageTemplateInfo(templateId);
        if (pti != null)
        {            
            // Update WebParts configuration in PageTemplate.
            try
            {
                pti.WebParts = txtWebParts.Text;
                PageTemplateInfoProvider.SetPageTemplateInfo(pti);

                lblInfo.Text = ResHelper.GetString("General.ChangesSaved");
                lblInfo.Visible = true;
            }
            catch (Exception ex)
            {
                errorMessage = ex.Message;
            }

            // Show error message
            if (errorMessage != "")
            {                
                lblError.Text = errorMessage;
                lblError.Visible = true;
            }
        }
    }
}
