using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.SiteProvider;
using CMS.GlobalHelper;
using CMS.ResourceManager;

public partial class CMSSiteManager_Development_UICultures_UICulture_Strings_List : SiteManagerPage
{
    int uiCultureID = 0;
    protected void Page_Load(object sender, EventArgs e)
    {
        if ((Request.QueryString["UIcultureID"] != null) && (Request.QueryString["UIcultureID"] != ""))
        {
            uiCultureID = Convert.ToInt32(Request.QueryString["UIcultureID"]);
        }

        //PageTitle.TitleText = ResHelper.GetString("Development-UICulture_Strings_List.Title");
        //PageTitle.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/UICultures/Strings/strings.gif";
        ImageNew.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/UICultures/Strings/addstring.gif";
        lnkNew.Text = ResHelper.GetString("Development-UICulture_Strings_List.NewString");
        lnkNew.NavigateUrl = "UICulture_String_New.aspx?UIcultureID=" + uiCultureID;

        // Get default culture
        UICultureInfo dui = UICultureInfoProvider.GetUICultureInfo("en-us");

        // Get requested culture
        UICultureInfo ui = UICultureInfoProvider.GetUICultureInfo(uiCultureID);

        object[,] parameters = new object[2, 3];
        parameters[0, 0] = "@Culture";
        parameters[0, 1] = ui.UICultureID;
        parameters[1, 0] = "@DefaultUICultureID";
        parameters[1, 1] = dui.UICultureID;
        UniGridStrings.QueryParameters = parameters;

        UniGridStrings.GridView.GridLines = GridLines.Horizontal;
        UniGridStrings.OnAction += new OnActionEventHandler(UniGridUICultures_OnAction);

        //UniGridStrings.DataSource = SqlResourceManager.MakeDataSourceForUniGrid(ui.UICultureCode);
        //UniGridStrings.OrderBy = "Key";

        UniGridStrings.OnExternalDataBound += new OnExternalDataBoundEventHandler(UniGridStrings_OnExternalDataBound);

    }

    object UniGridStrings_OnExternalDataBound(object sender, string sourceName, object parameter)
    {
        if (sourceName.ToLower() == "edititem")
        {
            ImageButton ib = sender as ImageButton;
            if (ib != null)
            {
                GridViewRow gvr = parameter as GridViewRow;
                if (gvr != null)
                {
                    DataView dv = gvr.DataItem as DataView;
                    if (dv != null)
                    {
                        UICultureInfo ui = UICultureInfoProvider.GetUICultureInfo(uiCultureID);
                        if (ui != null)
                        {
                            ResourceStringInfo ri = SqlResourceManager.GetResourceStringInfo(ValidationHelper.GetString(dv[0], ""), ui.UICultureCode);
                            if (ri != null)
                            {
                                ib.OnClientClick = "location.href='UICulture_Strings_Edit.aspx?stringID=" + ri.StringId + "&uicultureID=" + ui.UICultureID + "'; return false;";
                            }
                        }
                    }
                }
            }
        }

        return parameter;
    }

    /// <summary>
    /// Handles the UniGrid's OnAction event.
    /// </summary>
    /// <param name="actionName">Name of item (button) that threw event.</param>
    /// <param name="actionArgument">ID (value of Primary key) of corresponding data row.</param>
    protected void UniGridUICultures_OnAction(string actionName, object actionArgument)
    {
        UICultureInfo ui = new UICultureInfo();
        ui = UICultureInfoProvider.GetUICultureInfo(uiCultureID);
        ResourceStringInfo ri = new ResourceStringInfo();
        ri = SqlResourceManager.GetResourceStringInfo(actionArgument.ToString(), ui.UICultureCode);
        if (actionName == "edit")
        {
            Response.Redirect("UICulture_Strings_Edit.aspx?stringID=" + ri.StringId + "&uicultureID=" + ui.UICultureID);
        }
        else if (actionName == "delete")
        {
            SqlResourceManager.DeleteResourceStringInfo(actionArgument.ToString(), ui.UICultureCode);
        }
    }
}
