using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.WorkflowEngine;
using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class SiteManager_Development_Workflows_Workflow_Edit : SiteManagerPage
{
    protected int workflowId = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!CMSContext.CurrentUser.IsAuthorizedPerResource("cms.administration", "Modify"))
        {
            RedirectToAccessDenied("cms.administration", "Modify");
        }

        if ((Request.QueryString["workflowid"] != null) && (Request.QueryString["workflowid"] != ""))
        {
            workflowId = Convert.ToInt32(Request.QueryString["workflowid"]);
        }

        WorkflowInfo wi = WorkflowInfoProvider.GetWorkflowInfo(workflowId);
        

        string workflowListUrl = "~/CMSSiteManager/Development/Workflows/Workflow_List.aspx";
        string workflows = ResHelper.GetString("Development-Workflow_Edit.Workflows");
        string currentWorkflow = "";
        string title = ResHelper.GetString("Development-Workflow_Edit.Title");

        if (wi != null)
        {
            currentWorkflow = wi.WorkflowDisplayName; 
        }

        if (!IsPostBack)
        {
            InitalizeMenu();
            if ((Request.QueryString["showtab"] != null) && (Request.QueryString["showtab"] != ""))
            {
                if (Request.QueryString["showtab"].ToString() == "steps")
                {
                    BasicTabControlMenu.SelectedTab = 1;
                }
            }
        }

        //initialize PageTitle
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = workflows;
        pageTitleTabs[0, 1] = workflowListUrl;
        pageTitleTabs[0, 2] = "devmain";
        pageTitleTabs[1, 0] = currentWorkflow;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";
        
        PageTitle1.Breadcrumbs = pageTitleTabs;
        PageTitle1.TitleText = title;
        PageTitle1.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/Workflows/Workflow.gif";
    }

    /// <summary>
    /// Initializes workflow edit menu
    /// </summary>
    protected void InitalizeMenu()
    {
        string generalString = ResHelper.GetString("Development-Workflow_Edit.General");
        string stepsString = ResHelper.GetString("Development-Workflow_Edit.Steps");
        string scopesString = ResHelper.GetString("Development-Workflow_Edit.Scopes");

        BasicTabControlMenu.Tabs = new string[3, 4];
        BasicTabControlMenu.Tabs[0, 0] = generalString;
        BasicTabControlMenu.Tabs[0, 2] = "Workflow_General.aspx?workflowId=" + workflowId;
        BasicTabControlMenu.Tabs[1, 0] = stepsString;
        BasicTabControlMenu.Tabs[1, 2] = "Workflow_Steps.aspx?workflowId=" + workflowId;
        BasicTabControlMenu.Tabs[2, 0] = scopesString;
        BasicTabControlMenu.Tabs[2, 2] = "Workflow_Scopes.aspx?workflowId=" + workflowId;
        BasicTabControlMenu.UrlTarget = "workflowsContent";
    }
}
