using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.WorkflowEngine;
using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class SiteManager_Development_Workflows_Workflow_Step_Header : SiteManagerPage
{
    protected int workflowStepId = 0;
    protected WorkflowStepInfo wsi = null;

    protected void Page_Load(object sender, EventArgs e)
    {

        if ((Request.QueryString["workflowstepid"] != null) && (Request.QueryString["workflowstepid"] != ""))
        {
            workflowStepId = Convert.ToInt32(Request.QueryString["workflowstepid"]);
        }

        string currentWorkflowStep = null;
        
        int workflowId = 0;
        if (workflowStepId > 0)
        {
            wsi = WorkflowInfoProvider.GetWorkflowStepInfo(workflowStepId);
            if (wsi != null)
            {
                workflowId = wsi.StepWorkflowID;
                currentWorkflowStep = WorkflowInfoProvider.GetWorkflowStepInfo(workflowStepId).StepDisplayName;
            }
        }
        string workflowStepsUrl = "~/CMSSiteManager/Development/Workflows/Workflow_Edit.aspx";
        workflowStepsUrl += "?workflowid=" + workflowId.ToString() + "&showtab=steps";

        string workflowSteps = ResHelper.GetString("Publish.WorkflowSteps");
        string title = ResHelper.GetString("Development-Workflow_Step_Edit.Title");

        if (!IsPostBack)
        {
            InitalizeMenu();
        }

        //initialize PageTitle
        string[,] pageTitleTabs = new string[2, 3];
        pageTitleTabs[0, 0] = workflowSteps;
        pageTitleTabs[0, 1] = workflowStepsUrl;
        pageTitleTabs[0, 2] = "devmain";
        pageTitleTabs[1, 0] = currentWorkflowStep;
        pageTitleTabs[1, 1] = "";
        pageTitleTabs[1, 2] = "";

        PageTitle1.Breadcrumbs = pageTitleTabs;
        PageTitle1.TitleText = title;
        PageTitle1.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Development/Workflows/WorkflowStep.gif";
    }

    /// <summary>
    /// Initializes workflow step edit menu
    /// </summary>
    protected void InitalizeMenu()
    {
        string generalString = ResHelper.GetString("Development-Workflow_Step_Edit.General");
        string rolesString = ResHelper.GetString("Development-Workflow_Step_Step_Edit.Roles");

        BasicTabControlMenu.Tabs = new string[2, 4];
        BasicTabControlMenu.Tabs[0, 0] = generalString;
        BasicTabControlMenu.Tabs[0, 2] = "Workflow_Step_General.aspx?workflowStepId=" + workflowStepId;
        BasicTabControlMenu.Tabs[1, 0] = rolesString;
        BasicTabControlMenu.Tabs[1, 2] = "Workflow_Step_Roles.aspx?workflowStepId=" + workflowStepId;
        BasicTabControlMenu.UrlTarget = "wfStepContent";
    }
}
