using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class SiteManager_Header : SiteManagerPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.lblVersion.Text = "v" + CMSContext.SYSTEM_VERSION;
        
        lnkCmsDesk.Visible = false;
        if (CMSContext.CurrentUser.IsGlobalAdministrator == true)
        {
            lnkCmsDesk.Visible = true;
        }

        this.pnlSignOut.BackImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSDesk/signout_empty.gif";
        this.lblSignOut.Text = ResHelper.GetString("signoutbutton.signout");

        this.lblUser.Text = ResHelper.GetString("Header.User");
        this.lblUserInfo.Text = CMSContext.CurrentUser.FullName;
        this.lnkCmsDesk.Text = ResHelper.GetString("Header.CMSDesk");
        this.lnkCmsDesk.NavigateUrl = "~/CMSDesk";
        this.lnkCmsDesk.Target = "_parent";

        string[,] tabs = new string[6, 4];
        tabs[0, 0] = "&nbsp;" + ResHelper.GetString("Header.Sites") + "&nbsp";
        tabs[0, 2] = "sites/site_list.aspx";
        tabs[1, 0] = "&nbsp;" + ResHelper.GetString("Header.Administration") + "&nbsp";
        tabs[1, 2] = "administration/default.aspx";
        tabs[2, 0] = "&nbsp;" + ResHelper.GetString("Header.Settings") + "&nbsp";
        tabs[2, 2] = "settings/default.aspx";
        tabs[3, 0] = "&nbsp;" + ResHelper.GetString("Header.Development") + "&nbsp";
        tabs[3, 2] = "development/default.aspx";
        tabs[4, 0] = "&nbsp;" + ResHelper.GetString("Header.Licenses") + "&nbsp";
        tabs[4, 2] = "licenses/License_List.aspx";
        tabs[5, 0] = "&nbsp;" + ResHelper.GetString("Header.Support") + "&nbsp";
        tabs[5, 2] = "support/default.aspx";
        BasicTabControlHeader.Tabs = tabs;

        string section = ValidationHelper.GetString(Request.QueryString["section"], "sites").ToLower();
        int selectedTab = 0;
        switch (section)
        {
            case "sites":
                selectedTab = 0; 
                break;
            case "administration":
                selectedTab = 1; 
                break;
            case "settings":
                selectedTab = 2; 
                break;
            case "development":
                selectedTab = 3; 
                break;
            default:
                selectedTab = 0;
                break;
        }

        BasicTabControlHeader.SelectedTab = selectedTab;
        BasicTabControlHeader.UrlTarget = "cmsdesktop";
    }
    

    protected void btnSignOut_Click(object sender, EventArgs e)
    {
        //User.Identity = null;
        FormsAuthentication.SignOut();
        CMSContext.CurrentUser = null;
        LiteralScript.Text = "<script language=\"javascript\" type=\"text/javascript\">parent.location.href='../default.aspx';</script> ";
    }
}
