<%@ Control Language="C#" AutoEventWireup="true" CodeFile="ExportSettingsWizard.ascx.cs"
    Inherits="CMSSiteManager_Sites_Export_ExportSettingsWizard_ExportSettingsWizard" %>
<%@ Register Src="Export_FileSelection.ascx" TagName="FileSelection" TagPrefix="uc2" %>
<%@ Register Src="ExportGridView.ascx" TagName="ExportGridView" TagPrefix="uc2" %>
<%@ Register Assembly="CMS.ExtendedControls" Namespace="CMS.ExtendedControls" TagPrefix="cc1" %>
<div id="wzdBody" class="NewSiteWizardBody">
    <div id="wzdHeader" class="WizardHeader">
        <asp:Label ID="lblStepTitle" runat="server" SkinID="WizardStepHeader"></asp:Label>
        <asp:Label ID="lblStepDesc" runat="server" CssClass="NewSiteWizardStepDescription"></asp:Label>
    </div>
    <asp:Wizard ID="wzdExportSettings" runat="server" DisplaySideBar="False" NavigationButtonStyle-Width="75"
        NavigationStyle-HorizontalAlign="Left" OnNextButtonClick="wzdExportSettings_NextButtonClick">
        <StepNavigationTemplate>
            <div id="buttonsDiv" style="padding: 10px 0px 10px 10px">
                <cc1:localizedbutton usesubmitbehavior="True" id="StepPreviousButton" runat="server"
                    commandname="MovePrevious" text="{$ExportSiteSettings.PreviousStep$}" width="100" />
                <cc1:localizedbutton usesubmitbehavior="True" id="Localizedbutton1" runat="server"
                    commandname="MoveNext" text="{$ExportSiteSettings.NextStep$}" width="100" />
            </div>
        </StepNavigationTemplate>
        <StartNavigationTemplate>
            <div id="buttonsDiv" style="padding: 10px 0px 10px 10px">
                <cc1:localizedbutton usesubmitbehavior="True" id="StepNextButton" runat="server"
                    commandname="MoveNext" text="{$ExportSiteSettings.NextStep$}" width="100" />
            </div>
        </StartNavigationTemplate>
        <FinishNavigationTemplate>
            <div id="buttonsDiv" style="padding: 10px 0px 10px 10px">
                <cc1:localizedbutton usesubmitbehavior="True" id="StepNextButton" runat="server"
                    commandname="MoveComplete" text="{$ExportSiteSettings.Finish$}" width="100" />
            </div>
        </FinishNavigationTemplate>
        <WizardSteps>
            <asp:WizardStep ID="wzdStepFileSelection" runat="server" StepType="Start">
                <asp:Panel ID="pnlStepFileSelection" runat="server" SkinID="NewSiteWizardStep">
                    <uc2:FileSelection ID="ucFileSelection" runat="server" />
                </asp:Panel>
            </asp:WizardStep>
            <asp:WizardStep ID="wzdStepCssStyles" runat="server" StepType="Step">
                <asp:Panel ID="pnlStepCssStyles" runat="server" SkinID="NewSiteWizardStep">
                    <uc2:ExportGridView ID="ucCssStyles" runat="server" />
                </asp:Panel>
            </asp:WizardStep>
            <asp:WizardStep ID="wzdStepPageTemplates" runat="server" StepType="Step">
                <asp:Panel ID="pnlStepPageTemplates" runat="server" SkinID="NewSiteWizardStep">
                    <uc2:ExportGridView ID="ucPageTemplates" runat="server" />
                    <uc2:ExportGridView ID="ucLayouts" runat="server" />
                </asp:Panel>
            </asp:WizardStep>
            <asp:WizardStep ID="wzdStepDocumentTypes" runat="server" StepType="Step">
                <asp:Panel ID="pnlStepDocumentTypes" runat="server" SkinID="NewSiteWizardStep">
                    <uc2:ExportGridView ID="ucDocTypes" runat="server" />
                </asp:Panel>
            </asp:WizardStep>
            <asp:WizardStep ID="wzdStepUsers" runat="server" StepType="Step">
                <asp:Panel ID="pnlStepUsers" runat="server" SkinID="NewSiteWizardStep">
                    <uc2:ExportGridView ID="ucUsers" runat="server" />
                </asp:Panel>
            </asp:WizardStep>
            <asp:WizardStep ID="wzdStepWebparts" runat="server" StepType="Step">
                <asp:Panel ID="pnlStepWebparts" runat="server" SkinID="NewSiteWizardStep">
                    <uc2:ExportGridView ID="ucWebParts" runat="server" />
                </asp:Panel>
            </asp:WizardStep>
            <asp:WizardStep ID="wzdStepWebPartContainers" runat="server" StepType="Step">
                <asp:Panel ID="pnlStepWebPartContainers" runat="server" SkinID="NewSiteWizardStep">
                    <uc2:ExportGridView ID="ucWebPartContainers" runat="server" />
                </asp:Panel>
            </asp:WizardStep>
            <asp:WizardStep ID="wzdStepFormUserControls" runat="server" StepType="Step">
                <asp:Panel ID="pnlStepFormUserControls" runat="server" SkinID="NewSiteWizardStep">
                    <uc2:ExportGridView ID="ucFormUserCtrls" runat="server" />
                </asp:Panel>
            </asp:WizardStep>
            <asp:WizardStep ID="wzdStepInlineControls" runat="server" AllowReturn="False" StepType="Step">
                <asp:Panel ID="pnlStepInlineControls" runat="server" SkinID="NewSiteWizardStep">
                    <uc2:ExportGridView ID="ucInlineCtrls" runat="server" />
                </asp:Panel>
            </asp:WizardStep>
            <asp:WizardStep ID="wzdStepFinish" runat="server" AllowReturn="False" StepType="Finish">
                <asp:Panel ID="pnlStepFinish" runat="server" SkinID="NewSiteWizardStep">
                    <asp:Label ID="lblResult" runat="server" />
                </asp:Panel>
            </asp:WizardStep>
        </WizardSteps>
    </asp:Wizard>
</div>
<asp:Label ID="lblError" runat="server" SkinID="ErrorLabel"></asp:Label>
