using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.ImportExport;

public partial class Import_ImportType : System.Web.UI.UserControl
{
    /// <summary>
    /// If the conflicts will be resolved mnually by the user
    /// </summary>
    public ImportTypeEnum ImportType
    {
        get 
        {
            // Import only selected
            if (this.radSelectObjects.Checked)
            {
                return ImportTypeEnum.OnlySelected;
            }
            // Import only new objects
            else if(this.radDoNotOverwrite.Checked)
            {
                return ImportTypeEnum.DoNotOverwrite;
            }
            // Overwrite all
            else
            {
                return ImportTypeEnum.OverwriteAll;
            }
        }
    }


    protected void Page_Load(object sender, EventArgs e)
    {
        this.radSelectObjects.Text = ResHelper.GetString("ImportSite.StepImportType.radSelectObjects");
        this.radOverwriteAll.Text = ResHelper.GetString("ImportSite.StepImportType.radOverwriteAll");
        this.radDoNotOverwrite.Text = ResHelper.GetString("ImportSite.StepImportType.radDoNotOverwrite");
    }
}
