using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.TreeEngine;
using CMS.CMSSiteMapProvider;
using CMS.GlobalHelper;

public partial class CMSSiteManager_Sites_NewSite_DefineSiteStructure_tree : SiteManagerPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        this.ltlScript.Text = ScriptHelper.GetScript("treeUrl = '" + ResolveUrl("~/CMSSiteManager/Sites/NewSite/DefineSiteStructure/Tree.aspx") + "';");
        
        this.siteName.Value = ValidationHelper.GetString(Request.QueryString["sitename"], "");

        this.treeContent.NodeTextTemplate = "<span class=\"ContentTreeItem\" onclick=\"SelectNode(##NODEID##, this); return false;\">##ICON##<span class=\"Name\">##NODENAME##</span></span>";
        this.treeContent.SelectedNodeTextTemplate = "<span id=\"treeSelectedNode\" class=\"ContentTreeSelectedItem\" onclick=\"SelectNode(##NODEID##, this); return false;\">##ICON##<span class=\"Name\">##NODENAME##</span></span>";
        this.treeContent.MaxTreeNodeText = "<span class=\"ContentTreeItem\" onclick=\"Listing(##PARENTNODEID##, this); return false;\"><span class=\"Name\" style=\"font-style: italic;\">" + ResHelper.GetString("ContentTree.SeeListing") + "</span></span>";

        this.treeContent.SiteName = siteName.Value;

        // If nodeId set, init the list of the nodes to expand
        int expandNodeId = 0;
        if (Request.QueryString["expandnodeid"] != null)
        {
            expandNodeId = ValidationHelper.GetInteger(Request.QueryString["expandnodeid"], 0);
        }
        this.treeContent.ExpandNodeID = expandNodeId;

        // Current Node ID
        int nodeId = 0;
        if (Request.QueryString["nodeid"] != null)
        {
            nodeId = ValidationHelper.GetInteger(Request.QueryString["nodeid"], 0);
        }
        else
        {
            TreeProvider tree = new TreeProvider();
            CMS.TreeEngine.TreeNode node = tree.SelectSingleNode(siteName.Value, "/", TreeProvider.ALL_CULTURES);
            if (node != null)
            {
                nodeId = node.NodeID;
            }
        }

        this.treeContent.NodeID = nodeId;

        // Setup the current node script
        if (nodeId > 0)
        {
            this.ltlScript.Text += ScriptHelper.GetScript("    currentNodeId = " + nodeId + ";");
        }
    }
}
