using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using CMS.GlobalHelper;
using CMS.SiteProvider;

public partial class SiteManager_Sites_Site_Edit_DomainAliases : SiteManagerPage
{
    protected int siteId = 0;
    protected string siteName = "";

    protected DataSet mDs = new DataSet();

    protected void Page_Load(object sender, EventArgs e)
    {

        lnkNewAlias.Text = ResHelper.GetString("Sites-DomainAliases.NewAlias");
        imgNewAlias.ImageUrl = "~/App_Themes/" + this.Theme + "/Images/CMSSiteManager/Sites/DomainAliases/addalias.gif";
        

        if ((Request.QueryString["siteid"] != null) && (Request.QueryString["siteid"].ToString() != ""))
        {
            siteId = Convert.ToInt32(Request.QueryString["siteid"]);
            if (siteId > 0)
            {

                mDs = SiteInfoProvider.GetDomainAliases(siteId).Copy();

                if (mDs != null)
                {
                    int i = 0;

                    // Where Visitor culture is not defined replace it to "(Automatic)"
                    foreach (DataRow mDr in mDs.Tables[0].Rows)
                    {
                        if (DataHelper.GetDataRowValue(mDr, "SiteDefaultVisitorCulture") == DBNull.Value || DataHelper.GetDataRowValue(mDr, "SiteDefaultVisitorCulture") == null || ValidationHelper.GetString(DataHelper.GetDataRowValue(mDr, "SiteDefaultVisitorCulture"), "") == "")
                        {
                            DataHelper.SetDataRowValue(mDs.Tables[0].Rows[i], "SiteDefaultVisitorCulture", ResHelper.GetString("Site_Edit.Automatic"));
                        }
                        else
                        {
                            CultureInfo ci = CultureInfoProvider.GetCultureInfo(ValidationHelper.GetString(DataHelper.GetDataRowValue(mDr, "SiteDefaultVisitorCulture"),""));
                            if (ci != null)
                            {
                                DataHelper.SetDataRowValue(mDs.Tables[0].Rows[i], "SiteDefaultVisitorCulture", ci.CultureName);   
                            }
                        }
                        
                        i++;
                    }
                }

                //Set unigrid
                UniGridAliases.GridView.GridLines = GridLines.Horizontal;
                UniGridAliases.OnAction += new OnActionEventHandler(UniGridAliases_OnAction);
                
                UniGridAliases.HideControlForZeroRows = true;
                UniGridAliases.DataSource = mDs;
                UniGridAliases.DataBind();
                
            }
            lnkNewAlias.NavigateUrl = "Site_Edit_DomainAlias_Edit.aspx?&siteId=" + siteId;
        }

        
    }

    /// <summary>
    /// UniGrid actions
    /// </summary>
    /// <param name="actionName"></param>
    /// <param name="actionArgument"></param>
    void UniGridAliases_OnAction(string actionName, object actionArgument)
    {
        if (actionName == "edit")
        {
            Response.Redirect("Site_Edit_DomainAlias_Edit.aspx?siteId=" + siteId.ToString()+"&domainAliasId="+actionArgument.ToString());
        }
        else if (actionName == "delete")
        {
            if (mDs != null && actionArgument != null && Convert.ToInt32(actionArgument) > 0)
            {
                string mDomainName = "";
                           
                foreach (DataRow mDr in mDs.Tables[0].Rows)
                {
                    if (ValidationHelper.GetInteger(DataHelper.GetDataRowValue(mDr, "SiteDomainAliasID"),0) == Convert.ToInt32(actionArgument))
                    {
                        mDomainName = ValidationHelper.GetString(DataHelper.GetDataRowValue(mDr, "SiteDomainAliasName"), "");
                    }
                    
                }
                
                SiteInfoProvider.DeleteDomainAlias(siteId, mDomainName);
                Response.Redirect("Site_Edit_DomainAliases.aspx?siteId=" + siteId.ToString());
            }
        }
    }
}
