using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.CMSHelper;
using CMS.GlobalHelper;
using CMS.TreeEngine;

public partial class CMSControlsExamples_BasicMultiColumnTable : ControlsExamplesPage
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string[,] tableParams = new string[3, 4];
        DataSet notebooksDS = null;


        // set data source
        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        notebooksDS =  tree.SelectNodes(CMSContext.CurrentSite.SiteName,"/%",TreeProvider.ALL_CULTURES,true,"cms.product",null,null,-1,true,4);
        if (!DataHelper.DataSourceIsEmpty(notebooksDS))
        {
            BasicMultiColumnTable1.DataSource = notebooksDS.Tables[0];

            // define table header with product names
            tableParams[0, 0] = "Product:";
            tableParams[0, 1] = "productName";
            // add row with product description
            tableParams[1, 0] = "Description:";
            tableParams[1, 1] = "ProductDescription";
            // add row with product price
            tableParams[2, 0] = "Price:";
            tableParams[2, 1] = "productPrice";
            tableParams[2, 2] = "USD {%ProductPrice%}";
            tableParams[2, 3] = "N/A";
            BasicMultiColumnTable1.TableParams = tableParams;
        }
    }
}
