using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.CMSHelper;

public partial class CMSTemplates_CorporateSiteASPX_Blog : TemplatePage
{
    string className = CMSContext.CurrentPageInfo.ClassName.ToLower();

    protected void Page_PreInit(object sender, EventArgs e)
    {
        // Load recent posts and post archive
        switch (className)
        {
            case "cms.blogmonth":
            case "cms.blogpost":
            case "cms.blog":
                postArchive.OnContentLoaded();
                recentPosts.OnContentLoaded();
                break;
        }

        // Get where condition for repeaters
        string where = String.Format("'{0}' LIKE NodeAliasPath + '%'", CMSContext.CurrentAliasPath);
        rptTitle.WhereCondition = where;
        rptSyndication.WhereCondition = where;
        rptSideText.WhereCondition = where;
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        // Set menu item image
        this.menu.MenuItemImageUrl = "~/app_themes/green/Images/Blue/arrowrightsmall.gif";
        this.menu.MenuItemOpenImageUrl = "~/app_themes/green/Images/Blue/arrowrightsmall.gif";

        rptBlogs.Visible = false;
        plcRightColumn.Visible = false;
        wpcBread.Visible = false;
        wpcBreadCrumbs.Visible = true;

        plcBlog.Visible = false;
        plcMonth.Visible = false;
        plcPost.Visible = false;

        switch (className)
        {
            case "cms.menuitem":
                rptBlogs.Visible = true;                
                break;

            case "cms.blog":
                plcBlog.Visible = true;
                plcRightColumn.Visible = true;
                wpcBread.Visible = true;
                wpcBreadCrumbs.Visible = false;
                break;

            case "cms.blogmonth":
                plcMonth.Visible = true;
                plcRightColumn.Visible = true;
                wpcBread.Visible = true;
                wpcBreadCrumbs.Visible = false;
                break;

            case "cms.blogpost":
                plcPost.Visible = true;
                plcRightColumn.Visible = true;
                wpcBread.Visible = true;
                wpcBreadCrumbs.Visible = false;
                break;
        }


    }
}
