using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.Blogs;
using CMS.PortalEngine;

public partial class CMSWebParts_Blogs_RecentPosts : CMSAbstractWebPart
{
    #region "Properties"

    /// <summary>
    /// Select TOP N items.
    /// </summary>
    public int SelectTopN
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("SelectTopN"), this.rptRecentPosts.SelectTopN);
        }
        set
        {
            this.SetValue("SelectTopN", value);
            this.rptRecentPosts.SelectTopN = value;
        }
    }


    /// <summary>
    /// Transformation name
    /// </summary>
    public string TransformationName
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("TransformationName"), this.rptRecentPosts.TransformationName);
        }
        set
        {
            this.SetValue("TransformationName", value);
            this.rptRecentPosts.TransformationName = value;
        }
    }

    #endregion

    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {            
        }
        else
        {
            PageInfo currentPage = CMSContext.CurrentPageInfo;

            // Get current parent blog
            CMS.TreeEngine.TreeNode blogNode = BlogHelper.GetParentBlog(currentPage.NodeAliasPath, CMSContext.CurrentSiteName);
            if (blogNode != null)
            {
                this.rptRecentPosts.Path = blogNode.NodeAliasPath + "/%";
            }

            this.rptRecentPosts.TransformationName = this.TransformationName;
            this.rptRecentPosts.SelectTopN = this.SelectTopN;            

        }
    }

}
