using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.SiteProvider;
using CMS.CMSHelper;
using CMS.DataEngine;

public partial class CMSWebParts_Designers_QuerySelection : DesignerPage
{
    string name = string.Empty;
    protected void Page_Load(object sender, EventArgs e)
    {
        string txtClientId = string.Empty;
        string lblClientId = string.Empty;
        if (ValidationHelper.GetString(Request.QueryString["txtElem"], string.Empty) != string.Empty)
        {
            txtClientId = ValidationHelper.GetString(Request.QueryString["txtElem"], string.Empty);
        }
        if (ValidationHelper.GetString(Request.QueryString["lblElem"], string.Empty) != string.Empty)
        {
            lblClientId = ValidationHelper.GetString(Request.QueryString["lblElem"], string.Empty);
        }
        ltlScript.Text = ScriptHelper.GetScript("var lstQuery = document.getElementById('" + lstNames.ClientID + "');");

        this.PageTitle1.TitleText = ResHelper.GetString("QuerySelection.Title");
        this.PageTitle1.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSWebParts/Designers/selectquery.gif";

        lblDocType.Text = ResHelper.GetString("QuerySelection.lblDocTypes");

        btnOK.Text = ResHelper.GetString("QuerySelection.OK");
        btnCancel.Text = ResHelper.GetString("QuerySelection.Cancel");
        if ((txtClientId != "") && (lblClientId != ""))
        {
            btnOK.OnClientClick = "SelectCurrentQuery('" + txtClientId + "','" + lblClientId + "'); return false;";
            btnCancel.Attributes.Add("onclick", "Cancel();  return false;");
        }


        if (!IsPostBack)
        {
            DataSet ds = DataClassInfoProvider.GetClassesOnSite(CMSContext.CurrentSite.SiteID);
            if (!DataHelper.IsEmpty(ds))
            {
                foreach (DataRow dr in ds.Tables[0].Rows)
                {
                    ListItem li = new ListItem();
                    li.Text = dr["ClassName"].ToString();
                    li.Value = dr["ClassID"].ToString();
                    drpDocTypes.Items.Add(li);
                }
            }

            // preselect
            drpDocTypes.SelectedIndex = 0;
            if (Request.QueryString["name"] != null)
            {
                name = Request.QueryString["name"].ToString();
                if (name != String.Empty)
                {
                    drpDocTypes.SelectedIndex = drpDocTypes.Items.IndexOf(drpDocTypes.Items.FindByText(name));
                }
            }

            drpDocTypes_SelectedIndexChanged(sender, e);
        }
    }

    protected void drpDocTypes_SelectedIndexChanged(object sender, EventArgs e)
    {
        lstNames.Items.Clear();
        DataSet ds = QueryProvider.GetQueries(Convert.ToInt32(drpDocTypes.SelectedValue));
        ds.Tables[0].DefaultView.Sort = "QueryName";
        if (!DataHelper.IsEmpty(ds))
        {
            foreach (DataRowView dr in ds.Tables[0].DefaultView)
            {
                lstNames.Items.Add(drpDocTypes.SelectedItem.Text + "." + dr["QueryName"].ToString());
            }
        }

    }
}
