using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.GlobalHelper;
using CMS.SettingsProvider;
using CMS.SiteProvider;
using CMS.CMSHelper;
using CMS.DataEngine;

public partial class CMSWebParts_Designers_TransformationSelection : DesignerPage
{
    string name = string.Empty;
    protected void Page_Load(object sender, EventArgs e)
    {
        string txtClientId = string.Empty;
        string lblClientId = string.Empty;
        if (ValidationHelper.GetString(Request.QueryString["txtElem"], string.Empty) != string.Empty)
        {
            txtClientId = ValidationHelper.GetString(Request.QueryString["txtElem"], string.Empty);
        }
        if (ValidationHelper.GetString(Request.QueryString["lblElem"], string.Empty) != string.Empty)
        {
            lblClientId = ValidationHelper.GetString(Request.QueryString["lblElem"], string.Empty);
        }
        ltlScript.Text = ScriptHelper.GetScript("var lstTransformation = document.getElementById('" + lstNames.ClientID + "');");

        this.PageTitle1.TitleText = ResHelper.GetString("TransformationSelection.Title");
        this.PageTitle1.TitleImage = "~/App_Themes/" + this.Theme + "/Images/CMSWebParts/Designers/selecttransformation.gif";

        lblDocType.Text = ResHelper.GetString("TransformationSelection.lblDocTypes");
        
        btnOK.Text = ResHelper.GetString("TransformationSelection.OK");
        btnCancel.Text = ResHelper.GetString("TransformationSelection.Cancel");
        if ((txtClientId != "") && (lblClientId != ""))
        {
            btnOK.OnClientClick = "SelectCurrentTransformation('" + txtClientId + "','" + lblClientId + "'); return false;";
            btnCancel.Attributes.Add("onclick", "Cancel(); return false;");
        }       

        if (!IsPostBack)
        {
            DataSet ds = DataClassInfoProvider.GetClassesOnSite(CMSContext.CurrentSite.SiteID);
            if (!DataHelper.IsEmpty(ds))
            {
                foreach (DataRow dr in ds.Tables[0].Rows)
                {
                    ListItem li = new ListItem();
                    li.Text = dr["ClassName"].ToString();
                    li.Value = dr["ClassID"].ToString();
                    drpDocTypes.Items.Add(li);
                }
            }

            // preselect based on classname in querystring
            drpDocTypes.SelectedIndex = 0;
            if (Request.QueryString["name"] != null)
            {
                name = Request.QueryString["name"].ToString();
                if (name != String.Empty)
                {
                    drpDocTypes.SelectedIndex = drpDocTypes.Items.IndexOf(drpDocTypes.Items.FindByText(name));
                }
            }

            if (Request.QueryString["classname"] != null)
            {
                name = Request.QueryString["classname"].ToString();
                if (name != String.Empty)
                {
                    drpDocTypes.SelectedIndex = drpDocTypes.Items.IndexOf(drpDocTypes.Items.FindByText(name));
                }
            }
            
            drpDocTypes_SelectedIndexChanged(sender, e);
        }
    }


    protected void drpDocTypes_SelectedIndexChanged(object sender, EventArgs e)
    {
            lstNames.Items.Clear();
            DataSet ds = TransformationInfoProvider.GetTransformations(Convert.ToInt32(drpDocTypes.SelectedValue));
            ds.Tables[0].DefaultView.Sort = "TransformationName";
        
            if (!DataHelper.IsEmpty(ds))
            {
                foreach (DataRowView dr in ds.Tables[0].DefaultView)
                {
                    // TransformationInfoProvider.GetTransformationFullName(Convert.ToInt32(dr["TransformationId"]))
                    lstNames.Items.Add(drpDocTypes.SelectedItem.Text + "." + dr["TransformationName"].ToString());
                }
            }
    
    }
}
