using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.CMSHelper;
using CMS.Ecommerce;
using CMS.SettingsProvider;

public partial class CMSWebParts_Ecommerce_ShoppingCartMiniPreviewWebPart : CMSAbstractWebPart
{
    protected string mSiteName = "";

    #region "Public properties"

    /// <summary>
    /// E-mail text
    /// </summary>
    public string IconImageUrl
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("IconImageUrl"), "~/App_Themes/" + this.Page.Theme + "/Images/Ecommerce/cart.gif");
        }
        set
        {
            this.SetValue("IconImageUrl", value);
            this.cartPreview.IconImage.ImageUrl = value;
        }
    }

    /// <summary>
    /// First name text
    /// </summary>
    public string ShoppingCartLinkUrl
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("ShoppingCartLinkUrl"), SettingsKeyProvider.GetStringValue(SiteName + ".CMSShoppingCartURL")).Trim();
        }
        set
        {
            this.SetValue("ShoppingCartLinkUrl", value);
            this.cartPreview.ShoppingCartLink.NavigateUrl = value.Trim();
        }
    }

    /// <summary>
    /// First name text
    /// </summary>
    public string ShoppingCartLinkText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("ShoppingCartLinkText"), ResHelper.LocalizeString("{$ShopingCartMiniPreview.ShoppingCartLinkText$}"));
        }
        set
        {
            this.SetValue("ShoppingCartLinkText", value);
            this.cartPreview.ShoppingCartLink.Text = value;
        }
    }


    /// <summary>
    /// First name text
    /// </summary>
    public string MyAccountLinkUrl
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("MyAccountLinkUrl"), "~/MyAccount.aspx").Trim();
        }
        set
        {
            this.SetValue("MyAccountLinkUrl", value);
            this.cartPreview.MyAccountLink.NavigateUrl = value.Trim();
        }
    }


    /// <summary>
    /// First name text
    /// </summary>
    public string MyAccountLinkText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("MyAccountLinkText"), ResHelper.LocalizeString("{$ShopingCartMiniPreview.MyAccountLinkText$}"));
        }
        set
        {
            this.SetValue("MyAccountLinkText", value);
            this.cartPreview.MyAccountLink.Text = value;
        }
    }

    /// <summary>
    /// My wishlist link url.
    /// </summary>
    public string MyWishlistLinkUrl
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WishlistLinkUrl"), SettingsKeyProvider.GetStringValue(SiteName + ".CMSWishlistURL")).Trim();
        }
        set
        {
            this.SetValue("WishlistLinkUrl", value);
            this.cartPreview.MyWishlistLink.NavigateUrl = value.Trim();
        }
    }


    /// <summary>
    /// My wishlist link text.
    /// </summary>
    public string MyWishlistLinkText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WishlistLinkText"), ResHelper.LocalizeString("{$ShopingCartMiniPreview.MyWishlistLinkText$}"));
        }
        set
        {
            this.SetValue("WishlistLinkText", value);
            this.cartPreview.MyWishlistLink.Text = value;
        }
    }


    /// <summary>
    /// First name text
    /// </summary>
    public string TotalPriceTitleText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("TotalPriceTitleText"), ResHelper.LocalizeString("{$ShopingCartMiniPreview.TotalPriceTitleText$}"));
        }
        set
        {
            this.SetValue("TotalPriceTitleText", value);
            this.cartPreview.TotalPriceTitle.Text = value;
        }
    }


    /// <summary>
    /// First name text
    /// </summary>
    public string TotalPriceValueText
    {
        get
        {
            ShoppingCartInfo sc = CMSContext.CurrentShoppingCart;
            if (sc != null)
            {
                return CurrencyInfoProvider.GetFormatedPrice(sc.RoundedTotalPrice, sc.CurrencyInfoObj);
            }
            else
            {
                return "0";
            }
        }
    }


    /// <summary>
    /// Returns site name.
    /// </summary>
    protected string SiteName
    {
        get
        {
            if ((mSiteName == "") && (CMSContext.CurrentSite != null))
            {
                mSiteName = CMSContext.CurrentSite.SiteName;
            }

            return mSiteName;
        }
    }

    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }



    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
        }
        else
        {
            this.cartPreview.IconImage.ImageUrl = ResolveUrl(this.IconImageUrl);
            this.cartPreview.ShoppingCartLink.NavigateUrl = this.ShoppingCartLinkUrl;
            this.cartPreview.ShoppingCartLink.Text = this.ShoppingCartLinkText;
            this.cartPreview.MyWishlistLink.NavigateUrl = this.MyWishlistLinkUrl;
            this.cartPreview.MyWishlistLink.Text = this.MyWishlistLinkText;
            this.cartPreview.MyAccountLink.NavigateUrl = this.MyAccountLinkUrl;
            this.cartPreview.MyAccountLink.Text = this.MyAccountLinkText;
            this.cartPreview.TotalPriceTitle.Text = this.TotalPriceTitleText;
            this.cartPreview.TotalPriceValue.Text = this.TotalPriceValueText;
        }
    }


    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        this.cartPreview.TotalPriceValue.Text = this.TotalPriceValueText;

    }
}
