using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.PortalEngine;
using CMS.CMSHelper;
using CMS.WebAnalytics;

public partial class CMSWebParts_Ecommerce_ShoppingCartWebPart : CMSAbstractWebPart
{
    #region "Public properties"

    public string RedirectAfterPurchase
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("RedirectAfterPurchase"), this.cartElem.RedirectAfterPurchase);
        }
        set
        {
            this.SetValue("RedirectAfterPurchase", value);
        }
    }

    /// <summary>
    /// True if password retrieval is enabled
    /// </summary>
    public bool PasswordRetrieval
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("PasswordRetrieval"), true);
        }
        set
        {
            this.SetValue("PasswordRetrieval", value);
        }
    }


    /// <summary>
    /// Conversion track name used after successful registration.
    /// </summary>
    public string RegistrationTrackConversionName
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("RegistrationTrackConversionName"), "");
        }
        set
        {
            if (value.Length > 400)
            {
                value = value.Substring(0, 400);
            }
            this.SetValue("RegistrationTrackConversionName", value);
        }
    }


    /// <summary>
    /// Conversion track name used after successful order.
    /// </summary>
    public string OrderTrackConversionName
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("OrderTrackConversionName"), "");
        }
        set
        {
            if (value.Length > 400)
            {
                value = value.Substring(0, 400);
            }
            this.SetValue("OrderTrackConversionName", value);
        }
    }

    #endregion

    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
        }
        else
        {
            string[] stepFiles = new string[5];
            stepFiles[0] = "~/CMSEcommerce/ShoppingCartContent.ascx";
            stepFiles[1] = "~/CMSEcommerce/ShoppingCartCheckRegistration.ascx";
            stepFiles[2] = "~/CMSEcommerce/ShoppingCartOrderAddresses.ascx";
            stepFiles[3] = "~/CMSEcommerce/ShoppingCartPaymentShipping.ascx";
            stepFiles[4] = "~/CMSEcommerce/ShoppingCartPreview.ascx";

            this.cartElem.StepFiles = stepFiles;
            this.cartElem.RedirectAfterPurchase = this.RedirectAfterPurchase;
            this.cartElem.PasswordRetrieval = this.PasswordRetrieval;
            this.cartElem.RegistrationTrackConversionName = this.RegistrationTrackConversionName;
            this.cartElem.OrderTrackConversionName = this.OrderTrackConversionName;
        }
    }
}
