using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;

public partial class CMSWebParts_General_usercontrol : CMSAbstractWebPart
{
    private string mUserControlPath = "";

    /// <summary>
    /// Path of the user control
    /// </summary>
    public string UserControlPath
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("UserControlPath"), mUserControlPath);
        }
        set
        {
            this.SetValue("UserControlPath", value);
            this.mUserControlPath = value;
        }
    }


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            // Do not process
        }
        else
        {
            if ((this.UserControlPath != null) && (this.UserControlPath != string.Empty))
            {
                try
                {
                    Controls.Add(Page.LoadControl(this.UserControlPath));
                }
                catch (Exception ex)
                {
                    lblError.Text = "[" + this.ID + "] " + ResHelper.GetString("WebPartUserControl.ErrorLoad") + ": " + ex.Message;
                    lblError.ToolTip = ex.StackTrace;
                    lblError.Visible = true;
                }
            }
        }
    }
}
