using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.SiteProvider;
using CMS.EmailEngine;
using CMS.EventLog;
using CMS.DataEngine;
using CMS.WebAnalytics;

public partial class CMSWebParts_Membership_RegistrationForm : CMSAbstractWebPart
{
    #region "Text properties"

    /// <summary>
    /// Skin ID
    /// </summary>
    public override string SkinID
    {
        get
        {
            return base.SkinID;
        }
        set
        {
            base.SkinID = value;
            SetSkinID(value);
        }
    }


    /// <summary>
    /// First name text
    /// </summary>
    public string FirstNameText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("FirstNameText"), ResHelper.LocalizeString("{$Webparts_Membership_RegistrationForm.FirstName$}"));
        }
        set
        {
            this.SetValue("FirstNameText", value);
            lblFirstName.Text = value;
        }
    }


    /// <summary>
    /// First name text
    /// </summary>
    public string LastNameText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("LastNameText"), ResHelper.LocalizeString("{$Webparts_Membership_RegistrationForm.LastName$}"));
        }
        set
        {
            this.SetValue("LastNameText", value);
            lblLastName.Text = value;
        }
    }


    /// <summary>
    /// First name text
    /// </summary>
    public string EmailText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("EmailText"), ResHelper.LocalizeString("{$Webparts_Membership_RegistrationForm.Email$}"));
        }
        set
        {
            this.SetValue("EmailText", value);
            lblEmail.Text = value;
        }
    }


    /// <summary>
    /// First name text
    /// </summary>
    public string PasswordText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("PasswordText"), ResHelper.LocalizeString("{$Webparts_Membership_RegistrationForm.Password$}"));
        }
        set
        {
            this.SetValue("PasswordText", value);
            lblPassword.Text = value;
        }
    }


    /// <summary>
    /// First name text
    /// </summary>
    public string ConfirmPasswordText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("ConfirmPasswordText"), ResHelper.LocalizeString("{$Webparts_Membership_RegistrationForm.ConfirmPassword$}"));
        }
        set
        {
            this.SetValue("ConfirmPasswordText", value);
            lblConfirmPassword.Text = value;
        }
    }


    /// <summary>
    /// First name text
    /// </summary>
    public string ButtonText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("ButtonText"), ResHelper.LocalizeString("{$Webparts_Membership_RegistrationForm.Button$}"));
        }
        set
        {
            this.SetValue("ButtonText", value);
            btnOK.Text = value;
        }
    }

    #endregion


    #region "Registration properties"

    /// <summary>
    /// Enable user after registration?
    /// </summary>
    public bool EnableUserAfterRegistration
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("EnableUserAfterRegistration"), true);
        }
        set
        {
            this.SetValue("EnableUserAfterRegistration", value);
        }
    }


    /// <summary>
    /// Send e-mail from address
    /// </summary>
    public string FromAddress
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("FromAddress"), "");
        }
        set
        {
            this.SetValue("FromAddress", value);
        }
    }


    /// <summary>
    /// Send e-mail To address
    /// </summary>
    public string ToAddress
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("ToAddress"), "");
        }
        set
        {
            this.SetValue("ToAddress", value);
        }
    }


    /// <summary>
    /// Notify administrator
    /// </summary>
    public bool NotifyAdministrator
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("NotifyAdministrator"), false);
        }
        set
        {
            this.SetValue("NotifyAdministrator", value);
        }
    }


    /// <summary>
    /// Assign registered user to roles
    /// </summary>
    public string AssignRoles
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("AssignToRoles"), "");
        }
        set
        {
            this.SetValue("AssignToRoles", value);
        }
    }


    /// <summary>
    /// Display message
    /// </summary>
    public string DisplayMessage
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("DisplayMessage"), "");
        }
        set
        {
            this.SetValue("DisplayMessage", value);
        }
    }


    /// <summary>
    /// Redirect to URL
    /// </summary>
    public string RedirectToURL
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("RedirectToURL"), "");
        }
        set
        {
            this.SetValue("RedirectToURL", value);
        }
    }

    #endregion


    #region "Conversion properties"

    /// <summary>
    /// Conversion track name used after successful registration.
    /// </summary>
    public string TrackConversionName
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("TrackConversionName"), "");
        }
        set
        {
            if (value.Length > 400)
            {
                value = value.Substring(0, 400);
            }
            this.SetValue("TrackConversionName", value);
        }
    }

    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            // Do not process
            rfvFirstName.Enabled = false;
            rfvEmail.Enabled = false;
            rfvPassword.Enabled = false;
            rfvConfirmPassword.Enabled = false;
            rfvLastName.Enabled = false;
        }
        else
        {
            // Set texts
            lblFirstName.Text = this.FirstNameText;
            lblLastName.Text = this.LastNameText;
            lblEmail.Text = this.EmailText;
            lblPassword.Text = this.PasswordText;
            lblConfirmPassword.Text = this.ConfirmPasswordText;
            btnOK.Text = this.ButtonText;

            // Set required field validators texts
            rfvFirstName.ErrorMessage = ResHelper.GetString("Webparts_Membership_RegistrationForm.rfvFirstName");
            rfvLastName.ErrorMessage = ResHelper.GetString("Webparts_Membership_RegistrationForm.rfvLastName");
            rfvEmail.ErrorMessage = ResHelper.GetString("Webparts_Membership_RegistrationForm.rfvEmail");
            rfvPassword.ErrorMessage = ResHelper.GetString("Webparts_Membership_RegistrationForm.rfvPassword");
            rfvConfirmPassword.ErrorMessage = ResHelper.GetString("Webparts_Membership_RegistrationForm.rfvConfirmPassword");

            // Set SkinID
            if (!this.StandAlone && (this.PageCycle < PageCycleEnum.Loaded))
            {
                SetSkinID(this.SkinID);
            }
        }
    }


    void SetSkinID(string skinId)
    {
        if (skinId != "")
        {
            lblFirstName.SkinID = skinId;
            lblLastName.SkinID = skinId;
            lblEmail.SkinID = skinId;
            lblPassword.SkinID = skinId;
            lblConfirmPassword.SkinID = skinId;
            txtFirstName.SkinID = skinId;
            txtLastName.SkinID = skinId;
            txtEmail.SkinID = skinId;
            txtPassword.SkinID = skinId;
            txtConfirmPassword.SkinID = skinId;
            btnOK.SkinID = skinId;
        }
    }


    protected void btnOK_Click(object sender, EventArgs e)
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            // Do not process
        }
        else
        {

            UserInfo ui = new UserInfo();
            ui = UserInfoProvider.GetUserInfo(txtEmail.Text);
            if (ui != null)
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("Webparts_Membership_RegistrationForm.UserAlreadyExists").Replace("%%name%%", txtEmail.Text);
            }
            else
            {
                if (txtPassword.Text != txtConfirmPassword.Text)
                {
                    lblError.Visible = true;
                    lblError.Text = ResHelper.GetString("Webparts_Membership_RegistrationForm.PassworDoNotMatch");
                }
                else if (ValidationHelper.IsEmail(txtEmail.Text.ToLower()))
                //if (txtEmail.Text.Contains("@") && txtEmail.Text.Contains(".") && txtEmail.Text.Length > 4)
                {

                    ui = new UserInfo();
                    ui.PreferredCultureCode = "";
                    ui.Email = txtEmail.Text;
                    ui.FirstName = txtFirstName.Text;
                    ui.FullName = txtFirstName.Text + " " + txtLastName.Text;
                    ui.LastName = txtLastName.Text;
                    ui.MiddleName = "";
                    ui.UserName = txtEmail.Text;
                    ui.Enabled = this.EnableUserAfterRegistration;

                    ui.IsEditor = false;
                    ui.IsGlobalAdministrator = false;
                    ui.SetValue("UserPassword", txtPassword.Text);
                    ui.UserURLReferrer = CMSContext.CurrentUser.URLReferrer;
                    ui.UserCampaign = CMSContext.CurrentUser.Campaign;

                    // autentify user
                    UserInfoProvider.SetUserInfo(ui);

                    string mFrom = this.FromAddress;
                    string mRecipients = this.ToAddress;

                    // Notify administrator
                    if (this.NotifyAdministrator && (mFrom != "") && (mRecipients != ""))
                    {


                        string mSubject = "";
                        mSubject = ResHelper.GetString("RegistrationForm.EmailSubject");

                        string[,] replacements = new string[4, 2];
                        replacements[0, 0] = "firstname";
                        replacements[0, 1] = ui.FirstName;
                        replacements[1, 0] = "lastname";
                        replacements[1, 1] = ui.LastName;
                        replacements[2, 0] = "email";
                        replacements[2, 1] = ui.Email;
                        replacements[3, 0] = "username";
                        replacements[3, 1] = ui.UserName;

                        EmailTemplateInfo mEmailTemplate = null;

                        if (!ui.Enabled)
                        {
                            mEmailTemplate = EmailTemplateProvider.GetEmailTemplate("Registration.Approve", CMSContext.CurrentSite.SiteName);
                        }
                        else
                        {
                            mEmailTemplate = EmailTemplateProvider.GetEmailTemplate("Registration.New", CMSContext.CurrentSite.SiteName);
                        }

                        GeneralConnection genConn = ConnectionHelper.GetConnection();
                        EventLogProvider ev = new EventLogProvider(genConn);

                        if (mEmailTemplate == null)
                        {
                            ev.LogEvent("E", DateTime.Now, "RegistrationForm", "GetEmailTemplate", CMS.GlobalHelper.HTTPHelper.GetAbsoluteUri());
                        }

                        EmailMessage message = new EmailMessage();

                        TextHelper th = new TextHelper();

                        message.EmailFormat = EmailFormatEnum.Html;

                        message.From = mFrom;
                        message.Recipients = mRecipients;

                        message.Subject = TextHelper.MergeText(mSubject, replacements);
                        message.Body = TextHelper.MergeText(mEmailTemplate.TemplateText, replacements);

                        try
                        {
                            EmailSender.SendEmail(CMSContext.CurrentSite.SiteName, message);
                        }
                        catch
                        {
                            ev.LogEvent("E", DateTime.Now, "Membership", "RegistrationEmail", CMSContext.CurrentSite.SiteID);
                        }
                    }

                    // Track successful registration conversion
                    if (this.TrackConversionName != string.Empty)
                    {
                        string siteName = CMSContext.CurrentSite.SiteName;

                        if (AnalyticsHelper.AnalyticsEnabled(siteName) && !AnalyticsHelper.IsIPExcluded(siteName, HttpContext.Current.Request.UserHostAddress))
                        {
                            string objectName = new ContextResolver().ResolveMacros(this.TrackConversionName);
                            HitLogProvider.LogHit("conversion", siteName, CMSContext.CurrentUser.PreferredCultureCode, objectName, 0);
                        }
                    }

                    string roles = this.AssignRoles.ToString();
                    char[] separator = new char[1];
                    separator[0] = ';';
                    string[] roleList = roles.Split(separator);
                    string roleName = "";
                    if (CMSContext.CurrentSite != null)
                    {
                        UserInfoProvider.AddUserToSite(ui.UserName, CMSContext.CurrentSite.SiteName);
                        if (roleList != null)
                        {
                            string siteName = CMSContext.CurrentSite.SiteName;
                            for (int i = 0; i < roleList.Length; i++)
                            {
                                roleName = roleList[i];
                                if (RoleInfoProvider.RoleExists(roleName, siteName))
                                {
                                    UserInfoProvider.AddUserToRole(ui.UserName, roleName, siteName);
                                }
                            }
                        }
                    }

                    if (this.DisplayMessage.Trim() != "")
                    {
                        RegForm.Visible = false;
                        lblText.Visible = true;
                        lblText.Text = this.DisplayMessage;
                    }
                    else
                    {
                        if (ui.Enabled)
                        {
                            FormsAuthentication.SetAuthCookie(ui.UserName, true);
                        }

                        if (this.RedirectToURL != string.Empty)
                        {
                            Response.Redirect(this.RedirectToURL);
                        }
                        else if (ValidationHelper.GetString(Request.QueryString["ReturnURL"], "") != "")
                        {
                            Response.Redirect(Request.QueryString["ReturnURL"]);
                        }
                    }
                    lblError.Visible = false;
                }
                else
                {
                    lblError.Visible = true;
                    lblError.Text = ResHelper.GetString("Webparts_Membership_RegistrationForm.EmailIsNotValid");
                }
            }
        }
    }
}
