using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;

public partial class CMSWebParts_Navigation_cmssitemap : CMSAbstractWebPart
{
    #region "Document properties"

    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CacheMinutes"), this.smElem.CacheMinutes);
        }
        set
        {
            this.SetValue("CacheMinutes", value);
            this.smElem.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.smElem.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
        }
    }


    /// <summary>
    /// Class names
    /// </summary>
    public string ClassNames
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.smElem.ClassNames), this.smElem.ClassNames);
        }
        set
        {
            this.SetValue("ClassNames", value);
            this.smElem.ClassNames = value;
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.smElem.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.smElem.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.smElem.CultureCode), this.smElem.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.smElem.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.smElem.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.smElem.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.smElem.OrderBy), this.smElem.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.smElem.OrderBy = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), this.smElem.Path), this.smElem.Path);
        }
        set
        {
            this.SetValue("Path", value);
            this.smElem.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.smElem.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelctOnlyPublished", value);
            this.smElem.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.smElem.SiteName), this.smElem.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.smElem.SiteName = value;
        }
    }

    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.smElem.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.smElem.WhereCondition = value;
        }
    }


    /// <summary>
    /// Render item ID
    /// </summary>
    public bool RenderLinkTitle
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("RenderLinkTitle"), this.smElem.RenderLinkTitle);
        }
        set
        {
            this.SetValue("RenderLinkTitle", value);
            this.smElem.RenderLinkTitle = value;
        }
    }

    #endregion


    /// <summary>
    /// URL target
    /// </summary>
    public string UrlTarget
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("UrlTarget"), this.smElem.UrlTarget), this.smElem.UrlTarget);
        }
        set
        {
            this.SetValue("UrlTarget", value);
            this.smElem.UrlTarget = value;
        }
    }


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.smElem.StopProcessing = true;
        }
        else
        {
            // Set properties from Webpart form        
            this.smElem.CacheItemName = this.CacheItemName;
            this.smElem.CacheMinutes = this.CacheMinutes;
            this.smElem.CheckPermissions = this.CheckPermissions;
            this.smElem.ClassNames = this.ClassNames;
            this.smElem.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
            this.smElem.CultureCode = this.CultureCode;
            this.smElem.MaxRelativeLevel = this.MaxRelativeLevel;
            this.smElem.OrderBy = this.OrderBy;
            this.smElem.Path = this.Path;
            this.smElem.SelectOnlyPublished = this.SelectOnlyPublished;
            this.smElem.SiteName = this.SiteName;
            this.smElem.UrlTarget = this.UrlTarget;
            this.smElem.WhereCondition = this.WhereCondition;
            this.smElem.RenderLinkTitle = this.RenderLinkTitle;
        }
    }

}
