using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.ExtendedControls;
using CMS.GlobalHelper;
using CMS.Newsletter;
using CMS.CMSHelper;

public partial class CMSWebParts_Newsletters_NewsletterUnsubscription : System.Web.UI.UserControl
{
    private string mUnsubscribedText = ""; //message to display if subscriber is unsubscribed

    public string UnsubscribedText
    {
        get
        {
            return mUnsubscribedText;
        }
        set
        {
            mUnsubscribedText = value;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        int siteId = 0;

        if (CMSContext.CurrentSite != null)
        {
            siteId = CMSContext.CurrentSite.SiteID;
        }

        Guid subscriberGuid = ValidationHelper.GetGuid(Request.QueryString["subscriberguid"], Guid.Empty);
        Guid newsletterGuid = ValidationHelper.GetGuid(Request.QueryString["newsletterguid"], Guid.Empty);

        if ((subscriberGuid != Guid.Empty) && (newsletterGuid != Guid.Empty))
        {
            if (SubscriberProvider.IsSubscribed(subscriberGuid, newsletterGuid, siteId))
            {
                SubscriberProvider.Unsubscribe(subscriberGuid, newsletterGuid, siteId);
                lblInfo.Visible = true;
                if (this.UnsubscribedText == "")
                {
                    lblInfo.Text = ResHelper.GetString("Unsubscribe.Unsubscribed");
                }
                else
                {
                    lblInfo.Text = this.UnsubscribedText;
                }
                //if subscriber has unsubscribed after some issue, increase number of unsubscribed persons of that issue by 1
                int issueId = ValidationHelper.GetInteger(Request.QueryString["issueid"], 0);
                if (issueId > 0)
                {
                    Issue issue = IssueProvider.GetIssue(issueId);
                    if (issue != null)
                    {
                        issue.IncreaseUnsubscribedNumber();
                        IssueProvider.SetIssue(issue);
                    }
                }
            }
            else
            {
                lblError.Visible = true;
                lblError.Text = ResHelper.GetString("Unsubscribe.NotSubscribed");
            }
        }
    }
}
