using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.PortalEngine;
using CMS.CMSHelper;
using CMS.Reporting;

public partial class CMSWebParts_Reporting_Report : CMSAbstractWebPart
{
    /// <summary>
    /// Code name of the report, which should be displayed.
    /// </summary>
    public string ReportName
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("ReportName"), this.DisplayReport1.ReportName);
        }
        set
        {
            this.SetValue("ReportName", value);
        }
    }

    /// <summary>
    /// Code name of the report, which should be displayed.
    /// </summary>
    public bool DisplayFilter
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("DisplayFilter"), false);
        }
        set
        {
            this.SetValue("DisplayFilter", value);
        }
    }


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            // Do nothing
        }
        else
        {
            this.DisplayReport1.DisplayFilter = this.DisplayFilter;
            this.DisplayReport1.ReportName = this.ReportName;            
            this.DisplayReport1.ReloadData(true);
        }
    }


}
