using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.DataEngine;
using CMS.GlobalHelper;
using CMS.CMSHelper;

public partial class CMSWebParts_UserContributions_ContributionList : CMSAbstractWebPart
{
    #region "Document properties"

    /// <summary>
    /// Class names
    /// </summary>
    public string ClassNames
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.list.ClassNames), this.list.ClassNames);
        }
        set
        {
            this.SetValue("ClassNames", value);
            this.list.ClassNames = value;
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.list.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.list.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.list.CultureCode), this.list.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.list.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.list.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.list.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.list.OrderBy), this.list.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.list.OrderBy = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), null), null);
        }
        set
        {
            this.SetValue("Path", value);
            this.list.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.list.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelectOnlyPublished", value);
            this.list.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.list.SiteName), this.list.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.list.SiteName = value;
        }
    }

    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.list.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.list.WhereCondition = value;
        }
    }

    #endregion


    #region " Public properties "

    /// <summary>
    /// Indicates whether the list of documents should be displayed.
    /// </summary>
    public bool DisplayList
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("DisplayList"), this.list.DisplayList);
        }
        set
        {
            this.SetValue("DisplayList", value);
            this.list.DisplayList = value;
        }
    }


    /// <summary>
    /// Path for new created documents.
    /// </summary>
    public string NewDocumentPath
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("NewDocumentPath"), this.list.NewDocumentPath);
        }
        set
        {
            this.SetValue("NewDocumentPath", value);
            this.list.NewDocumentPath = value;
        }
    }


    /// <summary>
    /// Indicates whether inserting new document is allowed.
    /// </summary>
    public bool AllowInsert
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("AllowInsert"), this.list.AllowInsert);
        }
        set
        {
            this.SetValue("AllowInsert", value);
            this.list.AllowInsert = value;
        }
    }


    /// <summary>
    /// Indicates whether editing document is allowed.
    /// </summary>
    public bool AllowEdit
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("AllowEdit"), this.list.AllowEdit);
        }
        set
        {
            this.SetValue("AllowEdit", value);
            this.list.AllowEdit = value;
        }
    }


    /// <summary>
    /// Indicates whether deleting document is allowed.
    /// </summary>
    public bool AllowDelete
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("AllowDelete"), this.list.AllowDelete);
        }
        set
        {
            this.SetValue("AllowDelete", value);
            this.list.AllowDelete = value;
        }
    }


    /// <summary>
    /// Which group of users can work with the documents
    /// </summary>
    public UserContributionAllowUserEnum AllowUsers
    {
        get
        {
            return (UserContributionAllowUserEnum)(ValidationHelper.GetInteger(this.GetValue("AllowUsers"), 2));
        }
        set
        {
            this.SetValue("AllowUsers", value);
            this.list.AllowUsers = value;
        }
    }


    /// <summary>
    /// Page template the new items are assigned to.
    /// </summary>
    public string NewItemPageTemplate
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("NewItemPageTemplate"), this.list.NewItemPageTemplate);
        }
        set
        {
            this.SetValue("NewItemPageTemplate", value);
            this.list.NewItemPageTemplate = value;
        }
    }


    /// <summary>
    /// Type of the child documents that are allowed to be created.
    /// </summary>
    public string AllowedChildClasses
    {
        get
        {
            return ValidationHelper.GetString(this.GetValue("AllowedChildClasses"), this.list.AllowedChildClasses);
        }
        set
        {
            this.SetValue("AllowedChildClasses", value);
            this.list.AllowedChildClasses = value;
        }
    }


    /// <summary>
    /// Indicates whether permissions should be checked.
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.list.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
            this.list.CheckPermissions = value;
        }
    }

    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.list.StopProcessing = true; // Do nothing
        }
        else
        {
            this.list.AllowEdit = this.AllowEdit;
            this.list.AllowInsert = this.AllowInsert;
            this.list.AllowDelete = this.AllowDelete;
            this.list.CheckPermissions = this.CheckPermissions;
            this.list.AllowedChildClasses = this.AllowedChildClasses;
            this.list.NewItemPageTemplate = this.NewItemPageTemplate;
            this.list.AllowUsers = this.AllowUsers;
            this.list.WhereCondition = this.WhereCondition;
            this.list.SiteName = this.SiteName;
            this.list.SelectOnlyPublished = this.SelectOnlyPublished;
            this.list.Path = this.Path;
            this.list.OrderBy = this.OrderBy;
            this.list.MaxRelativeLevel = this.MaxRelativeLevel;
            this.list.CultureCode = this.CultureCode;
            this.list.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
            this.list.ClassNames = this.ClassNames;
            this.list.DisplayList = this.DisplayList;
            this.list.NewDocumentPath = this.NewDocumentPath;
        }
    }
}
