using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.Controls;
using CMS.CMSHelper;

public partial class CMSWebParts_Viewers_ImageGallery : CMSAbstractWebPart
{
    #region "Document properties"

    ///// <summary>
    ///// Cache item name
    ///// </summary>
    //public string CacheItemName
    //{
    //    get
    //    {
    //        return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CacheItemName"), this.lstImages.CacheItemName), this.lstImages.CacheItemName);
    //    }
    //    set
    //    {
    //        this.SetValue("CacheItemName", value);
    //        this.lstImages.CacheItemName = value;
    //    }
    //}


    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CacheMinutes"), this.lstImages.CacheMinutes);
        }
        set
        {
            this.SetValue("CacheMinutes", value);
            this.lstImages.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.lstImages.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.lstImages.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.lstImages.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.lstImages.CultureCode), this.lstImages.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.lstImages.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.lstImages.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.lstImages.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.lstImages.OrderBy), this.lstImages.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.lstImages.OrderBy = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), this.lstImages.Path), this.lstImages.Path);
        }
        set
        {
            this.SetValue("Path", value);
            this.lstImages.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.lstImages.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelctOnlyPublished", value);
            this.lstImages.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.lstImages.SiteName), this.lstImages.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.lstImages.SiteName = value;
        }
    }


    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.lstImages.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.lstImages.WhereCondition = value;
        }
    }

    #endregion


    #region "Relationships properties"

    /// <summary>
    /// Related node is on the left side
    /// </summary>
    public bool RelatedNodeIsOnTheLeftSide
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("RelatedNodeIsOnTheLeftSide"), this.lstImages.RelatedNodeIsOnTheLeftSide);
        }
        set
        {
            this.SetValue("RelatedNodeIsOnTheLeftSide", value);
            this.lstImages.RelatedNodeIsOnTheLeftSide = value;
        }
    }


    /// <summary>
    /// Relationship name
    /// </summary>
    public string RelationshipName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("RelationshipName"), this.lstImages.RelationshipName), this.lstImages.RelationshipName);
        }
        set
        {
            this.SetValue("RelationshipName", value);
            this.lstImages.RelationshipName = value;
        }
    }


    /// <summary>
    /// Relationship with node GUID
    /// </summary>
    public Guid RelationshipWithNodeGUID
    {
        get
        {
            return ValidationHelper.GetGuid(this.GetValue("RelationshipWithNodeGuid"), this.lstImages.RelationshipWithNodeGuid);
        }
        set
        {
            this.SetValue("RelationshipWithNodeGuid", value);
            this.lstImages.RelationshipWithNodeGuid = value;
        }
    }

    #endregion


    #region "Transformation properties"

    /// <summary>
    /// Thumbnail transformation
    /// </summary>
    public string ThumbnailTransformation
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("ThumbnailTransformation"), this.lstImages.TransformationName), this.lstImages.TransformationName);
        }
        set
        {
            this.SetValue("ThumbnailTransformation", value);
            this.lstImages.TransformationName = value;
        }
    }


    /// <summary>
    /// Detail transformation
    /// </summary>
    public string DetailTransformation
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("DetailTransformation"), this.lstImages.SelectedItemTransformationName), this.lstImages.SelectedItemTransformationName);
        }
        set
        {
            this.SetValue("DetailTransformation", value);
            this.lstImages.SelectedItemTransformationName = value;
        }
    }


    #endregion


    #region "Pager properties"

    /// <summary>
    /// Pager control
    /// </summary>
    public DataPager PagerControl
    {
        get
        {
            return (DataPager)this.lstImages.PagerControl;
        }
    }


    /// <summary>
    /// Pager position
    /// </summary>
    public PagingPlaceTypeEnum PagerPosition
    {
        get
        {
            return this.PagerControl.PagerPosition;
        }
        set
        {
            this.SetValue("PagerPosition", value.ToString());
            this.PagerControl.PagerPosition = value;
        }
    }


    /// <summary>
    /// Page size
    /// </summary>
    public int PageSize
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.PagerControl.PageSize);
        }
        set
        {
            this.SetValue("PageSize", value);
            this.PagerControl.PageSize = value;
        }
    }


    /// <summary>
    /// Pager query string key
    /// </summary>
    public string QueryStringKey
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("QueryStringKey"), this.PagerControl.QueryStringKey), this.PagerControl.QueryStringKey);
        }
        set
        {
            this.SetValue("QueryStringKey", value);
            this.PagerControl.QueryStringKey = value;
        }
    }


    /// <summary>
    /// Paging mode
    /// </summary>
    public PagingModeTypeEnum PagingMode
    {
        get
        {
            return this.PagerControl.GetPagingMode(DataHelper.GetNotEmpty(this.GetValue("PagingMode"), this.PagerControl.PagingMode.ToString()));
        }
        set
        {
            this.SetValue("PagingMode", value.ToString());
            this.PagerControl.PagingMode = value;
        }
    }


    /// <summary>
    /// Show first / last links
    /// </summary>
    public bool ShowFirstLast
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowFirstLast"), this.PagerControl.ShowFirstLast);
        }
        set
        {
            this.SetValue("ShowFirstLast", value);
            this.PagerControl.ShowFirstLast = value;
        }
    }


    /// <summary>
    /// Show navigation buttons on top of the control
    /// </summary>
    public bool ShowButtonsOnTop
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowButtonsOnTop"), true);
        }
        set
        {
            this.SetValue("ShowButtonsOnTop", value);
            RelocateButtons();
        }
    }

    #endregion


    #region Public properties

    /// <summary>
    /// Hide control for zero rows
    /// </summary>
    public bool HideControlForZeroRows
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("HideControlForZeroRows"), this.lstImages.HideControlForZeroRows);
        }
        set
        {
            this.SetValue("HideControlForZeroRows", value);
            this.lstImages.HideControlForZeroRows = value;
        }
    }


    /// <summary>
    /// Zero rows text
    /// </summary>
    public string ZeroRowsText
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("ZeroRowsText"), this.lstImages.ZeroRowsText), this.lstImages.ZeroRowsText);
        }
        set
        {
            this.SetValue("ZeroRowsText", value);
            this.lstImages.ZeroRowsText = value;
        }
    }

    #endregion


    #region Repeat properties

    /// <summary>
    /// Number of columns to diplay
    /// </summary>
    public int Columns
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("Columns"), this.lstImages.RepeatColumns);
        }
        set
        {
            this.SetValue("Columns", value);
            this.lstImages.RepeatColumns = value;
            this.PagerControl.PageSize = value * this.RowsPerPage;
        }
    }

    /// <summary>
    /// Numbers of rows to display
    /// </summary>
    public int RowsPerPage
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("RowsPerPage"), 1);
        }
        set
        {
            this.SetValue("RowsPerPage", value);
            this.PagerControl.PageSize = this.Columns * value;
        }
    }


    /// <summary>
    /// Repeat layout
    /// </summary>
    public RepeatLayout RepeatLayout
    {
        get
        {
            return CMSDataList.GetRepeatLayout(DataHelper.GetNotEmpty(this.GetValue("RepeatLayout"), this.lstImages.RepeatLayout.ToString()));
        }
        set
        {
            this.SetValue("RepeatLayout", value);
            this.lstImages.RepeatLayout = value;
        }
    }


    /// <summary>
    /// Repeat direction
    /// </summary>
    public RepeatDirection RepeatDirection
    {
        get
        {
            return CMSDataList.GetRepeatDirection(DataHelper.GetNotEmpty(this.GetValue("RepeatDirection"), this.lstImages.RepeatDirection.ToString()));
        }
        set
        {
            this.SetValue("RepeatDirection", value);
            this.lstImages.RepeatDirection = value;
        }
    }

    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        this.lstImages.PagerControl = this.pagerElem;
        this.pagerElem.OnDataSourceChanged += new EventHandler(pagerElem_OnDataSourceChanged);
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == CMS.CMSHelper.ViewModeEnum.Design) || this.HideOnCurrentPage || (!this.IsVisible))
        {
            this.lstImages.StopProcessing = true;
        }
        else
        {
            // Set properties from Webpart form   
            this.lstImages.CacheItemName = this.CacheItemName;
            this.lstImages.CacheMinutes = this.CacheMinutes;
            this.lstImages.CheckPermissions = this.CheckPermissions;
            this.lstImages.ClassNames = "cms.file";
            this.lstImages.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
            this.lstImages.CultureCode = this.CultureCode;
            this.lstImages.MaxRelativeLevel = this.MaxRelativeLevel;
            this.lstImages.OrderBy = this.OrderBy;
            this.lstImages.SelectOnlyPublished = this.SelectOnlyPublished;
            this.lstImages.SiteName = this.SiteName;
            this.lstImages.WhereCondition = this.WhereCondition;

            // Relationships
            this.lstImages.RelatedNodeIsOnTheLeftSide = this.RelatedNodeIsOnTheLeftSide;
            this.lstImages.RelationshipName = this.RelationshipName;
            this.lstImages.RelationshipWithNodeGuid = this.RelationshipWithNodeGUID;

            // Transformation properties
            this.lstImages.TransformationName = this.ThumbnailTransformation;
            this.lstImages.Path = this.Path;

            // Pager properties
            this.PagerControl.PageSize = this.Columns * this.RowsPerPage;
            this.PagerControl.PagerPosition = this.PagerPosition;
            this.PagerControl.QueryStringKey = this.QueryStringKey;
            this.PagerControl.PagingMode = this.PagingMode;
            this.PagerControl.ShowFirstLast = this.ShowFirstLast;
            this.lstImages.EnablePaging = true;

            // Repeat properties
            this.lstImages.RepeatColumns = this.Columns;
            this.lstImages.RepeatLayout = this.RepeatLayout;
            this.lstImages.RepeatDirection = this.RepeatDirection;

            // Public properties
            this.lstImages.HideControlForZeroRows = this.HideControlForZeroRows;
            this.lstImages.ZeroRowsText = this.ZeroRowsText;

            RelocateButtons();

            if (this.StandAlone)
            {
                this.lstImages.ReloadData(true);
            }
        }
    }


    public override void ReloadData()
    {
        base.ReloadData();
        this.SetupControl();
        this.lstImages.ReloadData(true);
    }


    void pagerElem_OnDataSourceChanged(object sender, EventArgs e)
    {
        if (Request.QueryString["imagepath"] != null)
        {
            string path = Convert.ToString(Request.QueryString["imagepath"]);

            this.PagingMode = PagingModeTypeEnum.QueryString;
            this.PagerControl.PageSize = 1;
            int currentPage = this.PagerControl.GetItemPage("NodeAliasPath = '" + path + "'");
            this.PagerControl.CurrentPage = currentPage;
            this.PagerControl.Visible = false;
            this.lstImages.TransformationName = this.DetailTransformation;

            this.plcNavigation.Visible = true;

            this.lnkNext.Text = ResHelper.GetString("ImageGallery.Next");
            DataRow nextItem = this.PagerControl.GetItemDataRow(currentPage);
            if (nextItem != null)
            {
                this.lnkNext.NavigateUrl = UrlHelper.AddParameterToUrl(Request.RawUrl, "imagepath", (string)nextItem["NodeAliasPath"]);
            }

            this.lnkPrevious.Text = ResHelper.GetString("ImageGallery.Previous");
            DataRow prevItem = this.PagerControl.GetItemDataRow(currentPage - 2);
            if (prevItem != null)
            {
                this.lnkPrevious.NavigateUrl = UrlHelper.AddParameterToUrl(Request.RawUrl, "imagepath", (string)prevItem["NodeAliasPath"]);
            }

            this.lnkThumbnails.Text = ResHelper.GetString("ImageGallery.Thumbnails");
            this.lnkThumbnails.NavigateUrl = UrlHelper.RemoveParameterFromUrl(Request.RawUrl, "imagepath");

            this.ltlScript.Text += ScriptHelper.GetScript("var drpElem = document.getElementById('" + this.drpImages.ClientID + "');");
            // Prepare the images dropdown list
            this.drpImages.Attributes.Add("onchange", "ChangeImage();");
            this.drpImages.Items.Clear();
            int index = 1;
            DataView images = (DataView)this.PagerControl.DataSource;
            foreach (DataRow dr in images.Table.Rows)
            {
                string url = UrlHelper.AddParameterToUrl(Request.RawUrl, "imagepath", (string)dr["NodeAliasPath"]);
                this.drpImages.Items.Add(new ListItem(index.ToString(), url));
                index++;
            }
            this.drpImages.SelectedIndex = currentPage - 1;
            this.lblOf.Text = ResHelper.GetString("ImageGallery.Of");
            this.lblTotal.Text = images.Table.Rows.Count.ToString();
        }

    }


    private void RelocateButtons()
    {
        this.plcButtonsTop.Controls.Remove(this.plcNavigation);
        this.plcButtonsBottom.Controls.Remove(this.plcNavigation);
        this.plcButtonsTop.Controls.Remove(this.plcPager);
        this.plcButtonsBottom.Controls.Remove(this.plcPager);

        if (!this.ShowButtonsOnTop)
        {
            this.plcButtonsBottom.Controls.Add(this.plcNavigation);
            this.plcButtonsBottom.Controls.Add(this.plcPager);
        }
        else
        {
            this.plcButtonsTop.Controls.Add(this.plcNavigation);
            this.plcButtonsTop.Controls.Add(this.plcPager);
        }
    }

}
