using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;

using CMS.SettingsProvider;
using CMS.Controls;


public partial class CMSWebParts_Viewers_cmsdocumentviewer : CMSAbstractWebPart
{
    #region "Document properties"

    ///// <summary>
    ///// Cache item name
    ///// </summary>
    //public string CacheItemName
    //{
    //    get
    //    {
    //        return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CacheItemName"), this.CMSViewer1.CacheItemName), this.CMSViewer1.CacheItemName);
    //    }
    //    set
    //    {
    //        this.SetValue("CacheItemName", value);
    //        this.CMSViewer1.CacheItemName = value;
    //    }
    //}


    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CacheMinutes"), this.CMSViewer1.CacheMinutes);
        }
        set
        {
            this.SetValue("CacheMinutes", value);
            this.CMSViewer1.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.CMSViewer1.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
        }
    }


    /// <summary>
    /// Class names
    /// </summary>
    public string ClassNames
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.CMSViewer1.ClassNames), this.CMSViewer1.ClassNames);
        }
        set
        {
            this.SetValue("ClassNames", value);
            this.CMSViewer1.ClassNames = value;
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.CMSViewer1.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.CMSViewer1.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.CMSViewer1.CultureCode), this.CMSViewer1.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.CMSViewer1.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.CMSViewer1.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.CMSViewer1.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.CMSViewer1.OrderBy), this.CMSViewer1.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.CMSViewer1.OrderBy = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), this.CMSViewer1.Path), this.CMSViewer1.Path);
        }
        set
        {
            this.SetValue("Path", value);
            this.CMSViewer1.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.CMSViewer1.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelctOnlyPublished", value);
            this.CMSViewer1.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.CMSViewer1.SiteName), this.CMSViewer1.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.CMSViewer1.SiteName = value;
        }
    }


    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.CMSViewer1.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.CMSViewer1.WhereCondition = value;
        }
    }

    #endregion


    #region "Relationships properties"

    /// <summary>
    /// Related node is on the left side
    /// </summary>
    public bool RelatedNodeIsOnTheLeftSide
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("RelatedNodeIsOnTheLeftSide"), this.CMSViewer1.RelatedNodeIsOnTheLeftSide);
        }
        set
        {
            this.SetValue("RelatedNodeIsOnTheLeftSide", value);
            this.CMSViewer1.RelatedNodeIsOnTheLeftSide = value;
        }
    }


    /// <summary>
    /// Relationship name
    /// </summary>
    public string RelationshipName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("RelationshipName"), this.CMSViewer1.RelationshipName), this.CMSViewer1.RelationshipName);
        }
        set
        {
            this.SetValue("RelationshipName", value);
            this.CMSViewer1.RelationshipName = value;
        }
    }


    /// <summary>
    /// Relationship with node GUID
    /// </summary>
    public Guid RelationshipWithNodeGUID
    {
        get
        {
            return ValidationHelper.GetGuid(this.GetValue("RelationshipWithNodeGuid"), this.CMSViewer1.RelationshipWithNodeGuid);
        }
        set
        {
            this.SetValue("RelationshipWithNodeGuid", value);
            this.CMSViewer1.RelationshipWithNodeGuid = value;
        }
    }

    #endregion


    #region "Transformation properties"

    /// <summary>
    /// Transformation name
    /// </summary>
    public string TransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("TransformationName"), this.CMSViewer1.TransformationName), this.CMSViewer1.TransformationName);
        }
        set
        {
            this.SetValue("TransformationName", value);
            this.CMSViewer1.TransformationName = value;
        }
    }


    /// <summary>
    /// Transformation name
    /// </summary>
    public string SelectedItemTransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SelectedItemTransformationName"), this.CMSViewer1.SelectedItemTransformationName), this.CMSViewer1.SelectedItemTransformationName);
        }
        set
        {
            this.SetValue("SelectedItemTransformationName", value);
            this.CMSViewer1.SelectedItemTransformationName = value;
        }
    }


    /// <summary>
    /// Transformation name
    /// </summary>
    public string AlternatingTransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("AlternatingTransformationName"), this.CMSRepeater1.AlternatingTransformationName), this.CMSRepeater1.AlternatingTransformationName);
        }
        set
        {
            this.SetValue("AlternatingTransformationName", value);
            this.CMSRepeater1.AlternatingTransformationName = value;
        }
    }

    #endregion


    #region Public properties

    /// <summary>
    /// Hide control for zero rows
    /// </summary>
    public bool HideControlForZeroRows
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("HideControlForZeroRows"), this.CMSViewer1.HideControlForZeroRows);
        }
        set
        {
            this.SetValue("HideControlForZeroRows", value);
            this.CMSViewer1.HideControlForZeroRows = value;
        }
    }


    /// <summary>
    /// Zero rows text
    /// </summary>
    public string ZeroRowsText
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("ZeroRowsText"), this.CMSViewer1.ZeroRowsText), this.CMSViewer1.ZeroRowsText);
        }
        set
        {
            this.SetValue("ZeroRowsText", value);
            this.CMSViewer1.ZeroRowsText = value;
        }
    }

    #endregion


    #region "Pager properties"

    /// <summary>
    /// Enable paging
    /// </summary>
    public bool EnablePaging
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("EnablePaging"), this.CMSRepeater1.EnablePaging);
        }
        set
        {
            this.SetValue("EnablePaging", value);
            this.CMSRepeater1.EnablePaging = value;
        }
    }


    /// <summary>
    /// Pager position
    /// </summary>
    public PagingPlaceTypeEnum PagerPosition
    {
        get
        {
            return this.CMSRepeater1.PagerControl.GetPagerPosition(DataHelper.GetNotEmpty(this.GetValue("PagerPosition"), this.CMSRepeater1.PagerControl.PagerPosition.ToString()));
        }
        set
        {
            this.SetValue("PagerPosition", value.ToString());
            this.CMSRepeater1.PagerControl.PagerPosition = value;
        }
    }


    /// <summary>
    /// Page size
    /// </summary>
    public int PageSize
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.CMSRepeater1.PagerControl.PageSize);
        }
        set
        {
            this.SetValue("PageSize", value);
            this.CMSRepeater1.PagerControl.PageSize = value;
        }
    }


    /// <summary>
    /// Pager query string key
    /// </summary>
    public string QueryStringKey
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("QueryStringKey"), this.CMSRepeater1.PagerControl.QueryStringKey), this.CMSRepeater1.PagerControl.QueryStringKey);
        }
        set
        {
            this.SetValue("QueryStringKey", value);
            this.CMSRepeater1.PagerControl.QueryStringKey = value;
        }
    }


    /// <summary>
    /// Paging mode
    /// </summary>
    public PagingModeTypeEnum PagingMode
    {
        get
        {
            return this.CMSRepeater1.PagerControl.GetPagingMode(DataHelper.GetNotEmpty(this.GetValue("PagingMode"), this.CMSRepeater1.PagerControl.PagingMode.ToString()));
        }
        set
        {
            this.SetValue("PagingMode", value.ToString());
            this.CMSRepeater1.PagerControl.PagingMode = value;
        }
    }


    /// <summary>
    /// Show first / last links
    /// </summary>
    public bool ShowFirstLast
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowFirstLast"), this.CMSRepeater1.PagerControl.ShowFirstLast);
        }
        set
        {
            this.SetValue("ShowFirstLast", value);
            this.CMSRepeater1.PagerControl.ShowFirstLast = value;
        }
    }

    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == CMS.CMSHelper.ViewModeEnum.Design) || this.HideOnCurrentPage || (!this.IsVisible))
        {
            this.CMSViewer1.StopProcessing = true;
            this.CMSRepeater1.StopProcessing = true;
        }
        else
        {

            // Get transformation name
            string mTransformationName = DataHelper.GetNotEmpty(this.GetValue("TransformationName"), "");

            if (mTransformationName != null && mTransformationName != "")
            {
                TransformationInfo mTransformation;

                // Get transformation info
                mTransformation = TransformationInfoProvider.GetTransformation(mTransformationName);
                if (mTransformation == null)
                {
                    if (this.PageManager.ViewMode != CMS.CMSHelper.ViewModeEnum.Design)
                    {
                        throw new Exception("[WebPart.CMSDocumentViever]: Transformation " + mTransformationName + " not found!");
                    }
                }

                // Get type of transformation
                if (mTransformation.TransformationType == TransformationTypeEnum.Ascx)
                {
                    this.UseASCX();
                }
                else
                {
                    this.UseXSLT();
                }

            }
        }
    }


    /// <summary>
    /// Use CMSViewer for XSLT transformation
    /// </summary>
    protected void UseXSLT()
    {
        // Set properties from Webpart form   
        this.CMSViewer1.CacheItemName = this.CacheItemName;
        this.CMSViewer1.CacheMinutes = this.CacheMinutes;
        this.CMSViewer1.CheckPermissions = this.CheckPermissions;
        this.CMSViewer1.ClassNames = this.ClassNames;
        this.CMSViewer1.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
        this.CMSViewer1.CultureCode = this.CultureCode;
        this.CMSViewer1.MaxRelativeLevel = this.MaxRelativeLevel;
        this.CMSViewer1.OrderBy = this.OrderBy;
        this.CMSViewer1.WhereCondition = this.WhereCondition;
        this.CMSViewer1.SelectOnlyPublished = this.SelectOnlyPublished;
        this.CMSViewer1.SiteName = this.SiteName;
        this.CMSViewer1.Path = this.Path;

        this.CMSViewer1.RelatedNodeIsOnTheLeftSide = this.RelatedNodeIsOnTheLeftSide;
        this.CMSViewer1.RelationshipName = this.RelationshipName;
        this.CMSViewer1.RelationshipWithNodeGuid = this.RelationshipWithNodeGUID;

        this.CMSViewer1.TransformationName = this.TransformationName;
        this.CMSViewer1.SelectedItemTransformationName = this.SelectedItemTransformationName;
        //        this.CMSViewer1.VersionHistoryID = ValidationHelper.GetInteger(this.GetValue("VersionHistoryID"), this.CMSViewer1.VersionHistoryID);

        this.CMSViewer1.HideControlForZeroRows = this.HideControlForZeroRows;
        this.CMSViewer1.ZeroRowsText = this.ZeroRowsText;
        //this.CMSViewer1.ViewMode = this.CMSViewer1.GetViewMode(DataHelper.GetNotEmpty(this.GetValue("ViewMode"), this.CMSViewer1.ViewMode.ToString()));
    }


    /// <summary>
    /// Use CMSRepeater for ASCX transformation
    /// </summary>
    protected void UseASCX()
    {
        // Set properties from Webpart form   
        this.CMSRepeater1.CacheItemName = this.CacheItemName;
        this.CMSRepeater1.CacheMinutes = this.CacheMinutes;
        this.CMSRepeater1.CheckPermissions = this.CheckPermissions;
        this.CMSRepeater1.ClassNames = this.ClassNames;
        this.CMSRepeater1.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
        this.CMSRepeater1.CultureCode = this.CultureCode;
        this.CMSRepeater1.MaxRelativeLevel = this.MaxRelativeLevel;
        this.CMSRepeater1.OrderBy = this.OrderBy;
        this.CMSRepeater1.WhereCondition = this.WhereCondition;
        this.CMSRepeater1.SelectOnlyPublished = this.SelectOnlyPublished;
        this.CMSRepeater1.SiteName = this.SiteName;
        this.CMSRepeater1.Path = this.Path;

        this.CMSRepeater1.RelatedNodeIsOnTheLeftSide = this.RelatedNodeIsOnTheLeftSide;
        this.CMSRepeater1.RelationshipName = this.RelationshipName;
        this.CMSRepeater1.RelationshipWithNodeGuid = this.RelationshipWithNodeGUID;

        this.CMSRepeater1.TransformationName = this.TransformationName;
        this.CMSRepeater1.SelectedItemTransformationName = this.SelectedItemTransformationName;
        this.CMSRepeater1.AlternatingTransformationName = this.AlternatingTransformationName;

        this.CMSRepeater1.PagerControl.PagerPosition = this.PagerPosition;
        this.CMSRepeater1.EnablePaging = this.EnablePaging;
        this.CMSRepeater1.PagerControl.PageSize = this.PageSize;
        this.CMSRepeater1.PagerControl.PagingMode = this.PagingMode;
        this.CMSRepeater1.PagerControl.QueryStringKey = this.QueryStringKey;
        this.CMSRepeater1.PagerControl.ShowFirstLast = this.ShowFirstLast;

        this.CMSRepeater1.HideControlForZeroRows = this.HideControlForZeroRows;
        this.CMSRepeater1.ZeroRowsText = this.ZeroRowsText;
    }
}
