using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.Controls;
using CMS.CMSHelper;

public partial class CMSWebParts_cmsrepeater : CMSAbstractWebPart
{
    #region "Document properties"

    /// <summary>
    /// Cache item name
    /// </summary>
    public override string CacheItemName
    {
        get
        {
            return base.CacheItemName;
        }
        set
        {
            base.CacheItemName = value;
            this.repItems.CacheItemName = value;
        }
    }


    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return base.CacheMinutes;
        }
        set
        {
            base.CacheMinutes = value;
            this.repItems.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Check permissions
    /// </summary>
    public bool CheckPermissions
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CheckPermissions"), this.repItems.CheckPermissions);
        }
        set
        {
            this.SetValue("CheckPermissions", value);
        }
    }


    /// <summary>
    /// Class names
    /// </summary>
    public string ClassNames
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.repItems.ClassNames), this.repItems.ClassNames);
        }
        set
        {
            this.SetValue("ClassNames", value);
            this.repItems.ClassNames = value;
        }
    }


    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.repItems.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.repItems.CombineWithDefaultCulture = value;
        }
    }


    /// <summary>
    /// Filter out duplicate documents
    /// </summary>
    public bool FilterOutDuplicates
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("FilterOutDuplicates"), this.repItems.FilterOutDuplicates);
        }
        set
        {
            this.SetValue("FilterOutDuplicates", value);
            this.repItems.FilterOutDuplicates = value;
        }
    }


    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.repItems.CultureCode), this.repItems.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.repItems.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.repItems.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.repItems.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.repItems.OrderBy), this.repItems.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.repItems.OrderBy = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), null), null);
        }
        set
        {
            this.SetValue("Path", value);
            this.repItems.Path = value;
        }
    }


    /// <summary>
    /// Select only published nodes
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.repItems.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelectOnlyPublished", value);
            this.repItems.SelectOnlyPublished = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.repItems.SiteName), this.repItems.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.repItems.SiteName = value;
        }
    }

    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.repItems.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.repItems.WhereCondition = value;
        }
    }


    /// <summary>
    /// Select top N items
    /// </summary>
    public int SelectTopN
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("SelectTopN"), this.repItems.SelectTopN);
        }
        set
        {
            this.SetValue("SelectTopN", value);
            this.repItems.SelectTopN = value;
        }
    }

    #endregion


    #region "Pager properties"

    /// <summary>
    /// Enable paging
    /// </summary>
    public bool EnablePaging
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("EnablePaging"), this.repItems.EnablePaging);
        }
        set
        {
            this.SetValue("EnablePaging", value);
            this.repItems.EnablePaging = value;
        }
    }


    /// <summary>
    /// Pager position
    /// </summary>
    public PagingPlaceTypeEnum PagerPosition
    {
        get
        {
            return this.repItems.PagerControl.GetPagerPosition(DataHelper.GetNotEmpty(this.GetValue("PagerPosition"), this.repItems.PagerControl.PagerPosition.ToString()));
        }
        set
        {
            this.SetValue("PagerPosition", value.ToString());
            this.repItems.PagerControl.PagerPosition = value;
        }
    }


    /// <summary>
    /// Page size
    /// </summary>
    public int PageSize
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.repItems.PagerControl.PageSize);
        }
        set
        {
            this.SetValue("PageSize", value);
            this.repItems.PagerControl.PageSize = value;
        }
    }


    /// <summary>
    /// Pager query string key
    /// </summary>
    public string QueryStringKey
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("QueryStringKey"), this.repItems.PagerControl.QueryStringKey), this.repItems.PagerControl.QueryStringKey);
        }
        set
        {
            this.SetValue("QueryStringKey", value);
            this.repItems.PagerControl.QueryStringKey = value;
        }
    }


    /// <summary>
    /// Paging mode
    /// </summary>
    public PagingModeTypeEnum PagingMode
    {
        get
        {
            return this.repItems.PagerControl.GetPagingMode(DataHelper.GetNotEmpty(this.GetValue("PagingMode"), this.repItems.PagerControl.PagingMode.ToString()));
        }
        set
        {
            this.SetValue("PagingMode", value.ToString());
            this.repItems.PagerControl.PagingMode = value;
        }
    }


    /// <summary>
    /// Show first / last links
    /// </summary>
    public bool ShowFirstLast
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowFirstLast"), this.repItems.PagerControl.ShowFirstLast);
        }
        set
        {
            this.SetValue("ShowFirstLast", value);
            this.repItems.PagerControl.ShowFirstLast = value;
        }
    }

    #endregion


    #region "Relationships properties"

    /// <summary>
    /// Related node is on the left side
    /// </summary>
    public bool RelatedNodeIsOnTheLeftSide
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("RelatedNodeIsOnTheLeftSide"), this.repItems.RelatedNodeIsOnTheLeftSide);
        }
        set
        {
            this.SetValue("RelatedNodeIsOnTheLeftSide", value);
            this.repItems.RelatedNodeIsOnTheLeftSide = value;
        }
    }


    /// <summary>
    /// Relationship name
    /// </summary>
    public string RelationshipName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("RelationshipName"), this.repItems.RelationshipName), this.repItems.RelationshipName);
        }
        set
        {
            this.SetValue("RelationshipName", value);
            this.repItems.RelationshipName = value;
        }
    }


    /// <summary>
    /// Relationship with node GUID
    /// </summary>
    public Guid RelationshipWithNodeGUID
    {
        get
        {
            return ValidationHelper.GetGuid(this.GetValue("RelationshipWithNodeGuid"), this.repItems.RelationshipWithNodeGuid);
        }
        set
        {
            this.SetValue("RelationshipWithNodeGuid", value);
            this.repItems.RelationshipWithNodeGuid = value;
        }
    }

    #endregion


    #region "Transformation properties"

    /// <summary>
    /// Transformation name
    /// </summary>
    public string TransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("TransformationName"), this.repItems.TransformationName), this.repItems.TransformationName);
        }
        set
        {
            this.SetValue("TransformationName", value);
            this.repItems.TransformationName = value;
        }
    }


    /// <summary>
    /// Transformation name
    /// </summary>
    public string SelectedItemTransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SelectedItemTransformationName"), this.repItems.SelectedItemTransformationName), this.repItems.SelectedItemTransformationName);
        }
        set
        {
            this.SetValue("SelectedItemTransformationName", value);
            this.repItems.SelectedItemTransformationName = value;
        }
    }


    /// <summary>
    /// Transformation name
    /// </summary>
    public string AlternatingTransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("AlternatingTransformationName"), this.repItems.AlternatingTransformationName), this.repItems.AlternatingTransformationName);
        }
        set
        {
            this.SetValue("AlternatingTransformationName", value);
            this.repItems.AlternatingTransformationName = value;
        }
    }

    #endregion


    #region "Public properties"

    /// <summary>
    /// Nested repeater ID
    /// </summary>
    public string NestedRepeaterID
    {
        get { return ValidationHelper.GetString(this.GetValue("NestedRepeaterID"), repItems.NestedRepeaterID); }
        set
        {
            this.SetValue("NestedRepeaterID", value);
            this.repItems.NestedRepeaterID = value;
        }
    }

    /// <summary>
    /// Nested datalist ID
    /// </summary>
    public string NestedDataListID
    {
        get { return ValidationHelper.GetString(this.GetValue("NestedDataListID"), repItems.NestedDataListID); }
        set
        {
            this.SetValue("NestedDataListID", value);
            this.repItems.NestedDataListID = value;
        }
    }

    /// <summary>
    /// Hide control for zero rows
    /// </summary>
    public bool HideControlForZeroRows
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("HideControlForZeroRows"), this.repItems.HideControlForZeroRows);
        }
        set
        {
            this.SetValue("HideControlForZeroRows", value);
            this.repItems.HideControlForZeroRows = value;
        }
    }


    /// <summary>
    /// Zero rows text
    /// </summary>
    public string ZeroRowsText
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("ZeroRowsText"), this.repItems.ZeroRowsText), this.repItems.ZeroRowsText);
        }
        set
        {
            this.SetValue("ZeroRowsText", value);
            this.repItems.ZeroRowsText = value;
        }
    }


    /// <summary>
    /// Item separator
    /// </summary>
    public string ItemSeparator
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("ItemSeparator"), this.repItems.ItemSeparator);
        }
        set
        {
            this.SetValue("ItemSeparator", value);
            this.repItems.ItemSeparator = value;
        }
    }

    #endregion


    #region "Editing mode buttons properties"

    /// <summary>
    /// Show new button
    /// </summary>
    public bool ShowNewButton
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowNewButton"), this.btnAdd.Visible);
        }
        set
        {
            this.SetValue("ShowNewButton", value);
            this.btnAdd.Visible = value;
        }
    }


    /// <summary>
    /// New button text
    /// </summary>
    public string NewButtonText
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("NewButtonText"), this.btnAdd.Text);
        }
        set
        {
            this.SetValue("NewButtonText", value);
            this.btnAdd.Text = value;
        }
    }


    /// <summary>
    /// Show edit / delete buttons
    /// </summary>
    public bool ShowEditDeleteButtons
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowEditDeleteButtons"), this.repItems.ShowEditDeleteButtons);
        }
        set
        {
            this.SetValue("ShowEditDeleteButtons", value);
            this.repItems.ShowEditDeleteButtons = value;
        }
    }

    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.repItems.StopProcessing = true;
        }
        else
        {
            // Document properties
            this.repItems.CacheItemName = this.CacheItemName;
            this.repItems.CacheMinutes = this.CacheMinutes;
            this.repItems.CheckPermissions = this.CheckPermissions;
            this.repItems.ClassNames = this.ClassNames;
            this.repItems.CombineWithDefaultCulture = this.CombineWithDefaultCulture;
            this.repItems.CultureCode = this.CultureCode;
            this.repItems.MaxRelativeLevel = this.MaxRelativeLevel;
            this.repItems.OrderBy = this.OrderBy;
            this.repItems.SelectTopN = this.SelectTopN;
            this.repItems.SelectOnlyPublished = this.SelectOnlyPublished;
            this.repItems.FilterOutDuplicates = this.FilterOutDuplicates;
            
            this.repItems.Path = this.Path;
            
            this.repItems.SiteName = this.SiteName;
            this.repItems.WhereCondition = this.WhereCondition;

            // Pager
            this.repItems.EnablePaging = this.EnablePaging;
            this.repItems.PagerControl.PagerPosition = this.PagerPosition;
            this.repItems.PagerControl.PageSize = this.PageSize;
            this.repItems.PagerControl.QueryStringKey = this.QueryStringKey;
            this.repItems.PagerControl.PagingMode = this.PagingMode;
            this.repItems.PagerControl.ShowFirstLast = this.ShowFirstLast;

            // Relationships
            this.repItems.RelatedNodeIsOnTheLeftSide = this.RelatedNodeIsOnTheLeftSide;
            this.repItems.RelationshipName = this.RelationshipName;
            this.repItems.RelationshipWithNodeGuid = this.RelationshipWithNodeGUID;

            // Transformation properties
            this.repItems.TransformationName = this.TransformationName;
            this.repItems.SelectedItemTransformationName = this.SelectedItemTransformationName;
            this.repItems.AlternatingTransformationName = this.AlternatingTransformationName;

            // Public properties
            this.repItems.HideControlForZeroRows = this.HideControlForZeroRows;
            this.repItems.ZeroRowsText = this.ZeroRowsText;
            this.repItems.ItemSeparator = this.ItemSeparator;

            this.repItems.NestedRepeaterID = this.NestedRepeaterID;
            this.repItems.NestedDataListID = this.NestedDataListID;
            
            // Edit mode buttons
            if ((this.PageManager.ViewMode == ViewModeEnum.LiveSite) || (this.PageManager.ViewMode == ViewModeEnum.LiveSiteNotAuthorized))
            {
                this.btnAdd.Visible = false;
                this.repItems.ShowEditDeleteButtons = false;
            }
            else
            {
                this.btnAdd.Visible = this.ShowNewButton;
                this.btnAdd.Text = this.NewButtonText;
                this.repItems.ShowEditDeleteButtons = this.ShowEditDeleteButtons;
            }


            string[] mClassNames = this.repItems.ClassNames.Split(';');
            this.btnAdd.ClassName = DataHelper.GetNotEmpty(mClassNames[0], "");

            string mPath = "";
            if (this.repItems.Path.EndsWith("/%"))
            {
                mPath = this.repItems.Path.Remove(this.repItems.Path.Length - 2);
            }
            if (this.repItems.Path.EndsWith("/"))
            {
                mPath = this.repItems.Path.Remove(this.repItems.Path.Length - 1);
            }

            this.btnAdd.Path = DataHelper.GetNotEmpty(mPath, "");
        }

    }


    public override void ReloadData()
    {
        base.ReloadData();
        this.SetupControl();
        this.repItems.ReloadData(true);
    }

}

