using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Xml;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.DataEngine;
using CMS.Controls;

public partial class CMSWebParts_Viewers : CMSAbstractWebPart
{
    #region "Document properties"

    ///// <summary>
    ///// Cache item name
    ///// </summary>
    //public string CacheItemName
    //{
    //    get
    //    {
    //        return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CacheItemName"), this.QueryDataGrid1.CacheItemName), this.QueryDataGrid1.CacheItemName);
    //    }
    //    set
    //    {
    //        this.SetValue("CacheItemName", value);
    //        this.QueryDataGrid1.CacheItemName = value;
    //    }
    //}


    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CacheMinutes"), this.QueryDataGrid1.CacheMinutes);
        }
        set
        {
            this.SetValue("CacheMinutes", value);
            this.QueryDataGrid1.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.QueryDataGrid1.OrderBy), this.QueryDataGrid1.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.QueryDataGrid1.OrderBy = value;
        }
    }


    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.QueryDataGrid1.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.QueryDataGrid1.WhereCondition = value;
        }
    }

    #endregion


    #region Public properties

    /// <summary>
    /// Hide control for zero rows
    /// </summary>
    public bool HideControlForZeroRows
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("HideControlForZeroRows"), this.QueryDataGrid1.HideControlForZeroRows);
        }
        set
        {
            this.SetValue("HideControlForZeroRows", value);
            this.QueryDataGrid1.HideControlForZeroRows = value;
        }
    }


    /// <summary>
    /// Zero rows text
    /// </summary>
    public string ZeroRowsText
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("ZeroRowsText"), this.QueryDataGrid1.ZeroRowsText), this.QueryDataGrid1.ZeroRowsText);
        }
        set
        {
            this.SetValue("ZeroRowsText", value);
            this.QueryDataGrid1.ZeroRowsText = value;
        }
    }


    /// <summary>
    /// Select top N
    /// </summary>
    public int SelectTopN
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("SelectTopN"), this.QueryDataGrid1.SelectTopN);
        }
        set
        {
            this.SetValue("SelectTopN", value);
            this.QueryDataGrid1.SelectTopN = value;
        }
    }


    /// <summary>
    /// True if the sorting is ascending
    /// </summary>
    public bool SortAscending
    {
        get { return (ValidationHelper.GetBoolean(this.GetValue("SortAscending"), this.QueryDataGrid1.SortAscending)); }
        set
        {
            this.SetValue("SortAscending", value);
            this.QueryDataGrid1.SortAscending = value;
        }
    }


    /// <summary>
    /// True if the sorting is allowed
    /// </summary>
    public bool AllowSorting
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("AllowSorting"), this.QueryDataGrid1.AllowSorting); }
        set
        {
            this.SetValue("AllowSorting", value);
            this.QueryDataGrid1.AllowSorting = value;
        }
    }


    /// <summary>
    /// True if the sorting process is in the code
    /// </summary>
    public bool ProcessSorting
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("ProcessSorting"), this.QueryDataGrid1.ProcessSorting); }
        set
        {
            this.SetValue("ProcessSorting", value);
            this.QueryDataGrid1.ProcessSorting = value;
        }
    }


    /// <summary>
    /// Sort field
    /// </summary>
    public string SortField
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SortField"), this.QueryDataGrid1.SortField), this.QueryDataGrid1.SortField); }
        set
        {
            this.SetValue("SortField", value);
            this.QueryDataGrid1.SortField = value;
        }
    }


    /// <summary>
    /// True if the paging should be allowed
    /// </summary>
    public bool AllowPaging
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("AllowPaging"), this.QueryDataGrid1.AllowPaging); }
        set
        {
            this.SetValue("AllowPaging", value);
            this.QueryDataGrid1.AllowPaging = value;
        }
    }


    /// <summary>
    /// Allow custom paging
    /// </summary>
    public bool AllowCustomPaging
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("AllowCustomPaging"), this.QueryDataGrid1.AllowCustomPaging); }
        set
        {
            this.SetValue("AllowCustomPaging", value);
            this.QueryDataGrid1.AllowCustomPaging = value;
        }
    }


    /// <summary>
    /// Size of the page if the paging is allowed
    /// </summary>
    public int PageSize
    {
        get { return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.QueryDataGrid1.PageSize); }
        set
        {
            this.SetValue("PageSize", value);
            this.QueryDataGrid1.PageSize = value;
        }
    }


    /// <summary>
    /// If true, the databind is automatic
    /// </summary>
    public bool DataBindByDefault
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("DataBindByDefault"), this.QueryDataGrid1.DataBindByDefault); }
        set
        {
            this.SetValue("DataBindByDefault", value);
            this.QueryDataGrid1.DataBindByDefault = value;
        }
    }


    /// <summary>
    /// Pager mode
    /// </summary>
    public PagerMode PagingMode
    {
        get { return this.QueryDataGrid1.GetPagerMode(ValidationHelper.GetString(this.GetValue("Mode"), "")); }
        set
        {
            this.SetValue("Mode", value);
        }
    }


    /// <summary>
    /// True if the header should be shown
    /// </summary>
    public bool ShowHeader
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("ShowHeader"), this.QueryDataGrid1.ShowHeader); }
        set
        {
            this.SetValue("ShowHeader", value);
            this.QueryDataGrid1.ShowHeader = value;
        }
    }


    /// <summary>
    /// True if the footer should be shown
    /// </summary>
    public bool ShowFooter
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("ShowFooter"), this.QueryDataGrid1.ShowFooter); }
        set
        {
            this.SetValue("ShowFooter", value);
            this.QueryDataGrid1.ShowFooter = value;
        }
    }


    /// <summary>
    /// Tool tip
    /// </summary>
    public string ToolTip
    {
        get { return DataHelper.GetNotEmpty(this.GetValue("ToolTip"), this.QueryDataGrid1.ToolTip); }
        set
        {
            this.SetValue("ToolTip", value);
            this.QueryDataGrid1.ToolTip = value;
        }
    }


    /// <summary>
    /// If true, the columns are generated automatically
    /// </summary>
    public bool AutoGenerateColumns
    {
        get { return ValidationHelper.GetBoolean(this.GetValue("AutoGenerateColumns"), this.QueryDataGrid1.AutoGenerateColumns); }
        set
        {
            this.SetValue("AutoGenerateColumns", value);
            this.QueryDataGrid1.AutoGenerateColumns = value;
        }
    }


    /// <summary>
    /// If true, the columns are generated automatically
    /// </summary>
    public string QueryName
    {
        get { return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("QueryName"), this.QueryDataGrid1.QueryName), this.QueryDataGrid1.QueryName); }
        set
        {
            this.SetValue("QueryName", value);
            this.QueryDataGrid1.QueryName = value;
        }
    }


    /// <summary>
    /// Columns selector
    /// </summary>
    public string ColumnsSelector
    {
        get { return DataHelper.GetNotEmpty(this.GetValue("ColumnSelector"), ""); }
        set
        {
            this.SetValue("ColumnSelector", value);
        }
    }

    #endregion


    protected string[] mColumnList;
    protected string[] mGlobalNameID = null;
    protected string[] mDataType = null;

    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.QueryDataGrid1.StopProcessing = true;
        }
        else
        {
            this.QueryDataGrid1.CacheItemName = this.CacheItemName;
            this.QueryDataGrid1.CacheMinutes = this.CacheMinutes;
            this.QueryDataGrid1.OrderBy = this.OrderBy;
            this.QueryDataGrid1.WhereCondition = this.WhereCondition;

            this.QueryDataGrid1.SelectTopN = this.SelectTopN;
            this.QueryDataGrid1.HideControlForZeroRows = this.HideControlForZeroRows;
            this.QueryDataGrid1.ZeroRowsText = this.ZeroRowsText;

            this.QueryDataGrid1.EnableViewState = true;
            this.QueryDataGrid1.SkinID = this.SkinID;

            this.QueryDataGrid1.AllowSorting = this.AllowSorting;
            this.QueryDataGrid1.ProcessSorting = this.ProcessSorting;
            this.QueryDataGrid1.SortAscending = this.SortAscending;
            this.QueryDataGrid1.SortField = this.SortField;

            this.QueryDataGrid1.AllowPaging = this.AllowPaging;
            this.QueryDataGrid1.PageSize = this.PageSize;
            this.QueryDataGrid1.AllowCustomPaging = this.AllowCustomPaging;
            this.QueryDataGrid1.PagerStyle.Mode = this.PagingMode;
            this.QueryDataGrid1.ShowHeader = this.ShowHeader;
            this.QueryDataGrid1.ShowFooter = this.ShowFooter;

            this.QueryDataGrid1.ToolTip = this.ToolTip;

            this.QueryDataGrid1.DataBindByDefault = this.DataBindByDefault;

            this.QueryDataGrid1.AutoGenerateColumns = this.AutoGenerateColumns;
            this.QueryDataGrid1.QueryName = this.QueryName;

            string mXML = this.ColumnsSelector;

            this.QueryDataGrid1.DataBindByDefault = false;

            if (this.PageManager.ViewMode != CMS.CMSHelper.ViewModeEnum.Design)
            {
                LoadFromQuery(this.QueryDataGrid1.QueryName);

                if (ColumnSelector(mXML))
                {
                    this.QueryDataGrid1.AutoGenerateColumns = false;
                }
                this.QueryDataGrid1.DataBind();
            }
        }
    }


    public override void ReloadData()
    {
        base.ReloadData();
        this.SetupControl();
        this.QueryDataGrid1.ReloadData(true);
    }


    /// <summary>
    /// Check if column is valid for classnames
    /// </summary>
    /// <param name="mColumn">Name of column</param>
    /// <returns>Return true if column is on table</returns>
    protected bool IsInTable(string mColumn)
    {
        if ((mColumn == null) || (mColumn == ""))
        {
            return false;
        }

        for (int i = mColumnList.GetLowerBound(0); i <= mColumnList.GetUpperBound(0); i++)
        {
            if (mColumnList[i] == mColumn)
            {
                return true;
            }
        }

        return false;
    }


    /// <summary>
    /// Load Columns names with Query
    /// </summary>
    protected void LoadFromQuery(string mQueryName)
    {
        if (DataHelper.GetNotEmpty(mQueryName, "") != "")
        {
            // Load the data
            this.QueryDataGrid1.ReloadData(false);
            DataView dv = DataHelper.GetDataView(this.QueryDataGrid1.DataSource);

            string[] mCl = new string[dv.Table.Columns.Count];
            string[] mDt = new string[dv.Table.Columns.Count];

            int i = 0;
            foreach (DataColumn dc in dv.Table.Columns)
            {
                mCl[i] = dc.ColumnName;
                mDt[i] = dc.DataType.ToString();
                i++;
            }
            this.mDataType = mDt;
            this.mColumnList = mCl;

        }
    }


    /// <summary>
    /// Get information from XML and add it to columns
    /// </summary>
    /// <param name="mXML">Input XML string</param>
    /// <returns>Return false if params is null or empty or when Xml haven't any node</returns>
    protected bool ColumnSelector(string mXML)
    {
        if (mXML == null || mXML == "")
        {
            return false;
        }

        if ((mColumnList == null) || (mColumnList.Length == 0))
        {
            return false;
        }

        XmlDocument mXMLDocument = new XmlDocument();

        mXMLDocument.LoadXml(mXML);

        XmlNodeList NodeList = mXMLDocument.DocumentElement.GetElementsByTagName("column");

        if (NodeList.Count == 0)
        {
            return false;
        }

        string mName = null;
        string mHeader = null;
        string mType = null;

        this.QueryDataGrid1.ItemDataBound += new DataGridItemEventHandler(QueryDataGrid1_ItemDataBound);

        this.QueryDataGrid1.Columns.Clear();

        foreach (XmlNode node in NodeList)
        {
            mName = XmlHelper.GetXmlAttributeValue(node.Attributes["name"], "");
            mHeader = XmlHelper.GetXmlAttributeValue(node.Attributes["header"], "");
            mType = XmlHelper.GetXmlAttributeValue(node.Attributes["type"], "");

            if (DataHelper.GetNotEmpty(mName, "") != "")
            {
                if (IsInTable(mName))
                {

                    if (mType != null && mType == "link")
                    {
                        if (mGlobalNameID == null)
                            mGlobalNameID = new string[0];

                        string[] mHelpGlobal = new string[mGlobalNameID.Length + 1];

                        mHelpGlobal[mGlobalNameID.Length] = mName;

                        for (int i = 0; i < mGlobalNameID.Length; i++)
                        {
                            mHelpGlobal[i] = mGlobalNameID[i];
                        }

                        mGlobalNameID = mHelpGlobal;


                        TemplateColumn col = new TemplateColumn();
                        col.ItemTemplate = new DynamicItem(mName);

                        if (DataHelper.GetNotEmpty(mHeader, "") != "")
                            col.HeaderText = mHeader;
                        else
                            col.HeaderText = mName;

                        if (this.QueryDataGrid1.AllowSorting)
                            col.SortExpression = mName;

                        this.QueryDataGrid1.Columns.Add(col);
                    }
                    else
                    {
                        BoundColumn col = new BoundColumn();

                        col.DataField = mName;

                        if (DataHelper.GetNotEmpty(mHeader, "") != "")
                            col.HeaderText = mHeader;
                        else
                            col.HeaderText = mName;

                        if (this.QueryDataGrid1.AllowSorting)
                            col.SortExpression = mName;



                        this.QueryDataGrid1.Columns.Add(col);
                    }
                }
            }
        }

        return true;
    }


    /// <summary>
    /// Item data bound handler
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    void QueryDataGrid1_ItemDataBound(object sender, DataGridItemEventArgs e)
    {
        if (mGlobalNameID != null)
        {
            for (int i = mGlobalNameID.GetLowerBound(0); i <= mGlobalNameID.GetUpperBound(0); i++)
            {
                if (mGlobalNameID[i] != null && mGlobalNameID[i] != "")
                {
                    Control ctrl = e.Item.FindControl(mGlobalNameID[i]);
                    if (ctrl != null)
                    {
                        ((HyperLink)ctrl).Text = ((DataRowView)e.Item.DataItem)[mGlobalNameID[i]].ToString();
                        ((HyperLink)ctrl).NavigateUrl = CMSContext.GetUrl(((DataRowView)e.Item.DataItem)["NodeAliasPath"].ToString(), ((DataRowView)e.Item.DataItem)["DocumentUrlPath"].ToString());
                    }
                }
            }
        }
    }

}


