using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls; 
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.CMSHelper;
using CMS.Controls;

public partial class CMSWebParts_Viewers_querydatalist : CMSAbstractWebPart
{
    #region "Document properties"

    /// <summary>
    /// Cache minutes
    /// </summary>
    public override int CacheMinutes
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("CacheMinutes"), this.QueryDataList1.CacheMinutes);
        }
        set
        {
            this.SetValue("CacheMinutes", value);
            this.QueryDataList1.CacheMinutes = value;
        }
    }


    /// <summary>
    /// Order by clause
    /// </summary>
    public string OrderBy
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("OrderBy"), this.QueryDataList1.OrderBy), this.QueryDataList1.OrderBy);
        }
        set
        {
            this.SetValue("OrderBy", value);
            this.QueryDataList1.OrderBy = value;
        }
    }


    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.QueryDataList1.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.QueryDataList1.WhereCondition = value;
        }
    }


    /// <summary>
    /// Select top N items
    /// </summary>
    public int SelectTopN
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("SelectTopN"), this.QueryDataList1.SelectTopN);
        }
        set
        {
            this.SetValue("SelectTopN", value);
            this.QueryDataList1.SelectTopN = value;
        }
    }

    #endregion


    #region "Pager properties"

    /// <summary>
    /// Enable paging
    /// </summary>
    public bool EnablePaging
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("EnablePaging"), this.QueryDataList1.EnablePaging);
        }
        set
        {
            this.SetValue("EnablePaging", value);
            this.QueryDataList1.EnablePaging = value;
        }
    }


    /// <summary>
    /// Pager position
    /// </summary>
    public PagingPlaceTypeEnum PagerPosition
    {
        get
        {
            return this.QueryDataList1.PagerControl.GetPagerPosition(DataHelper.GetNotEmpty(this.GetValue("PagerPosition"), this.QueryDataList1.PagerControl.PagerPosition.ToString()));
        }
        set
        {
            this.SetValue("PagerPosition", value.ToString());
            this.QueryDataList1.PagerControl.PagerPosition = value;
        }
    }


    /// <summary>
    /// Page size
    /// </summary>
    public int PageSize
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("PageSize"), this.QueryDataList1.PagerControl.PageSize);
        }
        set
        {
            this.SetValue("PageSize", value);
            this.QueryDataList1.PagerControl.PageSize = value;
        }
    }


    /// <summary>
    /// Pager query string key
    /// </summary>
    public string QueryStringKey
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("QueryStringKey"), this.QueryDataList1.PagerControl.QueryStringKey), this.QueryDataList1.PagerControl.QueryStringKey);
        }
        set
        {
            this.SetValue("QueryStringKey", value);
            this.QueryDataList1.PagerControl.QueryStringKey = value;
        }
    }


    /// <summary>
    /// Paging mode
    /// </summary>
    public PagingModeTypeEnum PagingMode
    {
        get
        {
            return this.QueryDataList1.PagerControl.GetPagingMode(DataHelper.GetNotEmpty(this.GetValue("PagingMode"), this.QueryDataList1.PagerControl.PagingMode.ToString()));
        }
        set
        {
            this.SetValue("PagingMode", value.ToString());
            this.QueryDataList1.PagerControl.PagingMode = value;
        }
    }


    /// <summary>
    /// Show first / last links
    /// </summary>
    public bool ShowFirstLast
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowFirstLast"), this.QueryDataList1.PagerControl.ShowFirstLast);
        }
        set
        {
            this.SetValue("ShowFirstLast", value);
            this.QueryDataList1.PagerControl.ShowFirstLast = value;
        }
    }

    #endregion


    #region "Public properties"

    /// <summary>
    /// Hide control for zero rows
    /// </summary>
    public bool HideControlForZeroRows
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("HideControlForZeroRows"), this.QueryDataList1.HideControlForZeroRows);
        }
        set
        {
            this.SetValue("HideControlForZeroRows", value);
            this.QueryDataList1.HideControlForZeroRows = value;
        }
    }


    /// <summary>
    /// Zero rows text
    /// </summary>
    public string ZeroRowsText
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("ZeroRowsText"), this.QueryDataList1.ZeroRowsText), this.QueryDataList1.ZeroRowsText);
        }
        set
        {
            this.SetValue("ZeroRowsText", value);
            this.QueryDataList1.ZeroRowsText = value;
        }
    }


    /// <summary>
    /// Repeat columns
    /// </summary>
    public int RepeatColumns
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("RepeatColumns"), this.QueryDataList1.RepeatColumns);
        }
        set
        {
            this.SetValue("RepeatColumns", value);
            this.QueryDataList1.RepeatColumns = value;
        }
    }


    /// <summary>
    /// Repeat layout
    /// </summary>
    public RepeatLayout RepeatLayout
    {
        get
        {
            return CMSDataList.GetRepeatLayout(DataHelper.GetNotEmpty(this.GetValue("RepeatLayout"), this.QueryDataList1.RepeatLayout.ToString()));
        }
        set
        {
            this.SetValue("RepeatLayout", value.ToString());
            this.QueryDataList1.RepeatLayout = value;
        }
    }


    /// <summary>
    /// Repeat Direction
    /// </summary>
    public RepeatDirection RepeatDirection
    {
        get
        {
            return CMSDataList.GetRepeatDirection(DataHelper.GetNotEmpty(this.GetValue("RepeatDirection"), this.QueryDataList1.RepeatDirection.ToString()));
        }
        set
        {
            this.SetValue("RepeatDirection", value.ToString());
            this.QueryDataList1.RepeatDirection = value;
        }
    }


    #endregion


    #region "Data binding properties"

    /// <summary>
    /// Databind by default
    /// </summary>
    public bool DataBindByDefault
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("DataBindByDefault"), this.QueryDataList1.DataBindByDefault);
        }
        set
        {
            this.SetValue("DataBindByDefault", value);
            this.QueryDataList1.DataBindByDefault = value;
        }
    }


    /// <summary>
    /// BuildFormat by default
    /// </summary>
    public bool BuildFormatByDefault
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("BuildFormatByDefault"), this.QueryDataList1.BuildFormatByDefault);
        }
        set
        {
            this.SetValue("BuildFormatByDefault", value);
            this.QueryDataList1.BuildFormatByDefault = value;
        }
    }


    /// <summary>
    /// Query name
    /// </summary>
    public string QueryName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("QueryName"), this.QueryDataList1.QueryName), this.QueryDataList1.QueryName);
        }
        set
        {
            this.SetValue("QueryName", value);
            this.QueryDataList1.QueryName = value;
        }
    }

    #endregion


    #region "Transformation properties"

    /// <summary>
    /// Transformation name
    /// </summary>
    public string TransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("TransformationName"), this.QueryDataList1.TransformationName), this.QueryDataList1.TransformationName);
        }
        set
        {
            this.SetValue("TransformationName", value);
            this.QueryDataList1.TransformationName = value;
        }
    }


    /// <summary>
    /// Transformation name
    /// </summary>
    public string AlternatingTransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("AlternatingTransformationName"), this.QueryDataList1.AlternatingTransformationName), this.QueryDataList1.AlternatingTransformationName);
        }
        set
        {
            this.SetValue("AlternatingTransformationName", value);
            this.QueryDataList1.AlternatingTransformationName = value;
        }
    }

    #endregion


    #region "Editing mode buttons properties"

    /// <summary>
    /// Show edit / delete buttons
    /// </summary>
    public bool ShowEditDeleteButtons
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("ShowEditDeleteButtons"), this.QueryDataList1.ShowEditDeleteButtons);
        }
        set
        {
            this.SetValue("ShowEditDeleteButtons", value);
            this.QueryDataList1.ShowEditDeleteButtons = value;
        }
    }

    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }

    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == CMS.CMSHelper.ViewModeEnum.Design) || this.HideOnCurrentPage || (!this.IsVisible))
        {
            this.QueryDataList1.StopProcessing = true;
        }
        else
        {
            // Setup the control
            // Document properties
            this.QueryDataList1.CacheItemName = this.CacheItemName;
            this.QueryDataList1.CacheMinutes = this.CacheMinutes;
            this.QueryDataList1.OrderBy = this.OrderBy;
            this.QueryDataList1.SelectTopN = this.SelectTopN;
            this.QueryDataList1.WhereCondition = this.WhereCondition;

            // Pager
            this.QueryDataList1.PagerControl.PagerPosition = this.PagerPosition;
            this.QueryDataList1.EnablePaging = this.EnablePaging;
            this.QueryDataList1.PagerControl.PageSize = this.PageSize;
            this.QueryDataList1.PagerControl.QueryStringKey = this.QueryStringKey;
            this.QueryDataList1.PagerControl.PagingMode = this.PagingMode;
            this.QueryDataList1.PagerControl.ShowFirstLast = this.ShowFirstLast;

            // Public
            this.QueryDataList1.RepeatColumns = this.RepeatColumns;
            this.QueryDataList1.RepeatLayout = this.RepeatLayout;
            this.QueryDataList1.RepeatDirection = this.RepeatDirection;
            this.QueryDataList1.HideControlForZeroRows = this.HideControlForZeroRows;
            this.QueryDataList1.ZeroRowsText = this.ZeroRowsText;

            // Binding
            this.QueryDataList1.DataBindByDefault = this.DataBindByDefault;
            this.QueryDataList1.BuildFormatByDefault = this.BuildFormatByDefault;

            // Transformations
            this.QueryDataList1.AlternatingTransformationName = this.AlternatingTransformationName;
            this.QueryDataList1.TransformationName = this.TransformationName;


            this.QueryDataList1.QueryName = this.QueryName;


            this.QueryDataList1.ShowEditDeleteButtons = this.ShowEditDeleteButtons;
        }
    }
    
    
    public override void ReloadData()
    {
        base.ReloadData();
        this.SetupControl();
        this.QueryDataList1.ReloadData(true);
    }

}
