using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using CMS.PortalControls;
using CMS.GlobalHelper;
using CMS.TreeEngine;
using CMS.Controls;
using CMS.CMSHelper;

public partial class CMSWebParts_Viewers_RandomDocument : CMSAbstractWebPart
{
    #region "Document properties"

    /// <summary>
    /// Class names
    /// </summary>
    public string ClassNames
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Classnames"), this.CMSRepeater1.ClassNames), this.CMSRepeater1.ClassNames);
        }
        set
        {
            this.SetValue("ClassNames", value);
            this.CMSRepeater1.ClassNames = value;
        }
    }

    /// <summary>
    /// Combine with default culture
    /// </summary>
    public bool CombineWithDefaultCulture
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("CombineWithDefaultCulture"), this.CMSRepeater1.CombineWithDefaultCulture);
        }
        set
        {
            this.SetValue("CombineWithDefaultCulture", value);
            this.CMSRepeater1.CombineWithDefaultCulture = value;
        }
    }

    /// <summary>
    /// Select only published
    /// </summary>
    public bool SelectOnlyPublished
    {
        get
        {
            return ValidationHelper.GetBoolean(this.GetValue("SelectOnlyPublished"), this.CMSRepeater1.SelectOnlyPublished);
        }
        set
        {
            this.SetValue("SelectOnlyPublished", value);
            this.CMSRepeater1.SelectOnlyPublished = value;
        }
    }

    /// <summary>
    /// Culture code
    /// </summary>
    public string CultureCode
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("CultureCode"), this.CMSRepeater1.CultureCode), this.CMSRepeater1.CultureCode);
        }
        set
        {
            this.SetValue("CultureCode", value);
            this.CMSRepeater1.CultureCode = value;
        }
    }


    /// <summary>
    /// Maximal relative level
    /// </summary>
    public int MaxRelativeLevel
    {
        get
        {
            return ValidationHelper.GetInteger(this.GetValue("MaxRelativeLevel"), this.CMSRepeater1.MaxRelativeLevel);
        }
        set
        {
            this.SetValue("MaxRelativeLevel", value);
            this.CMSRepeater1.MaxRelativeLevel = value;
        }
    }


    /// <summary>
    /// Nodes path 
    /// </summary>
    public string Path
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("Path"), this.CMSRepeater1.Path), this.CMSRepeater1.Path);
        }
        set
        {
            this.SetValue("Path", value);
            this.CMSRepeater1.Path = value;
        }
    }


    /// <summary>
    /// Site name
    /// </summary>
    public string SiteName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("SiteName"), this.CMSRepeater1.SiteName), this.CMSRepeater1.SiteName);
        }
        set
        {
            this.SetValue("SiteName", value);
            this.CMSRepeater1.SiteName = value;
        }
    }

    /// <summary>
    /// Transformation name
    /// </summary>
    public string TransformationName
    {
        get
        {
            return DataHelper.GetNotEmpty(ValidationHelper.GetString(this.GetValue("TransformationName"), this.CMSRepeater1.TransformationName), this.CMSRepeater1.TransformationName);
        }
        set
        {
            this.SetValue("TransformationName", value);
            this.CMSRepeater1.TransformationName = value;
        }
    }

    /// <summary>
    /// Where condition
    /// </summary>
    public string WhereCondition
    {
        get
        {
            return DataHelper.GetNotEmpty(this.GetValue("WhereCondition"), this.CMSRepeater1.WhereCondition);
        }
        set
        {
            this.SetValue("WhereCondition", value);
            this.CMSRepeater1.WhereCondition = value;
        }
    }

    #endregion


    /// <summary>
    /// Content loaded event handler
    /// </summary>
    public override void OnContentLoaded()
    {
        base.OnContentLoaded();
        SetupControl();
    }


    /// <summary>
    /// Initializes the control properties
    /// </summary>
    protected void SetupControl()
    {
        if ((this.PageManager.ViewMode == ViewModeEnum.Design) || (this.HideOnCurrentPage) || (!this.IsVisible))
        {
            this.CMSRepeater1.StopProcessing = true;
        }
        else
        {
            // Setup the control
            // Document properties
            this.CMSRepeater1.DataBindByDefault = false;
            this.CMSRepeater1.ClassNames = this.ClassNames;
            this.CMSRepeater1.CultureCode = this.CultureCode;
            this.CMSRepeater1.MaxRelativeLevel = this.MaxRelativeLevel;
            this.CMSRepeater1.Path = this.Path;
            this.CMSRepeater1.SiteName = this.SiteName;
            this.CMSRepeater1.SelectOnlyPublished = this.SelectOnlyPublished;
            this.CMSRepeater1.CombineWithDefaultCulture = this.CombineWithDefaultCulture;

            this.CMSRepeater1.TransformationName = this.TransformationName;

            // Get the cultures
            if (this.CacheMinutes == 0)
            {
                LoadAndAplly();
            }
            else
            {
                string useCacheItemName = DataHelper.GetNotEmpty(this.CacheItemName, CMSContext.BaseCacheKey + "|" + Request.Url.ToString() + "|" + this.ClientID);

                // Try to retrieve data from the cache
                if (!CacheHelper.Contains(useCacheItemName))
                {
                    DataSet ds = LoadAndAplly();

                    if (!DataHelper.DataSourceIsEmpty(ds))
                    {
                            CacheHelper.Add(useCacheItemName, ds, null, DateTime.Now.AddMinutes(this.CacheMinutes), System.Web.Caching.Cache.NoSlidingExpiration);
                    }
                }
                else
                {
                    this.CMSRepeater1.DataSource = (DataSet)CacheHelper.GetItem(useCacheItemName);
                }
            }


          
        }
    }

    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    public DataSet LoadAndAplly()
    {
        // Select random Document
        Random rnd = new Random();

        string where = "(SiteName = '" + this.CMSRepeater1.SiteName + "')";
        if (!DataHelper.IsEmpty(this.WhereCondition))
        {
            where += " AND " + this.WhereCondition;
        }

        TreeProvider tree = new TreeProvider(CMSContext.CurrentUser);
        DataSet ds = tree.SelectNodes(this.CMSRepeater1.SiteName, this.CMSRepeater1.Path, this.CMSRepeater1.CultureCode, this.CombineWithDefaultCulture , this.CMSRepeater1.ClassNames, where, null, this.CMSRepeater1.MaxRelativeLevel, this.SelectOnlyPublished);

        DataSet mDs = new DataSet();

        if (!DataHelper.DataSourceIsEmpty(ds))
        {
            rnd.NextDouble();
            int selectedRow = rnd.Next(0, ds.Tables[0].Rows.Count);

            mDs.Tables.Add(ds.Tables[0].Clone());
            mDs.Tables[0].Rows.Add(ds.Tables[0].Rows[selectedRow].ItemArray);
            mDs.AcceptChanges();
            this.CMSRepeater1.DataSource = mDs;
            this.CMSRepeater1.DataBind();
        }
        else
        {
            this.CMSRepeater1.StopProcessing = true;
        }

        return mDs;
    }

    public override void ReloadData()
    {
        base.ReloadData();
        this.SetupControl();
        this.CMSRepeater1.ReloadData(true);
    }
}
